
local songName= GAMESTATE:GetCurrentSong():GetSongDir()

local function iris_mod_internal(str, pn)
	local ps= GAMESTATE:GetPlayerState(pn)
	local pmods= ps:GetPlayerOptionsString('ModsLevel_Song')
	ps:SetPlayerOptions('ModsLevel_Song', pmods .. ', ' .. str)
	--GAMESTATE:ApplyGameCommand('mod,'..str, pn)
end


local function iris_mod(str)
	for i=1,2 do
		iris_mod_internal(str, 'PlayerNumber_P' .. i)
	end
end

------------------------------- Mod inspirations -------------------------------------------
-- Bounce thingy - The bounce animation style from The Detonator from WHY Hates You.
-- Zoom stuff - The things i did in Negator.
--------------------------------------------------------------------------------------------

local function iris_init()
	fgcurcommand = 0;
	wndr_skewx=0.3;
	checked = false;
	
	
	
	--Time for the mods!	
	curmod = 1;
	--{beat,mod,player well not really, since i'm gonna apply it for both players anyway...}
	mods = {

		{3.50,'*99 invert'},
		{3.52,'*99 -100% invert'},
		{3.54,'*99 invert'},
		{3.56,'*99 -100% invert'},
		{3.58,'*99 invert'},
		{3.60,'*99 -100% invert'},
		{3.62,'*99 invert'},
		{3.64,'*99 -100% invert'},
		{3.66,'*99 invert'},
		{3.68,'*99 -100% invert'},
		{3.70,'*99 invert'},
		{3.72,'*99 -100% invert'},
		{3.74,'*99 invert'},
		{3.76,'*99 -100% invert'},
		{3.78,'*99 invert'},
		{3.80,'*99 -100% invert'},
		{3.82,'*99 invert'},
		{3.84,'*99 -100% invert'},
		{3.86,'*99 invert'},
		{3.88,'*99 -100% invert'},
		{3.90,'*99 invert'},
		{3.92,'*99 -100% invert'},
		{3.94,'*99 invert'},
		{3.96,'*99 -100% invert'},
		{3.98,'*99 invert'},
		{4,'*99 0% invert'},
		{4.50,'*99 invert'},
		{4.52,'*99 -100% invert'},
		{4.54,'*99 invert'},
		{4.56,'*99 -100% invert'},
		{4.58,'*99 invert'},
		{4.60,'*99 -100% invert'},
		{4.62,'*99 invert'},
		{4.64,'*99 -100% invert'},
		{4.66,'*99 invert'},
		{4.68,'*99 -100% invert'},
		{4.70,'*99 invert'},
		{4.72,'*99 -100% invert'},
		{4.74,'*99 invert'},
		{4.76,'*99 -100% invert'},
		{4.78,'*99 invert'},
		{4.80,'*99 -100% invert'},
		{4.82,'*99 invert'},
		{4.84,'*99 -100% invert'},
		{4.86,'*99 invert'},
		{4.88,'*99 -100% invert'},
		{4.90,'*99 invert'},
		{4.92,'*99 -100% invert'},
		{4.94,'*99 invert'},
		{4.96,'*99 -100% invert'},
		{4.98,'*99 invert'},
		{5,'*99 0% invert'},

		{10,'*8 300% centered'},
		{17,'*8 0% centered'},

		{20,'*8 flip'},
		{20.5,'*8 0% flip'},

		{21,'*99 drunk, *99 tipsy'},
		{21.1,'*9 0% drunk, *9 0% tipsy'},
		{21.25,'*99 -100% drunk, *99 -100% tipsy'},
		{21.3,'*9 0% drunk, *9 0% tipsy'},
		{21.5,'*99 drunk, *99 tipsy'},
		{21.6,'*9 0% drunk, *9 0% tipsy'},

		{26,'*100000 200% drunk'},
		{26.02,'*100000 -200% drunk'},
		{26.04,'*100000 190% drunk'},
		{26.06,'*100000 -190% drunk'},
		{26.08,'*100000 180% drunk'},
		{26.10,'*100000 -180% drunk'},
		{26.12,'*100000 170% drunk'},
		{26.14,'*100000 -170% drunk'},
		{26.16,'*100000 160% drunk'},
		{26.18,'*100000 -160% drunk'},
		{26.20,'*100000 150% drunk'},
		{26.22,'*100000 -150% drunk'},
		{26.24,'*100000 140% drunk'},
		{26.26,'*100000 -140% drunk'},
		{26.28,'*100000 130% drunk'},
		{26.30,'*100000 -130% drunk'},
		{26.32,'*100000 120% drunk'},
		{26.34,'*100000 -120% drunk'},
		{26.36,'*100000 110% drunk'},
		{26.38,'*100000 -110% drunk'},
		{26.40,'*100000 100% drunk'},
		{26.42,'*100000 -100% drunk'},
		{26.44,'*100000 90% drunk'},
		{26.46,'*100000 -90% drunk'},
		{26.48,'*100000 80% drunk'},
		{26.50,'*100000 -80% drunk'},
		{26.52,'*100000 70% drunk'},
		{26.54,'*100000 -70% drunk'},
		{26.56,'*100000 60% drunk'},
		{26.58,'*100000 -60% drunk'},
		{26.60,'*100000 50% drunk'},
		{26.62,'*100000 -50% drunk'},
		{26.64,'*100000 40% drunk'},
		{26.66,'*100000 -40% drunk'},
		{26.68,'*100000 30% drunk'},
		{26.70,'*100000 -30% drunk'},
		{26.72,'*100000 20% drunk'},
		{26.74,'*100000 -20% drunk'},
		{26.76,'*100000 10% drunk'},
		{26.78,'*100000 -10% drunk'},
		{26.80,'*100000 0% drunk'},

		{27,'*100000 200% drunk'},
		{27.02,'*100000 -200% drunk'},
		{27.04,'*100000 190% drunk'},
		{27.06,'*100000 -190% drunk'},
		{27.08,'*100000 180% drunk'},
		{27.10,'*100000 -180% drunk'},
		{27.12,'*100000 170% drunk'},
		{27.14,'*100000 -170% drunk'},
		{27.16,'*100000 160% drunk'},
		{27.18,'*100000 -160% drunk'},
		{27.20,'*100000 150% drunk'},
		{27.22,'*100000 -150% drunk'},
		{27.24,'*100000 140% drunk'},
		{27.26,'*100000 -140% drunk'},
		{27.28,'*100000 130% drunk'},
		{27.30,'*100000 -130% drunk'},
		{27.32,'*100000 120% drunk'},
		{27.34,'*100000 -120% drunk'},
		{27.36,'*100000 110% drunk'},
		{27.38,'*100000 -110% drunk'},
		{27.40,'*100000 100% drunk'},
		{27.42,'*100000 -100% drunk'},
		{27.44,'*100000 90% drunk'},
		{27.46,'*100000 -90% drunk'},
		{27.48,'*100000 80% drunk'},
		{27.50,'*100000 -80% drunk'},
		{27.52,'*100000 70% drunk'},
		{27.54,'*100000 -70% drunk'},
		{27.56,'*100000 60% drunk'},
		{27.58,'*100000 -60% drunk'},
		{27.60,'*100000 50% drunk'},
		{27.62,'*100000 -50% drunk'},
		{27.64,'*100000 40% drunk'},
		{27.66,'*100000 -40% drunk'},
		{27.68,'*100000 30% drunk'},
		{27.70,'*100000 -30% drunk'},
		{27.72,'*100000 20% drunk'},
		{27.74,'*100000 -20% drunk'},
		{27.76,'*100000 10% drunk'},
		{27.78,'*100000 -10% drunk'},
		{27.80,'*100000 0% drunk'},

		{28,'*8 300% centered'},
		{33,'*8 0% centered'},

		{43,'*8 300% centered, *999 0% centered, *999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{43.02,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{43.04,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{43.06,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{43.08,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{43.10,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{43.12,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{43.14,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse'},
		{43.16,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse'},
		{43.18,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{43.20,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{43.22,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{43.24,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{43.26,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{43.28,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{43.30,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{43.32,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse'},
		{43.34,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse'},
		{43.36,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{43.38,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{43.40,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{43.42,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{43.44,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{43.46,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{43.48,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{43.50,'*8 300% centered, *999 0.03% Flip, *999 0% Split, *999 0% Reverse'},
		{48,'*8 0% centered'},

		{53,'*16 drunk, *99 200% bumpy'},
		{53.1,'*0.8 0% bumpy'},
		{54.5,'*16 -100% drunk, *99 200% bumpy'},
		{54.6,'*0.8 0% bumpy'},
		{56,'*16 drunk, *99 200% bumpy'},
		{56.1,'*0.8 0% bumpy'},
		{57.5,'*16 -100% drunk, *99 200% bumpy'},
		{57.6,'*0.8 0% bumpy'},

		{59,'*8 300% centered'},
		{66,'*8 0% centered'},

		{69,'*99 200% distant'},
		{69.1,'*5 0% distant'},

		{70.5,'*99 200% distant'},
		{70.6,'*5 0% distant'},

		{72,'*99 200% distant'},
		{72.1,'*5 0% distant'},

		{98.50,'*100000 -80% drunk'},
		{98.52,'*100000 70% drunk'},
		{98.54,'*100000 -70% drunk'},
		{98.56,'*100000 60% drunk'},
		{98.58,'*100000 -60% drunk'},
		{98.60,'*100000 50% drunk'},
		{98.62,'*100000 -50% drunk'},
		{98.64,'*100000 40% drunk'},
		{98.66,'*100000 -40% drunk'},
		{98.68,'*100000 30% drunk'},
		{98.70,'*100000 -30% drunk'},
		{98.72,'*100000 20% drunk'},
		{98.74,'*100000 -20% drunk'},
		{98.76,'*100000 10% drunk'},
		{98.78,'*100000 -10% drunk'},
		{98.80,'*100000 0% drunk'},

		{99.50,'*100000 -80% drunk'},
		{99.52,'*100000 70% drunk'},
		{99.54,'*100000 -70% drunk'},
		{99.56,'*100000 60% drunk'},
		{99.58,'*100000 -60% drunk'},
		{99.60,'*100000 50% drunk'},
		{99.62,'*100000 -50% drunk'},
		{99.64,'*100000 40% drunk'},
		{99.66,'*100000 -40% drunk'},
		{99.68,'*100000 30% drunk'},
		{99.70,'*100000 -30% drunk'},
		{99.72,'*100000 20% drunk'},
		{99.74,'*100000 -20% drunk'},
		{99.76,'*100000 10% drunk'},
		{99.78,'*100000 -10% drunk'},
		{99.80,'*100000 0% drunk'},

		{108,'drunk'},
		{124,'*99 9% drunk'},

		{138,'*999 300% centered, *999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{138.02,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{138.04,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{138.06,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{138.08,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{138.10,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{138.12,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{138.14,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{138.16,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{138.18,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{138.20,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{138.22,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{138.24,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{138.26,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{138.28,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{138.30,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{138.32,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{138.34,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{138.36,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{138.38,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{138.40,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{138.42,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{138.44,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{138.46,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{138.48,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{138.50,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{138.52,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{138.54,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{138.56,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{138.58,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{138.60,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{138.62,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{138.64,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{138.66,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{138.68,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{138.70,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{138.72,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{138.74,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{138.76,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{138.78,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{138.80,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{138.82,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{138.84,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{138.86,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{138.88,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{138.90,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{138.92,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{138.94,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{138.96,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{138.98,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{139,'*999 300% centered, *999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{139.02,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{139.04,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{139.06,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{139.08,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{139.10,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{139.12,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{139.14,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{139.16,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{139.18,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{139.20,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{139.22,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{139.24,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{139.26,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{139.28,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{139.30,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{139.32,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{139.34,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{139.36,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{139.38,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{139.40,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{139.42,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{139.44,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{139.46,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{139.48,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{139.50,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{139.52,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{139.54,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{139.56,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{139.58,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{139.60,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{139.62,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{139.64,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{139.66,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{139.68,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{139.70,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{139.72,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{139.74,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{139.76,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{139.78,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{139.80,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{139.82,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{139.84,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{139.86,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{139.88,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{139.90,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{139.92,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{139.94,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{139.96,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{139.98,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{140,'*100000 0% flip, *100000 0% split, *100000 0% reverse, *7.8 200% tiny, *99 drunk, *100000 0% centered'},
		{140.1,'*9 0% drunk, *99 70% stealth, *16 wave, 10% brake'},

		{154,'*99 180% tiny'},
		{154.25,'*99 160% tiny'},
		{154.5,'*99 140% tiny'},
		{154.75,'*99 120% tiny'},
		{155,'*99 100% tiny'},
		{155.25,'*99 80% tiny'},
		{155.5,'*99 60% tiny'},
		{155.75,'*99 40% tiny'},
		{156,'*99 20% tiny, *99 300% drunk'},
		{156.1,'*9 0% drunk'},
		{156.25,'*99 0% tiny'},

		{158,'*99 400% drunk'},
		{158.1,'*9 0% drunk'},

		{160,'*99 400% drunk'},
		{160.1,'*9 0% drunk'},

		{162.5,'*99 400% drunk'},
		{162.6,'*9 0% drunk'},

		{164,'*99 400% drunk'},
		{164.1,'*9 0% drunk'},

		{166.5,'*99 400% drunk'},
		{166.6,'*9 0% drunk'},

		{168.5,'*99 400% drunk'},
		{168.6,'*9 0% drunk'},

		{170,'*99 400% drunk'},
		{170.1,'*9 0% drunk'},

		{171.5,'*99 400% drunk'},
		{171.6,'*9 0% drunk'},

		{172,'*999 300% beat'},
		{174.5,'*999 0% beat'},

		{176,'*999 300% beat'},
		{178.5,'*999 0% beat'},

		{180,'*999 300% beat'},
		{182.5,'*999 0% beat'},

		{188,'*99 -70% tiny, *99 0% stealth'},
		{188.1,'*16 -40% tiny'},
		{188.5,'*99 230% tiny'},
		{188.6,'*16 200% tiny'},

		{189,'*99 -70% tiny'},
		{189.1,'*16 -40% tiny'},
		{189.25,'*99 230% tiny'},
		{189.3,'*16 200% tiny'},
		{189.5,'*99 -70% tiny'},
		{189.6,'*16 -40% tiny'},
		{189.75,'*99 230% tiny'},
		{189.8,'*16 200% tiny'},

		{190.5,'*99 -70% tiny'},
		{190.6,'*16 -40% tiny'},

		{191,'*99 230% tiny'},
		{191.1,'*16 200% tiny'},

		{192,'*99 -70% tiny'},
		{192.1,'*16 -40% tiny'},

		{192.5,'*99 230% tiny'},
		{192.6,'*16 200% tiny'},
		{192.75,'*99 -70% tiny'},
		{192.8,'*16 -40% tiny'},
		{193,'*99 230% tiny'},
		{193.1,'*16 200% tiny'},
		
		{193.5,'*99 -70% tiny'},
		{193.6,'*16 -40% tiny'},

		{194,'*99 230% tiny'},
		{194.1,'*16 200% tiny'},

		{194.5,'*99 -70% tiny'},
		{194.6,'*16 -40% tiny'},

		{195,'*99 230% tiny'},
		{195.1,'*16 0% tiny'},

		{196,'*99 230% tiny, *99 -80% flip'},
		{197,'*99 160% tiny, *99 -60% flip'},
		{198,'*99 120% tiny, *99 -40% flip'},
		{199,'*99 40% tiny, *99 -20% flip'},
		{200,'*1 0% tiny, *1 0% flip'},

		{201,'*100000 100000% drunk'},
		{201.02,'*100000 0% drunk'},
		{201.04,'*100000 100000% drunk'},
		{201.06,'*100000 0% drunk'},
		{201.08,'*100000 100000% drunk'},
		{201.10,'*100000 0% drunk'},
		{201.12,'*100000 100000% drunk'},
		{201.14,'*100000 0% drunk'},
		{201.16,'*100000 100000% drunk'},
		{201.18,'*100000 0% drunk'},
		{201.20,'*100000 100000% drunk'},
		{201.22,'*100000 100000% drunk'},
		{201.24,'*100000 0% drunk'},
		{201.26,'*100000 100000% drunk'},
		{201.28,'*100000 0% drunk'},
		{201.30,'*100000 100000% drunk'},
		{201.32,'*100000 0% drunk'},
		{201.34,'*100000 100000% drunk'},
		{201.36,'*100000 0% drunk'},
		{201.38,'*100000 100000% drunk'},
		{201.40,'*100000 0% drunk'},
		{201.42,'*100000 100000% drunk'},
		{201.44,'*100000 0% drunk'},
		{201.46,'*100000 100000% drunk'},
		{201.48,'*100000 0% drunk'},
		{201.50,'*100000 100000% drunk'},
		{201.52,'*100000 0% drunk'},
		{201.54,'*100000 100000% drunk'},
		{201.56,'*100000 0% drunk'},
		{201.58,'*100000 100000% drunk'},
		{201.60,'*100000 0% drunk'},
		{201.62,'*100000 100000% drunk'},
		{201.64,'*100000 0% drunk'},
		{201.66,'*100000 100000% drunk'},
		{201.68,'*100000 0% drunk'},
		{201.70,'*100000 100000% drunk'},
		{201.72,'*100000 0% drunk'},
		{201.74,'*100000 100000% drunk'},
		{201.76,'*100000 0% drunk'},
		{201.78,'*100000 100000% drunk'},
		{201.80,'*100000 0% drunk'},
		{201.82,'*100000 100000% drunk'},
		{201.84,'*100000 0% drunk'},
		{201.86,'*100000 100000% drunk'},
		{201.88,'*100000 0% drunk'},
		{201.90,'*100000 100000% drunk'},
		{201.92,'*100000 0% drunk'},
		{201.94,'*100000 100000% drunk'},
		{201.96,'*100000 0% drunk'},

		{204,'*0.1 stealth'},
		{219,'*1.8 dark, *99 blind'},

		{226,'*100000 100000% drunk, *99 0% stealth, *99 0% dark, *99 0% blind'},
		{226.02,'*100000 0% drunk'},
		{226.04,'*100000 100000% drunk'},
		{226.06,'*100000 0% drunk'},
		{226.08,'*100000 100000% drunk'},
		{226.10,'*100000 0% drunk'},
		{226.12,'*100000 100000% drunk'},
		{226.14,'*100000 0% drunk'},
		{226.16,'*100000 100000% drunk'},
		{226.18,'*100000 0% drunk'},
		{226.20,'*100000 100000% drunk'},
		{226.22,'*100000 100000% drunk'},
		{226.24,'*100000 0% drunk'},
		{226.26,'*100000 100000% drunk'},
		{226.28,'*100000 0% drunk'},
		{226.30,'*100000 100000% drunk'},
		{226.32,'*100000 0% drunk'},
		{226.34,'*100000 100000% drunk'},
		{226.36,'*100000 0% drunk'},
		{226.38,'*100000 100000% drunk'},
		{226.40,'*100000 0% drunk'},
		{226.42,'*100000 100000% drunk'},
		{226.44,'*100000 0% drunk'},
		{226.46,'*100000 100000% drunk'},
		{226.48,'*100000 0% drunk'},
		{226.50,'*100000 100000% drunk'},
		{226.52,'*100000 0% drunk'},
		{226.54,'*100000 100000% drunk'},
		{226.56,'*100000 0% drunk'},
		{226.58,'*100000 100000% drunk'},
		{226.60,'*100000 0% drunk'},
		{226.62,'*100000 100000% drunk'},
		{226.64,'*100000 0% drunk'},
		{226.66,'*100000 100000% drunk'},
		{226.68,'*100000 0% drunk'},
		{226.70,'*100000 100000% drunk'},
		{226.72,'*100000 0% drunk'},
		{226.74,'*100000 100000% drunk'},
		{226.76,'*100000 0% drunk'},
		{226.78,'*100000 100000% drunk'},
		{226.80,'*100000 0% drunk'},
		{226.82,'*100000 100000% drunk'},
		{226.84,'*100000 0% drunk'},
		{226.86,'*100000 100000% drunk'},
		{226.88,'*100000 0% drunk'},
		{226.90,'*100000 100000% drunk'},
		{226.92,'*100000 0% drunk'},
		{226.94,'*100000 100000% drunk'},
		{226.96,'*100000 0% drunk'},

		-- IT REPEAtS, so i just added seconds to it.

		{216+10,'*8 300% centered'},
		{216+17,'*8 0% centered'},

		{216+20,'*8 flip'},
		{216+20.5,'*8 0% flip'},

		{216+21,'*99 drunk, *99 tipsy'},
		{216+21.1,'*9 0% drunk, *9 0% tipsy'},
		{216+21.25,'*99 -100% drunk, *99 -100% tipsy'},
		{216+21.3,'*9 0% drunk, *9 0% tipsy'},
		{216+21.5,'*99 drunk, *99 tipsy'},
		{216+21.6,'*9 0% drunk, *9 0% tipsy'},

		{216+26,'*100000 200% drunk'},
		{216+26.02,'*100000 -200% drunk'},
		{216+26.04,'*100000 190% drunk'},
		{216+26.06,'*100000 -190% drunk'},
		{216+26.08,'*100000 180% drunk'},
		{216+26.10,'*100000 -180% drunk'},
		{216+26.12,'*100000 170% drunk'},
		{216+26.14,'*100000 -170% drunk'},
		{216+26.16,'*100000 160% drunk'},
		{216+26.18,'*100000 -160% drunk'},
		{216+26.20,'*100000 150% drunk'},
		{216+26.22,'*100000 -150% drunk'},
		{216+26.24,'*100000 140% drunk'},
		{216+26.26,'*100000 -140% drunk'},
		{216+26.28,'*100000 130% drunk'},
		{216+26.30,'*100000 -130% drunk'},
		{216+26.32,'*100000 120% drunk'},
		{216+26.34,'*100000 -120% drunk'},
		{216+26.36,'*100000 110% drunk'},
		{216+26.38,'*100000 -110% drunk'},
		{216+26.40,'*100000 100% drunk'},
		{216+26.42,'*100000 -100% drunk'},
		{216+26.44,'*100000 90% drunk'},
		{216+26.46,'*100000 -90% drunk'},
		{216+26.48,'*100000 80% drunk'},
		{216+26.50,'*100000 -80% drunk'},
		{216+26.52,'*100000 70% drunk'},
		{216+26.54,'*100000 -70% drunk'},
		{216+26.56,'*100000 60% drunk'},
		{216+26.58,'*100000 -60% drunk'},
		{216+26.60,'*100000 50% drunk'},
		{216+26.62,'*100000 -50% drunk'},
		{216+26.64,'*100000 40% drunk'},
		{216+26.66,'*100000 -40% drunk'},
		{216+26.68,'*100000 30% drunk'},
		{216+26.70,'*100000 -30% drunk'},
		{216+26.72,'*100000 20% drunk'},
		{216+26.74,'*100000 -20% drunk'},
		{216+26.76,'*100000 10% drunk'},
		{216+26.78,'*100000 -10% drunk'},
		{216+26.80,'*100000 0% drunk'},

		{216+27,'*100000 200% drunk'},
		{216+27.02,'*100000 -200% drunk'},
		{216+27.04,'*100000 190% drunk'},
		{216+27.06,'*100000 -190% drunk'},
		{216+27.08,'*100000 180% drunk'},
		{216+27.10,'*100000 -180% drunk'},
		{216+27.12,'*100000 170% drunk'},
		{216+27.14,'*100000 -170% drunk'},
		{216+27.16,'*100000 160% drunk'},
		{216+27.18,'*100000 -160% drunk'},
		{216+27.20,'*100000 150% drunk'},
		{216+27.22,'*100000 -150% drunk'},
		{216+27.24,'*100000 140% drunk'},
		{216+27.26,'*100000 -140% drunk'},
		{216+27.28,'*100000 130% drunk'},
		{216+27.30,'*100000 -130% drunk'},
		{216+27.32,'*100000 120% drunk'},
		{216+27.34,'*100000 -120% drunk'},
		{216+27.36,'*100000 110% drunk'},
		{216+27.38,'*100000 -110% drunk'},
		{216+27.40,'*100000 100% drunk'},
		{216+27.42,'*100000 -100% drunk'},
		{216+27.44,'*100000 90% drunk'},
		{216+27.46,'*100000 -90% drunk'},
		{216+27.48,'*100000 80% drunk'},
		{216+27.50,'*100000 -80% drunk'},
		{216+27.52,'*100000 70% drunk'},
		{216+27.54,'*100000 -70% drunk'},
		{216+27.56,'*100000 60% drunk'},
		{216+27.58,'*100000 -60% drunk'},
		{216+27.60,'*100000 50% drunk'},
		{216+27.62,'*100000 -50% drunk'},
		{216+27.64,'*100000 40% drunk'},
		{216+27.66,'*100000 -40% drunk'},
		{216+27.68,'*100000 30% drunk'},
		{216+27.70,'*100000 -30% drunk'},
		{216+27.72,'*100000 20% drunk'},
		{216+27.74,'*100000 -20% drunk'},
		{216+27.76,'*100000 10% drunk'},
		{216+27.78,'*100000 -10% drunk'},
		{216+27.80,'*100000 0% drunk'},

		{216+28,'*8 300% centered'},
		{216+33,'*8 0% centered'},

		{216+43,'*8 300% centered, *999 0% centered, *999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{216+43.02,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+43.04,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+43.06,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+43.08,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+43.10,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+43.12,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{216+43.14,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse'},
		{216+43.16,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse'},
		{216+43.18,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{216+43.20,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+43.22,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+43.24,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+43.26,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+43.28,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+43.30,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{216+43.32,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse'},
		{216+43.34,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse'},
		{216+43.36,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{216+43.38,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+43.40,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+43.42,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+43.44,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+43.46,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+43.48,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{216+43.50,'*999 0.03% Flip, *999 0% Split, *999 0% Reverse'},
		{216+48,'*8 0% centered'},

		{216+53,'*16 drunk, *99 200% bumpy'},
		{216+53.1,'*0.8 0% bumpy'},
		{216+54.5,'*16 -100% drunk, *99 200% bumpy'},
		{216+54.6,'*0.8 0% bumpy'},
		{216+56,'*16 drunk, *99 200% bumpy'},
		{216+56.1,'*0.8 0% bumpy'},
		{216+57.5,'*16 -100% drunk, *99 200% bumpy'},
		{216+57.6,'*0.8 0% bumpy'},

		{216+59,'*8 300% centered'},
		{216+66,'*8 0% centered'},

		{216+69,'*99 200% distant'},
		{216+69.1,'*5 0% distant'},

		{216+70.5,'*99 200% distant'},
		{216+70.6,'*5 0% distant'},

		{216+72,'*99 200% distant'},
		{216+72.1,'*5 0% distant'},

		{216+59,'*8 300% centered'},
		{216+66,'*8 0% centered'},

		{216+98.50,'*100000 -80% drunk'},
		{216+98.52,'*100000 70% drunk'},
		{216+98.54,'*100000 -70% drunk'},
		{216+98.56,'*100000 60% drunk'},
		{216+98.58,'*100000 -60% drunk'},
		{216+98.60,'*100000 50% drunk'},
		{216+98.62,'*100000 -50% drunk'},
		{216+98.64,'*100000 40% drunk'},
		{216+98.66,'*100000 -40% drunk'},
		{216+98.68,'*100000 30% drunk'},
		{216+98.70,'*100000 -30% drunk'},
		{216+98.72,'*100000 20% drunk'},
		{216+98.74,'*100000 -20% drunk'},
		{216+98.76,'*100000 10% drunk'},
		{216+98.78,'*100000 -10% drunk'},
		{216+98.80,'*100000 0% drunk'},

		{216+99.50,'*100000 -80% drunk'},
		{216+99.52,'*100000 70% drunk'},
		{216+99.54,'*100000 -70% drunk'},
		{216+99.56,'*100000 60% drunk'},
		{216+99.58,'*100000 -60% drunk'},
		{216+99.60,'*100000 50% drunk'},
		{216+99.62,'*100000 -50% drunk'},
		{216+99.64,'*100000 40% drunk'},
		{216+99.66,'*100000 -40% drunk'},
		{216+99.68,'*100000 30% drunk'},
		{216+99.70,'*100000 -30% drunk'},
		{216+99.72,'*100000 20% drunk'},
		{216+99.74,'*100000 -20% drunk'},
		{216+99.76,'*100000 10% drunk'},
		{216+99.78,'*100000 -10% drunk'},
		{216+99.80,'*100000 0% drunk'},

		{216+138,'*999 300% centered, *999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{216+138.02,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+138.04,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+138.06,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+138.08,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+138.10,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+138.12,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{216+138.14,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse'},
		{216+138.16,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse'},
		{216+138.18,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{216+138.20,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+138.22,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+138.24,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+138.26,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+138.28,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+138.30,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{216+138.32,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse'},
		{216+138.34,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse'},
		{216+138.36,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{216+138.38,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+138.40,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+138.42,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+138.44,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+138.46,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+138.48,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{216+138.50,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse'},
		{216+138.52,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse'},
		{216+138.54,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{216+138.56,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+138.58,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+138.60,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+138.62,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+138.64,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+138.66,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{216+138.68,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse'},
		{216+138.70,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse'},
		{216+138.72,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+138.74,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+138.76,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+138.78,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+138.80,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+138.82,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{216+138.84,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse'},
		{216+138.86,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse'},
		{216+138.88,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{216+138.90,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+138.92,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+138.94,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+138.96,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+138.98,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+139,'*999 300% centered, *999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{216+139.02,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+139.04,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+139.06,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+139.08,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+139.10,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+139.12,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{216+139.14,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse'},
		{216+139.16,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse'},
		{216+139.18,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{216+139.20,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+139.22,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+139.24,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+139.26,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+139.28,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+139.30,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{216+139.32,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse'},
		{216+139.34,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse'},
		{216+139.36,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{216+139.38,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+139.40,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+139.42,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+139.44,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+139.46,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+139.48,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{216+139.50,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse'},
		{216+139.52,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse'},
		{216+139.54,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{216+139.56,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+139.58,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+139.60,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+139.62,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+139.64,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+139.66,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{216+139.68,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse'},
		{216+139.70,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse'},
		{216+139.72,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+139.74,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+139.76,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+139.78,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+139.80,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+139.82,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse'},
		{216+139.84,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse'},
		{216+139.86,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse'},
		{216+139.88,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse'},
		{216+139.90,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse'},
		{216+139.92,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse'},
		{216+139.94,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{216+139.96,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse'},
		{216+139.98,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse'},
		{216+140,'*100000 0% flip, *100000 0% split, *100000 0% reverse, *99 drunk, *100000 0% centered'},
		{216+140.1,'*9 0% drunk, *99 70% stealth, *16 wave, 10% brake'},

		-- eND
		{418,'*999 300% centered, *999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{418.02,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{418.04,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{418.06,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{418.08,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{418.10,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{418.12,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{418.14,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{418.16,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{418.18,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{418.20,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{418.22,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{418.24,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{418.26,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{418.28,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{418.30,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{418.32,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{418.34,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{418.36,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{418.38,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{418.40,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{418.42,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{418.44,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{418.46,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{418.48,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{418.50,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{418.52,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{418.54,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{418.56,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{418.58,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{418.60,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{418.62,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{418.64,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{418.66,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{418.68,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{418.70,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{418.72,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{418.74,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{418.76,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{418.78,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{418.80,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{418.82,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{418.84,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{418.86,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{418.88,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{418.90,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{418.92,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{418.94,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{418.96,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{418.98,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{419,'*999 300% centered, *999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{419.02,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{419.04,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{419.06,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{419.08,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{419.10,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{419.12,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{419.14,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{419.16,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{419.18,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{419.20,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{419.22,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{419.24,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{419.26,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{419.28,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{419.30,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{419.32,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{419.34,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{419.36,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{419.38,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{419.40,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{419.42,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{419.44,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{419.46,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{419.48,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{419.50,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{419.52,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{419.54,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{419.56,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{419.58,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{419.60,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{419.62,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{419.64,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{419.66,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{419.68,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{419.70,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{419.72,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{419.74,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{419.76,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{419.78,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{419.80,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{419.82,'*999 12.843% Flip, *999 -46.839% Split, *999 48% Reverse, *7.8 200% tiny'},
		{419.84,'*999 0.03% Flip, *999 -2.443% Split, *999 26% Reverse, *7.8 200% tiny'},
		{419.86,'*999 10.599% Flip, *999 43.096% Split, *999 3% Reverse, *7.8 200% tiny'},
		{419.88,'*999 39.604% Flip, *999 68.47% Split, *999 -9% Reverse, *7.8 200% tiny'},
		{419.90,'*999 73.474% Flip, *999 61.806% Split, *999 -6% Reverse, *7.8 200% tiny'},
		{419.92,'*999 96.359% Flip, *999 26.222% Split, *999 12% Reverse, *7.8 200% tiny'},
		{419.94,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse, *7.8 200% tiny'},
		{419.96,'*999 76.496% Flip, *999 -59.363% Split, *999 55% Reverse, *7.8 200% tiny'},
		{419.98,'*999 43.041% Flip, *999 -69.319% Split, *999 60% Reverse, *7.8 200% tiny'},
		{420,'*100000 0% flip, *100000 0% split, *100000 0% reverse, *7.8 200% tiny, *99 drunk, *99 tipsy, *30 -6000% tiny, *1.2 dark'},

		
	}

	iris_driven = 1;
	iris_driven_beat = 193;
	iris_driven_beat_init = 193;

	iris_driven_speed = 0.65;
	iris_driven_modspeed = 1.0;

	iris_drunk = 1;
	iris_drunk_amt = 0;
	iris_bumpy = 1;
	iris_bumpy_amt = 0;

	--SCREAMING GUMBALL / timed message broadcaster
	curmessage = 1;
	--{beat,message,ignoreIfAhead}
	messages = {
		--{182.5,'CytusSpawn'},
		--{193,'CytusBegin'},
		--{257,'CytusEnd'},

		{10,'Vibrate'},
		{11.5,'Stop'},
		{12,'Bounce'},
		{18,'Stop'},
		{26,'ZOOMINPLAYER'},
		{27,'ZOOMINPLAYER'},
		{29,'Bounce'},
		{34,'Stop'},
		{36,'Closeandreapear'},
		{44,'Bounce'},
		{49,'Stop'},
		{60,'Bounce'},
		{65.9,'Stop'},
		{66,'Quickspin'},
		{72,'Moveplayer'},
		{72.5,'Moveplayer'},
		{73,'Moveplayer'},
		{73.5,'Moveplayer'},
		{73.75,'Moveplayer'},
		{74,'Moveplayer'},
		{74.5,'MoveplayerR'},
		{75,'Vibrate'},
		{75.9,'Stop'},
		{76,'Slowmovement'},
		{91.8,'Stop'},
		{92,'ZOOMINPLAYER'},
		{93.5,'ZOOMINPLAYER'},
		{100,'ZOOMINPLAYER'},
		{101.5,'ZOOMINPLAYER'},
		{104,'ZOOMINPLAYERfast'},
		{104.5,'ZOOMINPLAYERfast'},
		{105,'ZOOMINPLAYERfast'},
		{105.5,'ZOOMINPLAYERfast'},
		{106,'ZOOMINPLAYERfast'},
		{106.25,'ZOOMINPLAYERfast'},
		{106.5,'ZOOMINPLAYERfast'},
		{106.75,'ZOOMINPLAYERfast'},
		{108,'Slowmovement'},
		{124,'ZOOMINPLAYER'},
		{125.5,'ZOOMINPLAYER'},
		{132,'ZOOMINPLAYER'},
		{133.5,'ZOOMINPLAYER'},
		{219,'Dissapear'},

		{216+10,'Vibrate'},
		{216+11.5,'Stop'},
		{216+12,'Bounce'},
		{216+18,'Stop'},
		{216+26,'ZOOMINPLAYER'},
		{216+27,'ZOOMINPLAYER'},
		{216+29,'Bounce'},
		{216+34,'Stop'},
		{216+36,'Closeandreapear'},
		{216+44,'Bounce'},
		{216+49,'Stop'},
		{216+60,'Bounce'},
		{216+65.9,'Stop'},
		{216+66,'Quickspin'},
		{216+72,'Moveplayer'},
		{216+72.5,'Moveplayer'},
		{216+73,'Moveplayer'},
		{216+73.5,'Moveplayer'},
		{216+73.75,'Moveplayer'},
		{216+74,'Moveplayer'},
		{216+74.5,'MoveplayerR'},
		{216+75,'Vibrate'},
		{216+75.9,'Stop'},
		{216+76,'Slowmovement'},
		{216+91.8,'Stop'},
		{216+92,'ZOOMINPLAYER'},
		{216+93.5,'ZOOMINPLAYER'},
		{216+100,'ZOOMINPLAYER'},
		{216+101.5,'ZOOMINPLAYER'},
		{216+104,'ZOOMINPLAYERfast'},
		{216+104.5,'ZOOMINPLAYERfast'},
		{216+105,'ZOOMINPLAYERfast'},
		{216+105.5,'ZOOMINPLAYERfast'},
		{216+106,'ZOOMINPLAYERfast'},
		{216+106.25,'ZOOMINPLAYERfast'},
		{216+106.5,'ZOOMINPLAYERfast'},
		{216+106.75,'ZOOMINPLAYERfast'},
		{216+108,'Slowmovement'},
		{216+124,'ZOOMINPLAYER'},
		{216+125.5,'ZOOMINPLAYER'},
		{216+132,'ZOOMINPLAYER'},
		{216+133.5,'ZOOMINPLAYER'},

		{356,'Slowmovement'},
		{372,'ZOOMINPLAYER'},
		{373.5,'ZOOMINPLAYER'},
		{376,'ZOOMINPLAYER'},
		{380,'ZOOMINPLAYER'},
		{381.5,'ZOOMINPLAYER'},
		{384,'ZOOMINPLAYERfast'},
		{384.5,'ZOOMINPLAYERfast'},
		{385,'ZOOMINPLAYERfast'},
		{385.5,'ZOOMINPLAYERfast'},
		{386,'ZOOMINPLAYERfast'},
		{386.25,'ZOOMINPLAYERfast'},
		{386.5,'ZOOMINPLAYERfast'},
		{386.75,'ZOOMINPLAYERfast'},
		{388,'Slowmovement'},

		{404,'ZOOMINPLAYER'},
		{405.5,'ZOOMINPLAYER'},
		{408,'ZOOMINPLAYER'},
		{412,'ZOOMINPLAYER'},
		{413.5,'ZOOMINPLAYER'},
		{416.5,'ZOOMINPLAYERfast'},
		{416.75,'ZOOMINPLAYERfast'},
		{417.25,'ZOOMINPLAYERfast'},
		{417.5,'ZOOMINPLAYERfast'},
		

	}
	
end

local function iris_update()

	if GAMESTATE:GetSongBeat()>=0.1 and not checked then
	
	if SCREENMAN:GetTopScreen():GetChild('PlayerP1') then
		P1 = SCREENMAN:GetTopScreen():GetChild('PlayerP1')
	end
			if P1 then
				P1xpos=P1:GetX();
				P1ypos=P1:GetY();
			end
	if SCREENMAN:GetTopScreen():GetChild('PlayerP2') then
		P2 = SCREENMAN:GetTopScreen():GetChild('PlayerP2')
	end
			if P2 then
				P2xpos=P2:GetX();
				P2ypos=P2:GetY();
			end
		--PE = SCREENMAN:GetTopScreen():GetChild('')
		
		screen = SCREENMAN:GetTopScreen()
		
		if P1 then
			P1:visible(false);
			P1:x(0);
			P1:y(0);
			wndrP1clone1:SetTarget(P1);
			wndrP1clone1:x(P1xpos);
			wndrP1clone1:y(P1ypos);
			
			
			wndrP1clone2:SetTarget(P1);
			wndrP1clone3:SetTarget(P1);
			wndrP1clone4:SetTarget(P1);
			
			wndrP1clone2:visible(false);
			wndrP1clone3:visible(false);
			wndrP1clone4:visible(false);
		end
		
		if P2 then
			P2:visible(false);
			P2:x(0);
			P2:y(0);
			wndrP2clone1:SetTarget(P2);
			wndrP2clone1:x(P2xpos);
			wndrP2clone1:y(P2ypos);
			
			
			wndrP2clone2:SetTarget(P2);
			wndrP2clone3:SetTarget(P2);
			wndrP2clone4:SetTarget(P2);
			
			wndrP2clone2:visible(false);
			wndrP2clone3:visible(false);
			wndrP2clone4:visible(false);
		end
		checked = true;
		
	end
	
	local beat = GAMESTATE:GetSongBeat()

	-- Collect all the mods that will be applied in this frame into one string.
	-- Mod tweening doesn't work correctly if the mods are in seperate commands.
	local mods_this_frame= {}
	local function add_mod(mod_str)
		mods_this_frame[#mods_this_frame+1]= mod_str
	end
	local function execute_mods()
		if #mods_this_frame <= 0 then return end
		local total_mod_str= ""
		for i, ms in ipairs(mods_this_frame) do
			if #total_mod_str > 0 then
				total_mod_str= total_mod_str .. ", "
			end
			total_mod_str= total_mod_str .. ms
		end
		iris_mod(total_mod_str)
	end
	
	--[[
	
	if beat>257 and fgcurcommand == 3 then
		set_player_speed(PLAYER_1, iris_speedmodP1)
		set_player_speed(PLAYER_2, iris_speedmodP2)
		add_mod('*1000 no reverse')
		add_mod('*1000 no centered')
		add_mod('*1000 no dark')
		fgcurcommand = fgcurcommand+1
	end --]]
	
	while curmod<= #mods and GAMESTATE:GetSongBeat()>=mods[curmod][1] do
		add_mod(mods[curmod][2])
		curmod = curmod+1
	end

	execute_mods()
	
	--SCREAMING GUMBALL
	while curmessage<= #messages and GAMESTATE:GetSongBeat()>=messages[curmessage][1] do
		if messages[curmessage][3] and GAMESTATE:GetSongBeat()>=messages[curmessage][1]+5 then
			curmessage = curmessage+1;
		else
			MESSAGEMAN:Broadcast(messages[curmessage][2])
			curmessage = curmessage+1;
		end
	end
end

return Def.ActorFrame{
	OnCommand= function(self)
							 iris_init()
							 self:SetUpdateFunction(iris_update)
						 end,
	Def.Quad{
		Name= "I may be sleeping, but I preserve the world.",
		InitCommand= cmd(visible,false),
		OnCommand= cmd(sleep,1000000000),
	},
	Def.Quad{
		OnCommand= cmd(diffuse,0,0,0,1;diffusealpha,0;zoomto,6,SCREEN_HEIGHT;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y),
		CytusSpawnMessageCommand= cmd(linear,1;diffusealpha,1),
		CytusEndMessageCommand= cmd(linear,1;diffusealpha,0),

		BounceMessageCommand= function(self)
			P1:bounce();
            P1:effectperiod(1)
            P1:effectclock('bgm');
            P1:effectmagnitude(0,-450,0);
            P2:bounce();
            P2:effectperiod(1)
            P2:effectclock('bgm');
            P2:effectmagnitude(0,-450,0);
        end,

        StopMessageCommand= function(self)
			P1:stopeffect();
            P2:stopeffect();
        end,

        VibrateMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):vibrate();
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectmagnitude(20,20,20);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):vibrate();
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectmagnitude(20,20,20);
		end,

		ZOOMINPLAYERMessageCommand= function(self)
			P1:zoom(2.5)
			P1:zoomz(2.5)
			P1:rotationz(math.random(-120,120));
			P1:rotationx(math.random(-120,120));
			P1:rotationy(math.random(-120,120));
            P1:decelerate(0.25)
            P1:zoom(1)
            P1:zoomz(1)
            P1:rotationz(0)
			P1:rotationx(0)
			P1:rotationy(0)
			P1:x(0)
			P1:y(0)
			P1:z(0)
            -- Player two because yes
            P2:zoom(1.5)
            P2:zoomz(2.5)
            P2:rotationz(math.random(-120,120));
			P2:rotationx(math.random(-120,120));
			P2:rotationy(math.random(-120,120));
            P2:decelerate(0.2)
            P2:zoom(1)
            P2:zoomz(1)
            P2:rotationz(0)
			P2:rotationx(0)
			P2:rotationy(0)
			P2:x(0)
			P2:y(0)
			P2:z(0)
        end,

        ZOOMINPLAYERfastMessageCommand= function(self)
			P1:zoom(2.5)
			P1:rotationz(math.random(-120,120));
			P1:rotationx(math.random(-120,120));
			P1:rotationy(math.random(-120,120));
            P1:decelerate(0.1)
            P1:zoom(1)
            P1:rotationz(0)
			P1:rotationx(0)
			P1:rotationy(0)
			P1:x(0)
			P1:y(0)
			P1:z(0)
            -- Player two because yes
            P2:zoom(1.5)
            P2:rotationz(math.random(-120,120));
			P2:rotationx(math.random(-120,120));
			P2:rotationy(math.random(-120,120));
            P2:decelerate(0.1)
            P2:zoom(1)
            P2:rotationz(0)
			P2:rotationx(0)
			P2:rotationy(0)
			P2:x(0)
			P2:y(0)
			P2:z(0)
        end,

        MoveplayerMessageCommand= function(self)
            P1:decelerate(0.1)
			P1:x(math.random(-120,120));
			P1:y(math.random(-120,120));
            -- Player two because yes
			P2:decelerate(0.1)
			P2:x(math.random(-120,120));
			P2:y(math.random(-120,120));
        end,

        MoveplayerRMessageCommand= function(self)
            P1:decelerate(0.1)
			P1:x(0)
			P1:y(0)
            -- Player two because yes
			P2:decelerate(0.1)
			P2:x(0)
			P2:y(0)
        end,

        SlowmovementMessageCommand= function(self)
        	P1:smooth(2.55)
        	P1:x(30)
        	P1:rotationz(30)
        	P1:smooth(2.55)
        	P1:x(-30)
        	P1:rotationz(-30)
        	--
        	P2:smooth(2.55)
        	P2:x(30)
        	P2:rotationz(-30)
        	P2:smooth(2.55)
        	P2:x(-30)
        	P2:rotationz(30)
        end,

        QuickspinMessageCommand= function(self)
        	P1:rotationz(46800)
        	P1:decelerate(0.25)
        	P1:rotationz(0)
        	--
        	P2:rotationz(46800)
        	P2:decelerate(0.25)
        	P2:rotationz(0)
        end,

        CloseandreapearMessageCommand= function(self)
        	P1:decelerate(0.11)
        	P1:zoomy(0)
        	P1:zoomx(0)
        	P1:decelerate(0.05)
        	P1:zoomy(2)
        	P1:zoomx(5)
        	P1:decelerate(0.11)
        	P1:zoomy(1)
        	P1:zoomx(1)
        	--
        	P2:decelerate(0.11)
        	P2:zoomy(0)
        	P2:zoomx(0)
        	P2:decelerate(0.05)
        	P2:zoomy(2)
        	P2:zoomx(5)
        	P2:decelerate(0.11)
        	P2:zoomy(1)
        	P2:zoomx(1)
        end,

        DissapearMessageCommand= function(self)
        	P1:decelerate(0.52)
        	P1:rotationz(20)
        	P1:sleep(1.71)
        	P1:rotationz(0)
        	--
        	P2:decelerate(0.52)
        	P2:rotationz(20)
        	P2:sleep(1.71)
        	P2:rotationz(0)
        end,

		
	},	
	--------------------------------------------------------
	--------------------------------------------------------
	--------------------------------------------------------
	-------------HERE LIES THE ACTOR PROXIES----------------
	--------------------------------------------------------
	--------------------------------------------------------
	--------------------------------------------------------
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone1=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone2=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone3=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone4=self;
			
		end;
	};
	
	
	------
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone1=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone2=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone3=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone4=self;
			
		end;
	};
	
}