
local songName= GAMESTATE:GetCurrentSong():GetSongDir()

local function iris_mod_internal(str, pn)
	local ps= GAMESTATE:GetPlayerState(pn)
	local pmods= ps:GetPlayerOptionsString('ModsLevel_Song')
	ps:SetPlayerOptions('ModsLevel_Song', pmods .. ', ' .. str)
	--GAMESTATE:ApplyGameCommand('mod,'..str, pn)
end


local function iris_mod(str)
	for i=1,2 do
		iris_mod_internal(str, 'PlayerNumber_P' .. i)
	end
end



local function iris_init()
	fgcurcommand = 0;
	wndr_skewx=0.3;
	checked = false;
	
	
	
	--lua course :D	/ timed mod management	
	curmod = 1;
	--{beat,mod,player}
	mods = {

		{0.1,'*0.1 400% tipsy, *0.03 dark, *0.1 300% drunk'},
		{48,'*99 1.7x, *0.9 0% drunk, *0.9 0% tipsy, *99 sudden, *0.2 0% dark, *99 50% flip, *16 90% brake, *99 blind'},
		{90,'*1.2 2.7x, *1.1 0% brake, *1.1 0% sudden, *99 0% blind, *0.7 0% flip'},

		-- Mix with tornado and bumpy-
		{96,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{96.1,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{97.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{97.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{96.75,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{96.8,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{99.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{99.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},

		{4+96,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{4+96.1,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{4+97.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{4+97.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{4+96.75,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{4+96.8,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{4+99.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{4+99.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},

		{8+96,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{8+96.1,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{8+97.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{8+97.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{8+96.75,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{8+96.8,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{8+99.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{8+99.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},

		{12+96,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{12+96.1,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{12+97.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{12+97.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{12+96.75,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{12+96.8,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{12+99.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{12+99.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},

		{16+96,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{16+96.1,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{16+97.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{16+97.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{16+96.75,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{16+96.8,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{16+99.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{16+99.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},

		{20+96,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{20+96.1,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{20+97.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{20+97.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{20+96.75,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{20+96.8,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{20+99.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{20+99.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},

		{24+96,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{24+96.1,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{24+97.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{24+97.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{24+96.75,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{24+96.8,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{24+99.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{24+99.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},

		{28+96,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{28+96.1,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{28+97.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{28+97.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{28+96.75,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{28+96.8,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},
		{28+99.5,'*99 -50% tornado, *99 70% bumpy, *99 distant'},
		{28+99.6,'*0.7 0% tornado, *0.7 0% bumpy, *1.4 overhead'},

		{128,'*99 -50% tornado, *99 70% bumpy, *99 stealth'},
		{128.1,'*0.4 0% tornado, *0.7 0% bumpy, *1.4 0% stealth'},

		{132,'*99 -50% tornado, *99 70% bumpy, *99 stealth'},
		{132.1,'*0.4 0% tornado, *0.7 0% bumpy, *1.4 0% stealth'},

		{144,'*99 -50% tornado, *99 70% bumpy, *99 stealth'},
		{144.1,'*0.4 0% tornado, *0.7 0% bumpy, *1.4 0% stealth'},

		{148,'*99 -50% tornado, *99 70% bumpy, *99 stealth'},
		{148.1,'*0.4 0% tornado, *0.7 0% bumpy, *1.4 0% stealth'},

		{152,'*99 -50% tornado, *99 70% bumpy, *99 stealth'},
		{152.1,'*0.4 0% tornado, *0.7 0% bumpy, *1.4 0% stealth'},

		--Drum Section
		{160,'*99 180% bumpy'},
		{160.1,'*9 0% bumpy'},
		{161,'*99 180% bumpy'},
		{161.1,'*9 0% bumpy'},
		{161.5,'*99 180% bumpy'},
		{161.6,'*9 0% bumpy'},
		{162.5,'*99 180% bumpy'},
		{162.6,'*9 0% bumpy'},
		{163.5,'*99 180% bumpy'},
		{163.6,'*9 0% bumpy'},

		{4+160,'*99 180% bumpy'},
		{4+160.1,'*9 0% bumpy'},
		{4+161,'*99 180% bumpy'},
		{4+161.1,'*9 0% bumpy'},
		{4+161.5,'*99 180% bumpy'},
		{4+161.6,'*9 0% bumpy'},
		{4+162.5,'*99 180% bumpy'},
		{4+162.6,'*9 0% bumpy'},
		{4+163.5,'*99 180% bumpy'},
		{4+163.6,'*9 0% bumpy'},

		{8+160,'*99 180% bumpy'},
		{8+160.1,'*9 0% bumpy'},
		{8+161,'*99 180% bumpy'},
		{8+161.1,'*9 0% bumpy'},
		{8+161.5,'*99 180% bumpy'},
		{8+161.6,'*9 0% bumpy'},
		{8+162.5,'*99 180% bumpy'},
		{8+162.6,'*9 0% bumpy'},
		{8+163.5,'*99 180% bumpy'},
		{8+163.6,'*9 0% bumpy'},

		{12+160,'*99 180% bumpy'},
		{12+160.1,'*9 0% bumpy'},
		{12+161,'*99 180% bumpy'},
		{12+161.1,'*9 0% bumpy'},
		{12+161.5,'*99 180% bumpy'},
		{12+161.6,'*9 0% bumpy'},
		{12+162.5,'*99 180% bumpy'},
		{12+162.6,'*9 0% bumpy'},
		{12+163.5,'*99 180% bumpy'},
		{12+163.6,'*9 0% bumpy'},

		{16+160,'*99 180% bumpy'},
		{16+160.1,'*9 0% bumpy'},
		{16+161,'*99 180% bumpy'},
		{16+161.1,'*9 0% bumpy'},
		{16+161.5,'*99 180% bumpy'},
		{16+161.6,'*9 0% bumpy'},
		{16+162.5,'*99 180% bumpy'},
		{16+162.6,'*9 0% bumpy'},
		{16+163.5,'*99 180% bumpy'},
		{16+163.6,'*9 0% bumpy'},

		{20+160,'*99 180% bumpy'},
		{20+160.1,'*9 0% bumpy'},
		{20+161,'*99 180% bumpy'},
		{20+161.1,'*9 0% bumpy'},
		{20+161.5,'*99 180% bumpy'},
		{20+161.6,'*9 0% bumpy'},
		{20+162.5,'*99 180% bumpy'},
		{20+162.6,'*9 0% bumpy'},
		{20+163.5,'*99 180% bumpy'},
		{20+163.6,'*9 0% bumpy'},

		{24+160,'*99 180% bumpy'},
		{24+160.1,'*9 0% bumpy'},
		{24+161,'*99 180% bumpy'},
		{24+161.1,'*9 0% bumpy'},
		{24+161.5,'*99 180% bumpy'},
		{24+161.6,'*9 0% bumpy'},
		{24+162.5,'*99 180% bumpy'},
		{24+162.6,'*9 0% bumpy'},
		{24+163.5,'*99 180% bumpy'},
		{24+163.6,'*9 0% bumpy'},

		{28+160,'*99 180% bumpy'},
		{28+160.1,'*9 0% bumpy'},
		{28+161,'*99 180% bumpy'},
		{28+161.1,'*9 0% bumpy'},
		{28+161.5,'*99 180% bumpy'},
		{28+161.6,'*9 0% bumpy'},
		{28+162.5,'*99 180% bumpy'},
		{28+162.6,'*9 0% bumpy'},
		{28+163.5,'*99 180% bumpy'},
		{28+163.6,'*9 0% bumpy'},

		{317.5,'*99 3.5x, 60% brake, 60% sudden, 20% hiddenoffset'},

		{400,'*0.01 distant, *0.09 0x, *0.2 130% bumpy, *99 stealth, *99 dark, *99 blind'},
		{400.1,'*0.3 75% stealth, *0.1 10000x, *1.5 3000% tornado'},

	}

	iris_driven = 1;
	iris_driven_beat = 193;
	iris_driven_beat_init = 193;

	iris_driven_speed = 0.65;
	iris_driven_modspeed = 1.0;

	iris_drunk = 1;
	iris_drunk_amt = 0;
	iris_bumpy = 1;
	iris_bumpy_amt = 0;

	--SCREAMING GUMBALL / timed message broadcaster
	curmessage = 1;
	--{beat,message,ignoreIfAhead}
	messages = {
		--{182.5,'CytusSpawn'},
		--{193,'CytusBegin'},
		--{257,'CytusEnd'},

		{51,'ClonesSet'},
		{52,'Displayallclones'},
		{90,'Retrieveallclones'},
		{96,'Removeclones'},
		{194,'Slightleft'},
		{198,'Slightright'},
		{202,'Slightleft'},
		{206,'Slightright'},
		{210,'Slightleft'},
		{214,'Slightright'},
		{218,'Slightleft'},
		{222,'Slightright'},
		{226,'Slightleft'},
		{230,'Slightright'},
		{234,'Slightleft'},
		{238,'Slightright'},
		{242,'Slightleft'},
		{246,'Slightright'},
		{250,'Slightleft'},
		{254,'SlightRestore'},
		--
		{318,'Setoneclone'},
		{318.1,'Moveonlyclone'},
		{322,'Moveonlycloneup'},
		{326,'Moveonlyclonedown'},
		{330,'Moveonlycloneup'},
		{334,'Moveonlyclonedown'},
		{338,'Moveonlycloneup'},
		{342,'Moveonlyclonedown'},
		{346,'Moveonlycloneup'},
		{350,'Moveonlyclonedown'},
		{354,'Moveonlycloneup'},
		{358,'Moveonlyclonedown'},
		{362,'Moveonlycloneup'},
		{366,'Moveonlyclonedown'},
		{370,'Moveonlycloneup'},
		{374,'Moveonlyclonedown'},
		{378,'Moveonlycloneup'},
		{382,'Moveonlyclonedown'},
		{386,'Moveonlycloneup'},
		{390,'Moveonlyclonedown'},
		{394,'Moveonlycloneup'},
		{398,'MoveonlycloneRestore'},
		--End
		{400,'ClonesSet'},
		{400.1,'Displayallclonesslow'},


	}
	
end

local function iris_update()

	if GAMESTATE:GetSongBeat()>=0.1 and not checked then
	
	if SCREENMAN:GetTopScreen():GetChild('PlayerP1') then
		P1 = SCREENMAN:GetTopScreen():GetChild('PlayerP1')
	end
			if P1 then
				P1xpos=P1:GetX();
				P1ypos=P1:GetY();
			end
	if SCREENMAN:GetTopScreen():GetChild('PlayerP2') then
		P2 = SCREENMAN:GetTopScreen():GetChild('PlayerP2')
	end
			if P2 then
				P2xpos=P2:GetX();
				P2ypos=P2:GetY();
			end
		--PE = SCREENMAN:GetTopScreen():GetChild('')
		
		screen = SCREENMAN:GetTopScreen()
		
		if P1 then
			P1:visible(false);
			P1:x(0);
			P1:y(0);
			wndrP1clone1:SetTarget(P1);
			wndrP1clone1:x(P1xpos);
			wndrP1clone1:y(P1ypos);
			
			
			wndrP1clone2:SetTarget(P1);
			wndrP1clone3:SetTarget(P1);
			wndrP1clone4:SetTarget(P1);
			wndrP1clone5:SetTarget(P1);
			wndrP1clone6:SetTarget(P1);
			wndrP1clone7:SetTarget(P1);
			wndrP1clone8:SetTarget(P1);
			wndrP1clone9:SetTarget(P1);
			wndrP1clone10:SetTarget(P1);
			wndrP1clone11:SetTarget(P1);
			wndrP1clone12:SetTarget(P1);
			wndrP1clone13:SetTarget(P1);
			
			wndrP1clone2:visible(false);
			wndrP1clone3:visible(false);
			wndrP1clone4:visible(false);
			wndrP1clone5:visible(false);
			wndrP1clone6:visible(false);
			wndrP1clone7:visible(false);
			wndrP1clone8:visible(false);
			wndrP1clone9:visible(false);
			wndrP1clone10:visible(false);
			wndrP1clone11:visible(false);
			wndrP1clone12:visible(false);
			wndrP1clone13:visible(false);
		end
		
		if P2 then
			P2:visible(false);
			P2:x(0);
			P2:y(0);
			wndrP2clone1:SetTarget(P2);
			wndrP2clone1:x(P2xpos);
			wndrP2clone1:y(P2ypos);
			
			
			wndrP2clone2:SetTarget(P2);
			wndrP2clone3:SetTarget(P2);
			wndrP2clone4:SetTarget(P2);
			wndrP2clone5:SetTarget(P2);
			wndrP2clone6:SetTarget(P2);
			wndrP2clone7:SetTarget(P2);
			wndrP2clone8:SetTarget(P2);
			wndrP2clone9:SetTarget(P2);
			wndrP2clone10:SetTarget(P2);
			wndrP2clone11:SetTarget(P2);
			wndrP2clone12:SetTarget(P2);
			
			wndrP2clone2:visible(false);
			wndrP2clone3:visible(false);
			wndrP2clone4:visible(false);
			wndrP2clone5:visible(false);
			wndrP2clone6:visible(false);
			wndrP2clone7:visible(false);
			wndrP2clone8:visible(false);
			wndrP2clone9:visible(false);
			wndrP2clone10:visible(false);
			wndrP2clone11:visible(false);
			wndrP2clone12:visible(false);
		end
		checked = true;
		
	end
	
	local beat = GAMESTATE:GetSongBeat()

	-- Collect all the mods that will be applied in this frame into one string.
	-- Mod tweening doesn't work correctly if the mods are in seperate commands.
	local mods_this_frame= {}
	local function add_mod(mod_str)
		mods_this_frame[#mods_this_frame+1]= mod_str
	end
	local function execute_mods()
		if #mods_this_frame <= 0 then return end
		local total_mod_str= ""
		for i, ms in ipairs(mods_this_frame) do
			if #total_mod_str > 0 then
				total_mod_str= total_mod_str .. ", "
			end
			total_mod_str= total_mod_str .. ms
		end
		iris_mod(total_mod_str)
	end
	
	--[[
	
	if beat>257 and fgcurcommand == 3 then
		set_player_speed(PLAYER_1, iris_speedmodP1)
		set_player_speed(PLAYER_2, iris_speedmodP2)
		add_mod('*1000 no reverse')
		add_mod('*1000 no centered')
		add_mod('*1000 no dark')
		fgcurcommand = fgcurcommand+1
	end --]]
	
	while curmod<= #mods and GAMESTATE:GetSongBeat()>=mods[curmod][1] do
		add_mod(mods[curmod][2])
		curmod = curmod+1
	end

	execute_mods()
	
	--SCREAMING GUMBALL
	while curmessage<= #messages and GAMESTATE:GetSongBeat()>=messages[curmessage][1] do
		if messages[curmessage][3] and GAMESTATE:GetSongBeat()>=messages[curmessage][1]+5 then
			curmessage = curmessage+1;
		else
			MESSAGEMAN:Broadcast(messages[curmessage][2])
			curmessage = curmessage+1;
		end
	end
end

return Def.ActorFrame{
	OnCommand= function(self)
							 iris_init()
							 self:SetUpdateFunction(iris_update)
						 end,
	Def.Quad{
		Name= "I may be sleeping, but I preserve the world.",
		InitCommand= cmd(visible,false),
		OnCommand= cmd(sleep,100000000),
	},
	Def.Quad{
		OnCommand= cmd(diffuse,0,0,0,1;diffusealpha,0;zoomto,6,SCREEN_HEIGHT;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y),
		CytusSpawnMessageCommand= cmd(linear,1;diffusealpha,1),
		CytusEndMessageCommand= cmd(linear,1;diffusealpha,0),
		
		DisplayallclonesMessageCommand= function(self)
			if P1 then
			wndrP1clone2:smooth(3.7)
			wndrP1clone2:rotationz(30)
			--
			wndrP1clone3:smooth(3.7)
			wndrP1clone3:rotationz(60)
			--
			wndrP1clone4:smooth(3.7)
			wndrP1clone4:rotationz(90)
			--
			wndrP1clone5:smooth(3.7)
			wndrP1clone5:rotationz(120)
			--
			wndrP1clone6:smooth(3.7)
			wndrP1clone6:rotationz(150)
			--
			wndrP1clone7:smooth(3.7)
			wndrP1clone7:rotationz(180)
			--
			wndrP1clone8:smooth(3.7)
			wndrP1clone8:rotationz(210)
			--
			wndrP1clone9:smooth(3.7)
			wndrP1clone9:rotationz(240)
			--
			wndrP1clone10:smooth(3.7)
			wndrP1clone10:rotationz(270)
			--
			wndrP1clone11:smooth(3.7)
			wndrP1clone11:rotationz(300)
			--
			wndrP1clone12:smooth(3.7)
			wndrP1clone12:rotationz(300)
			--
			wndrP1clone13:smooth(3.7)
			wndrP1clone13:rotationz(330)
			end
			
			if P2 then
			wndrP2clone2:smooth(3.7)
			wndrP2clone2:rotationz(30)
			--
			wndrP2clone3:smooth(3.7)
			wndrP2clone3:rotationz(60)
			--
			wndrP2clone4:smooth(3.7)
			wndrP2clone4:rotationz(90)
			--
			wndrP2clone5:smooth(3.7)
			wndrP2clone5:rotationz(120)
			--
			wndrP2clone6:smooth(3.7)
			wndrP2clone6:rotationz(150)
			--
			wndrP2clone7:smooth(3.7)
			wndrP2clone7:rotationz(180)
			--
			wndrP2clone8:smooth(3.7)
			wndrP2clone8:rotationz(210)
			--
			wndrP2clone9:smooth(3.7)
			wndrP2clone9:rotationz(240)
			--
			wndrP2clone10:smooth(3.7)
			wndrP2clone10:rotationz(270)
			--
			wndrP2clone11:smooth(3.7)
			wndrP2clone11:rotationz(300)
			--
			wndrP2clone12:smooth(3.7)
			wndrP2clone12:rotationz(300)
			--
			wndrP2clone13:smooth(3.7)
			wndrP2clone13:rotationz(330)
			end
		end,

		DisplayallclonesslowMessageCommand= function(self)
			if P1 then
			wndrP1clone2:smooth(25)
			wndrP1clone2:rotationz(1602+30)
			--
			wndrP1clone3:smooth(25)
			wndrP1clone3:rotationz(1602+60)
			--
			wndrP1clone4:smooth(25)
			wndrP1clone4:rotationz(1602+90)
			--
			wndrP1clone5:smooth(25)
			wndrP1clone5:rotationz(1602+120)
			--
			wndrP1clone6:smooth(25)
			wndrP1clone6:rotationz(1602+150)
			--
			wndrP1clone7:smooth(25)
			wndrP1clone7:rotationz(1602+180)
			--
			wndrP1clone8:smooth(25)
			wndrP1clone8:rotationz(1602+210)
			--
			wndrP1clone9:smooth(25)
			wndrP1clone9:rotationz(1602+240)
			--
			wndrP1clone10:smooth(25)
			wndrP1clone10:rotationz(1602+270)
			--
			wndrP1clone11:smooth(25)
			wndrP1clone11:rotationz(1602+300)
			--
			wndrP1clone12:smooth(25)
			wndrP1clone12:rotationz(1602+300)
			--
			wndrP1clone13:smooth(25)
			wndrP1clone13:rotationz(1602+330)
			end
			
			if P2 then
			wndrP2clone2:smooth(25)
			wndrP2clone2:rotationz(1602+30)
			--
			wndrP2clone3:smooth(25)
			wndrP2clone3:rotationz(1602+60)
			--
			wndrP2clone4:smooth(25)
			wndrP2clone4:rotationz(1602+90)
			--
			wndrP2clone5:smooth(25)
			wndrP2clone5:rotationz(1602+120)
			--
			wndrP2clone6:smooth(25)
			wndrP2clone6:rotationz(1602+150)
			--
			wndrP2clone7:smooth(25)
			wndrP2clone7:rotationz(1602+180)
			--
			wndrP2clone8:smooth(25)
			wndrP2clone8:rotationz(1602+210)
			--
			wndrP2clone9:smooth(25)
			wndrP2clone9:rotationz(1602+240)
			--
			wndrP2clone10:smooth(25)
			wndrP2clone10:rotationz(1602+270)
			--
			wndrP2clone11:smooth(25)
			wndrP2clone11:rotationz(1602+300)
			--
			wndrP2clone12:smooth(25)
			wndrP2clone12:rotationz(1602+300)
			--
			wndrP2clone13:smooth(25)
			wndrP2clone13:rotationz(1602+330)
			end
		end,

		RetrieveallclonesMessageCommand= function(self)
			if P1 then
			wndrP1clone2:smooth(3.7)
			wndrP1clone2:rotationz(0)
			--
			wndrP1clone3:smooth(3.7)
			wndrP1clone3:rotationz(0)
			--
			wndrP1clone4:smooth(3.7)
			wndrP1clone4:rotationz(0)
			--
			wndrP1clone5:smooth(3.7)
			wndrP1clone5:rotationz(0)
			--
			wndrP1clone6:smooth(3.7)
			wndrP1clone6:rotationz(0)
			--
			wndrP1clone7:smooth(3.7)
			wndrP1clone7:rotationz(0)
			--
			wndrP1clone8:smooth(3.7)
			wndrP1clone8:rotationz(0)
			--
			wndrP1clone9:smooth(3.7)
			wndrP1clone9:rotationz(0)
			--
			wndrP1clone10:smooth(3.7)
			wndrP1clone10:rotationz(0)
			--
			wndrP1clone11:smooth(3.7)
			wndrP1clone11:rotationz(0)
			--
			wndrP1clone12:smooth(3.7)
			wndrP1clone12:rotationz(0)
			--
			wndrP1clone13:smooth(3.7)
			wndrP1clone13:rotationz(0)
			end
			
			if P2 then
			wndrP2clone2:smooth(3.7)
			wndrP2clone2:rotationz(0)
			--
			wndrP2clone3:smooth(3.7)
			wndrP2clone3:rotationz(0)
			--
			wndrP2clone4:smooth(3.7)
			wndrP2clone4:rotationz(0)
			--
			wndrP2clone5:smooth(3.7)
			wndrP2clone5:rotationz(0)
			--
			wndrP2clone6:smooth(3.7)
			wndrP2clone6:rotationz(0)
			--
			wndrP2clone7:smooth(3.7)
			wndrP2clone7:rotationz(0)
			--
			wndrP2clone8:smooth(3.7)
			wndrP2clone8:rotationz(0)
			--
			wndrP2clone9:smooth(3.7)
			wndrP2clone9:rotationz(0)
			--
			wndrP2clone10:smooth(3.7)
			wndrP2clone10:rotationz(0)
			--
			wndrP2clone11:smooth(3.7)
			wndrP2clone11:rotationz(0)
			--
			wndrP2clone12:smooth(3.7)
			wndrP2clone12:rotationz(0)
			--
			wndrP2clone13:smooth(3.7)
			wndrP2clone13:rotationz(0)
			end
		end,

		SlightleftMessageCommand= function(self)
			if P1 then
			P1:spring(0.3)
			P1:rotationz(30)
			end
			
			if P2 then
			P2:spring(0.3)
			P2:rotationz(-30)
			end
		end,

		SlightrightMessageCommand= function(self)
			if P1 then
			P1:spring(0.3)
			P1:rotationz(-30)
			end
			
			if P2 then
			P2:spring(0.3)
			P2:rotationz(30)
			end
		end,

		SlightRestoreMessageCommand= function(self)
			if P1 then
			P1:smooth(1.4)
			P1:rotationz(0)
			end
			
			if P2 then
			P2:smooth(1.4)
			P2:rotationz(0)
			end
		end,

		MoveonlycloneMessageCommand= function(self)
			if P1 then
			wndrP1clone2:smooth(1.7)
			wndrP1clone2:rotationz(180)
			end
			
			if P2 then
			wndrP2clone2:smooth(1.7)
			wndrP2clone2:rotationz(180)
			end
		end,

		MoveonlycloneupMessageCommand= function(self)
			if P1 then
			P1:spring(0.3)
			P1:rotationz(180)
			wndrP1clone2:spring(0.3)
			wndrP1clone2:rotationz(-180)
			end
			
			if P2 then
			P2:spring(0.3)
			P2:rotationz(180)
			wndrP2clone2:spring(0.3)
			wndrP2clone2:rotationz(-180)
			end
		end,

		MoveonlyclonedownMessageCommand= function(self)
			if P1 then
			P1:spring(0.3)
			P1:rotationz(0)
			wndrP1clone2:spring(0.3)
			wndrP1clone2:rotationz(180)
			end
			
			if P2 then
			P2:spring(0.3)
			P2:rotationz(0)
			wndrP2clone2:spring(0.3)
			wndrP2clone2:rotationz(180)
			end
		end,

		MoveonlycloneRestoreMessageCommand= function(self)
			if P1 then
			P1:spring(0.3)
			P1:rotationz(0)
			wndrP1clone2:spring(0.3)
			wndrP1clone2:rotationz(0)
			end
			
			if P2 then
			P2:spring(0.3)
			P2:rotationz(0)
			wndrP2clone2:spring(0.3)
			wndrP2clone2:rotationz(0)
			end
		end,

		RemoveclonesMessageCommand= function(self)
			if P1 then
			wndrP1clone2:visible(false);
			wndrP1clone3:visible(false);
			wndrP1clone4:visible(false);
			wndrP1clone5:visible(false);
			wndrP1clone6:visible(false);
			wndrP1clone7:visible(false);
			wndrP1clone8:visible(false);
			wndrP1clone9:visible(false);
			wndrP1clone10:visible(false);
			wndrP1clone11:visible(false);
			wndrP1clone12:visible(false);
			wndrP1clone13:visible(false);
			--
			wndrP2clone2:visible(false);
			wndrP2clone3:visible(false);
			wndrP2clone4:visible(false);
			wndrP2clone5:visible(false);
			wndrP2clone6:visible(false);
			wndrP2clone7:visible(false);
			wndrP2clone8:visible(false);
			wndrP2clone9:visible(false);
			wndrP2clone10:visible(false);
			wndrP2clone11:visible(false);
			wndrP2clone12:visible(false);
			wndrP2clone13:visible(false);
			end
		end,

		LeftMessageCommand= function(self)
			if P1 then
			P1:smooth(2.376)
			P1:rotationz(-23)
			end
			
			if P2 then
			P2:smooth(2.376)
			P2:rotationz(23)
			end
		end,

		RestoreMessageCommand= function(self)
			if P1 then
			P1:smooth(2.376)
			P1:rotationz(0)
			end
			
			if P2 then
			P2:smooth(2.376)
			P2:rotationz(0)
			end
		end,

		FallMessageCommand= function(self)
			if P1 then
			P1:smooth(2.376)
			P1:y(120)
			P1:rotationz(80)
			end
			
			if P2 then
			P2:smooth(2.376)
			P2:y(120)
			P2:rotationz(-80)
			end
		end,

		Appear1MessageCommand= function(self)
			if P1 then
			P1:y(0)
			P1:rotationz(0)
			end
			
			if P2 then
			P2:y(0)
			P2:rotationz(0)
			end
		end,

		DropMessageCommand= function(self)
			if P1 then
			P1:decelerate(0.96)
			P1:rotationz(400)
			P1:y(400)
			P1:decelerate(0.84)
			P1:rotationz(0)
			P1:y(0)
			end
			
			if P2 then
			P2:decelerate(0.96)
			P2:rotationz(400)
			P2:y(400)
			P2:decelerate(0.84)
			P2:rotationz(0)
			P2:y(0)
			end
		end,

		SpinMessageCommand= function(self)
			if P1 then
			P1:decelerate(3.84)
			P1:rotationy(54000);
			end
			
			if P2 then
			P2:decelerate(3.84)
			P2:rotationy(54000);
			end
		end,
		
		PlayersRot2MessageCommand= function(self)
			if P1 then
			P1:decelerate(.3)
			P1:rotationz(-90)
			end
			
			if P2 then
			P2:decelerate(.3)
			P2:rotationz(90)
			end
		end,
		
		PlayersRot0MessageCommand= function(self)
			if P1 then
			P1:decelerate(.3)
			P1:rotationz(0)
			end
			
			if P2 then
			P2:decelerate(.3)
			P2:rotationz(0)
			end
		end,
		
		PlayersSkew1MessageCommand= function(self)
			if P1 then
			P1:smooth(0.10)
			P1:skewx(wndr_skewx)
			end
			
			--PE:skewx(wndr_skewx)
			
			if P2 then
			P2:smooth(0.10)
			P2:skewx(-wndr_skewx)
			end
		end,
		
		PlayersSkew2MessageCommand= function(self)
			if P1 then
			P1:smooth(0.10)
			P1:skewx(-wndr_skewx)
			end
			
			if P2 then
			P2:smooth(0.10)
			P2:skewx(wndr_skewx)
			end
		end,
		
		PlayersSkew0MessageCommand= function(self)
			if P1 then
			P1:stoptweening()
			P1:linear(0.25)
			P1:skewx(0)
			end
			
			if P2 then
			P2:stoptweening()
			P2:linear(0.25)
			P2:skewx(0)
			end
		end,

		PlayerRotateRightMessageCommand= function(self)
			if P1 then
			P1:addz(90)
			end
			
			if P2 then
			P2:addz(90)
			end
		end,

		PlayerRotateLeftMessageCommand= function(self)
			if P1 then
			P1:addz(-90)
			end
			
			if P2 then
			P2:addz(-90)
			end
		end,

		PlayerRotateRestoreMessageCommand= function(self)
			if P1 then
			P1:rotationz(0)
			end
			
			if P2 then
			P2:rotationz(0)
			end
		end,

		AppearMessageCommand= function(self)
			if P1 then
			P1:decelerate(0.07)
			P1:zoomx(8)
			P1:zoomz(2)
			P1:decelerate(0.2)
			P1:zoomx(.1)
			P1:zoomz(.1)
			P1:decelerate(0.1)
			P1:zoomx(1)
			P1:zoomz(1)
			end
			
			if P2 then
			P2:decelerate(0.07)
			P2:zoomx(8)
			P2:zoomz(2)
			P2:decelerate(0.2)
			P2:zoomx(.1)
			P2:zoomz(.1)
			P2:decelerate(0.1)
			P2:zoomx(1)
			P2:zoomz(1)
			end
		end,

		BeforeAppearMessageCommand= function(self)
			if P1 then
			P1:zoomx(0)
			P1:zoomz(0)
			end
			
			if P2 then
			P2:zoomx(0)
			P2:zoomz(0)
			end
		end,

		WhateeeeeeeMessageCommand= function(self)
			if P1 then
			P1:zoomy(0)
			P1:decelerate(0.3)
			P1:zoomy(1.5)
			P1:decelerate(0.1)
			P1:zoomy(1)
			end
			
			if P2 then
			P2:zoomy(0)
			P2:decelerate(0.3)
			P2:zoomy(1.5)
			P2:decelerate(0.1)
			P2:zoomy(1)
			end
		end,

		AlarmMessageCommand= function(self)
			if P1 then
			P1:decelerate(0.48)
			P1:zoomz(7)
			P1:decelerate(0.1)
			P1:zoomz(1)
			end
			
			if P2 then
			P2:decelerate(0.48)
			P2:zoomz(7)
			P2:decelerate(0.1)
			P2:zoomz(1)
			end
		end,

		wowMessageCommand= function(self)
			if P1 then
			P1:zoomx(5)
			P1:zoomy(.3)
			P1:decelerate(0.3)
			P1:zoomx(1)
			P1:zoomy(1)
			end
			
			if P2 then
			P2:zoomx(5)
			P2:zoomy(.3)
			P2:decelerate(0.3)
			P2:zoomx(1)
			P2:zoomy(1)
			end
		end,

		datMessageCommand= function(self)
			if P1 then
			P1:decelerate(0.3)
			P1:rotationz(math.random(-39,39));
			P1:rotationy(math.random(-39,39));
			P1:rotationx(math.random(-39,39));
			end
			
			if P2 then
			P2:decelerate(0.3)
			P2:rotationz(math.random(-39,39));
			P2:rotationy(math.random(-39,39));
			P2:rotationx(math.random(-39,39));
			end
		end,

		datbackMessageCommand= function(self)
			if P1 then
			P1:decelerate(0.12)
			P1:rotationz(0);
			P1:rotationy(0);
			P1:rotationx(0);
			end
			
			if P2 then
			P2:decelerate(0.12)
			P2:rotationz(0);
			P2:rotationy(0);
			P2:rotationx(0);
			end
		end,


		-- Vibration commands
		VibratePlayerMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):vibrate();
			SCREENMAN:GetTopScreen():effectmagnitude(0.6,0.6,0.6);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):vibrate();
			SCREENMAN:GetTopScreen():effectmagnitude(0.6,0.6,0.6);
		end,

		VibratePlayerStopMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):stopeffect();
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):stopeffect();
		end,

		VibrateMessageCommand= function(self)
			SCREENMAN:GetTopScreen():vibrate();
			SCREENMAN:GetTopScreen():effectmagnitude(20,20,20);
		end,

		VibratestopMessageCommand= function(self)
			SCREENMAN:GetTopScreen():stopeffect();
		end,

		BounceMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectperiod(1)
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectmagnitude(0,-15,0)
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectperiod(1)
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectmagnitude(0,-15,0)
        end,

        BouncefasterMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectperiod(.5)
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectmagnitude(0,-15,0)
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectperiod(.5)
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectmagnitude(0,-15,0)
        end,

        BouncefastererMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectperiod(.25)
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectmagnitude(0,-15,0)
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectperiod(.25)
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectmagnitude(0,-15,0)
        end,

        BounceSomewereElseMessageCommand= function(self)
        	self:sleep(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectperiod(1)
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectmagnitude(20,-15,15)
        end,

        BouncestopMessageCommand= function(self)
        	SCREENMAN:GetTopScreen():GetChild('PlayerP1'):stopeffect();
        	SCREENMAN:GetTopScreen():GetChild('PlayerP2'):stopeffect();
        end,

        SlidestuffoffstopMessageCommand= function(self)
        	SCREENMAN:GetTopScreen():GetChild('PlayerP1'):decelerate(1.4);
        	SCREENMAN:GetTopScreen():GetChild('PlayerP1'):x(-1000);
        	SCREENMAN:GetTopScreen():GetChild('LifeP1'):decelerate(1.4);
            SCREENMAN:GetTopScreen():GetChild('LifeP1'):x(-1000);
            SCREENMAN:GetTopScreen():GetChild('ScoreP1'):decelerate(1.4);
            SCREENMAN:GetTopScreen():GetChild('ScoreP1'):x(-1000);
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Combo'):decelerate(1.4);
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Combo'):x(-1000);
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Judgment'):decelerate(1.4);
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Judgment'):x(-1000);
        end,

        DivideClonesMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:addx(250);
				wndrP1clone2:addx(-250);
				wndrP1clone3:Vibrate();
				wndrP1clone4:Vibrate();
			end
		end,

		LetsmakeeverythinggoupexceptforthenotefieldMessageCommand= function(self)
			if P1 then
			self:sleep(0);
			SCREENMAN:GetTopScreen():y(-500);
			P1:y(500)
			end
			
			if P2 then
			P2:y(500)
			end
		end,

		MainDissapearsMessageCommand= function(self)
			if P1 then
			self:sleep(0);
			SCREENMAN:GetTopScreen():smooth(0.2);
			SCREENMAN:GetTopScreen():GetChild('Background'):diffusealpha(0);
			end
			
			if P2 then
			P2:y(500)
			end
		end,

		BackUpMessageCommand= function(self)
			if P1 then
			self:sleep(0);
			SCREENMAN:GetTopScreen():smooth(.8);
			P1:smooth(.8)
			SCREENMAN:GetTopScreen():y(0);
			P1:y(0)
			end
			
			if P2 then
			P2:smooth(.8)
			P2:y(0)
			end
		end,

		ChangethebeatofthesongpleaseMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):addx(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):addy(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):addz(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationx(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationy(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationz(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):addx(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):addy(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):addz(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationx(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationy(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationz(math.random(-50,50));
		end,

		ChangethebeatbackMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):x(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):y(500);
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):z(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationx(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationy(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationz(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):x(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):y(500);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):z(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationx(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationy(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationz(0);
		end,
		
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		
		
		ClonesSetMessageCommand= function(self)
			self:sleep(0);
			if P1 then

				wndrP1clone1:visible(true);
				wndrP1clone2:visible(true);
				wndrP1clone3:visible(true);
				wndrP1clone4:visible(true);
				wndrP1clone5:visible(true);
				wndrP1clone6:visible(true);
				wndrP1clone7:visible(true);
				wndrP1clone8:visible(true);
				wndrP1clone9:visible(true);
				wndrP1clone10:visible(true);
				wndrP1clone11:visible(true);
				wndrP1clone12:visible(true);
				wndrP1clone13:visible(true);
				
				wndrP1clone2:x(wndrP1clone1:GetX()+0);
				wndrP1clone3:x(wndrP1clone1:GetX()+0);
				wndrP1clone4:x(wndrP1clone1:GetX()+0);
				wndrP1clone5:x(wndrP1clone1:GetX()+0);
				wndrP1clone6:x(wndrP1clone1:GetX()+0);
				wndrP1clone7:x(wndrP1clone1:GetX()+0);
				wndrP1clone8:x(wndrP1clone1:GetX()+0);
				wndrP1clone9:x(wndrP1clone1:GetX()+0);
				wndrP1clone10:x(wndrP1clone1:GetX()+0);
				wndrP1clone11:x(wndrP1clone1:GetX()+0);
				wndrP1clone12:x(wndrP1clone1:GetX()+0);
				wndrP1clone13:x(wndrP1clone1:GetX()+0);
				
				wndrP1clone2:y(wndrP1clone1:GetY()+0);
				wndrP1clone3:y(wndrP1clone1:GetY()+0);
				wndrP1clone4:y(wndrP1clone1:GetY()+0);
				wndrP1clone5:y(wndrP1clone1:GetY()+0);
				wndrP1clone6:y(wndrP1clone1:GetY()+0);
				wndrP1clone7:y(wndrP1clone1:GetY()+0);
				wndrP1clone8:y(wndrP1clone1:GetY()+0);
				wndrP1clone9:y(wndrP1clone1:GetY()+0);
				wndrP1clone10:y(wndrP1clone1:GetY()+0);
				wndrP1clone11:y(wndrP1clone1:GetY()+0);
				wndrP1clone12:y(wndrP1clone1:GetY()+0);
				wndrP1clone13:y(wndrP1clone1:GetY()+0);
			end
			
			if P2 then

				wndrP2clone1:visible(true);
				wndrP2clone2:visible(true);
				wndrP2clone3:visible(true);
				wndrP2clone4:visible(true);
				wndrP2clone5:visible(true);
				wndrP2clone6:visible(true);
				wndrP2clone7:visible(true);
				wndrP2clone8:visible(true);
				wndrP2clone9:visible(true);
				wndrP2clone10:visible(true);
				wndrP2clone11:visible(true);
				wndrP2clone12:visible(true);
				wndrP2clone13:visible(true);
				
				wndrP2clone2:x(wndrP2clone1:GetX()+0);
				wndrP2clone3:x(wndrP2clone1:GetX()+0);
				wndrP2clone4:x(wndrP2clone1:GetX()+0);
				wndrP2clone5:x(wndrP2clone1:GetX()+0);
				wndrP2clone6:x(wndrP2clone1:GetX()+0);
				wndrP2clone7:x(wndrP2clone1:GetX()+0);
				wndrP2clone8:x(wndrP2clone1:GetX()+0);
				wndrP2clone9:x(wndrP2clone1:GetX()+0);
				wndrP2clone10:x(wndrP2clone1:GetX()+0);
				wndrP2clone11:x(wndrP2clone1:GetX()+0);
				wndrP2clone12:x(wndrP2clone1:GetX()+0);
				wndrP2clone13:x(wndrP2clone1:GetX()+0);
				
				wndrP2clone2:y(wndrP2clone1:GetY()+0);
				wndrP2clone3:y(wndrP2clone1:GetY()+0);
				wndrP2clone4:y(wndrP2clone1:GetY()+0);
				wndrP2clone5:y(wndrP2clone1:GetY()+0);
				wndrP2clone6:y(wndrP2clone1:GetY()+0);
				wndrP2clone7:y(wndrP2clone1:GetY()+0);
				wndrP2clone8:y(wndrP2clone1:GetY()+0);
				wndrP2clone9:y(wndrP2clone1:GetY()+0);
				wndrP2clone10:y(wndrP2clone1:GetY()+0);
				wndrP2clone11:y(wndrP2clone1:GetY()+0);
				wndrP2clone12:y(wndrP2clone1:GetY()+0);
				wndrP2clone13:y(wndrP2clone1:GetY()+0);
			end
		end,

		SetonecloneMessageCommand= function(self)
			self:sleep(0);
			if P1 then

				wndrP1clone1:visible(true);
				wndrP1clone2:visible(true);
				
				wndrP1clone2:x(wndrP1clone1:GetX()+0);
				wndrP1clone3:x(wndrP1clone1:GetX()+0);
				
				wndrP1clone2:y(wndrP1clone1:GetY()+0);
			end
			
			if P2 then

				wndrP2clone1:visible(true);
				wndrP2clone2:visible(true);
				
				wndrP2clone2:x(wndrP2clone1:GetX()+0);
				wndrP2clone3:x(wndrP2clone1:GetX()+0);
				
				wndrP2clone2:y(wndrP2clone1:GetY()+0);
			end
		end,
		
		DropFirstMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:smooth(0.345);
				wndrP1clone1:addy(450);
				wndrP1clone1:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone1:smooth(0.345);
				wndrP2clone1:addy(450);
				wndrP2clone1:rotationz(20);
			end
		end,
		
		
		FirstJumpMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:sleep(0);
				wndrP1clone1:rotationz(-20);
				wndrP1clone1:smooth(0.345*2);
				wndrP1clone1:addy(-450);
				wndrP1clone1:rotationz(0);
				wndrP1clone1:smooth(0.345*2);
				wndrP1clone1:addy(450);
				wndrP1clone1:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone1:sleep(0);
				wndrP2clone1:rotationz(-20);
				wndrP2clone1:smooth(0.345*2);
				wndrP2clone1:addy(-450);
				wndrP2clone1:rotationz(0);
				wndrP2clone1:smooth(0.345*2);
				wndrP2clone1:addy(450);
				wndrP2clone1:rotationz(20);
			end
		end,
		
		
		SecondJumpMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone2:sleep(0);
				wndrP1clone2:rotationz(-20);
				wndrP1clone2:smooth(0.345*2);
				wndrP1clone2:addy(-450);
				wndrP1clone2:rotationz(0);
				wndrP1clone2:smooth(0.345*2);
				wndrP1clone2:addy(450);
				wndrP1clone2:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone2:sleep(0);
				wndrP2clone2:rotationz(-20);
				wndrP2clone2:smooth(0.345*2);
				wndrP2clone2:addy(-450);
				wndrP2clone2:rotationz(0);
				wndrP2clone2:smooth(0.345*2);
				wndrP2clone2:addy(450);
				wndrP2clone2:rotationz(20);
			end
		end,
		
		ThirdJumpMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone3:sleep(0);
				wndrP1clone3:rotationz(-20);
				wndrP1clone3:smooth(0.345*2);
				wndrP1clone3:addy(-450);
				wndrP1clone3:rotationz(0);
				wndrP1clone3:smooth(0.345*2);
				wndrP1clone3:addy(450);
				wndrP1clone3:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone3:sleep(0);
				wndrP2clone3:rotationz(-20);
				wndrP2clone3:smooth(0.345*2);
				wndrP2clone3:addy(-450);
				wndrP2clone3:rotationz(0);
				wndrP2clone3:smooth(0.345*2);
				wndrP2clone3:addy(450);
				wndrP2clone3:rotationz(20);
			end
		end,
		
		FourthJumpMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone4:sleep(0);
				wndrP1clone4:rotationz(-20);
				wndrP1clone4:smooth(0.345*2);
				wndrP1clone4:addy(-450);
				wndrP1clone4:rotationz(0);
				wndrP1clone4:smooth(0.345*2);
				wndrP1clone4:addy(450);
				wndrP1clone4:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone4:sleep(0);
				wndrP2clone4:rotationz(-20);
				wndrP2clone4:smooth(0.345*2);
				wndrP2clone4:addy(-450);
				wndrP2clone4:rotationz(0);
				wndrP2clone4:smooth(0.345*2);
				wndrP2clone4:addy(450);
				wndrP2clone4:rotationz(20);
			end
		end,
		
		FourthSetMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone4:sleep(0);
				wndrP1clone4:rotationz(-20);
				wndrP1clone4:smooth(0.345*2);
				wndrP1clone4:x(P1xpos);
				wndrP1clone4:y(P1ypos);
				wndrP1clone4:rotationz(0);
			end
			
			if P1 then
				
				wndrP2clone4:sleep(0);
				wndrP2clone4:rotationz(-20);
				wndrP2clone4:smooth(0.345*2);
				wndrP2clone4:x(P2xpos);
				wndrP2clone4:y(P2ypos);
				wndrP2clone4:rotationz(0);
			end
		end,
		
		HideRestMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:visible(false);
				wndrP1clone2:visible(false);
				wndrP1clone3:visible(false);
			end
			
			if P2 then
				
				wndrP2clone1:visible(false);
				wndrP2clone2:visible(false);
				wndrP2clone3:visible(false);
			end
		end,
		
		------------------------------------------------
		------------------------------------------------
		------------------------------------------------
		----------BRIDGE THING PART MOD THINGY----------
		------------------------------------------------
		------------------------------------------------
		------------------------------------------------
		
		SetRestMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:visible(true);
				wndrP1clone1:x(P1xpos);
				wndrP1clone1:y(P1ypos+450);
				wndrP1clone1:rotationz(0);
				
				wndrP1clone2:visible(true);
				wndrP1clone2:x(P1xpos);
				wndrP1clone2:y(P1ypos+450);
				wndrP1clone2:rotationz(0);
				
				wndrP1clone3:visible(true);
				wndrP1clone3:x(P1xpos);
				wndrP1clone3:y(P1ypos+450);
				wndrP1clone3:rotationz(0);
			end
			
			if P2 then
				
				wndrP2clone1:visible(true);
				wndrP2clone1:x(P2xpos);
				wndrP2clone1:y(P2ypos+450);
				wndrP2clone1:rotationz(0);
				
				wndrP2clone2:visible(true);
				wndrP2clone2:x(P2xpos);
				wndrP2clone2:y(P2ypos+450);
				wndrP2clone2:rotationz(0);
				
				wndrP2clone3:visible(true);
				wndrP2clone3:x(P2xpos);
				wndrP2clone3:y(P2ypos+450);
				wndrP2clone3:rotationz(0);
			end
		end,
		
		PopThirdMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone3:zoom(0.9);
				wndrP1clone3:smooth(1);
				wndrP1clone3:x(P1xpos+100);
				wndrP1clone3:y(P1ypos+100);
				wndrP1clone3:rotationz(40);
				wndrP1clone3:sleep(2);
				wndrP1clone3:smooth(1);
				wndrP1clone3:x(P1xpos);
				wndrP1clone3:y(P1ypos+450);
				wndrP1clone3:rotationz(0);
			end
			
			if P2 then
								
				wndrP2clone3:zoom(0.9);
				wndrP2clone3:smooth(1);
				wndrP2clone3:x(P2xpos-100);
				wndrP2clone3:y(P2ypos+100);
				wndrP2clone3:rotationz(-40);
				wndrP2clone3:sleep(2);
				wndrP2clone3:smooth(1);
				wndrP2clone3:x(P2xpos);
				wndrP2clone3:y(P2ypos+450);
				wndrP2clone3:rotationz(0);
			end
		end,
		
		PopSecondMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone2:zoom(0.8);
				wndrP1clone2:smooth(1);
				wndrP1clone2:x(P1xpos-100);
				wndrP1clone2:y(P1ypos+120);
				wndrP1clone2:rotationz(-40);
				wndrP1clone2:sleep(2);
				wndrP1clone2:smooth(1);
				wndrP1clone2:x(P1xpos);
				wndrP1clone2:y(P1ypos+450);
				wndrP1clone2:rotationz(0);
			end
			
			if P2 then
								
				wndrP2clone2:zoom(0.8);
				wndrP2clone2:smooth(1);
				wndrP2clone2:x(P2xpos+100);
				wndrP2clone2:y(P2ypos+120);
				wndrP2clone2:rotationz(40);
				wndrP2clone2:sleep(2);
				wndrP2clone2:smooth(1);
				wndrP2clone2:x(P2xpos);
				wndrP2clone2:y(P2ypos+450);
				wndrP2clone2:rotationz(0);
			end
		end,
		
		PopFirstMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone1:zoom(0.7);
				wndrP1clone1:smooth(1);
				wndrP1clone1:x(P1xpos);
				wndrP1clone1:y(P1ypos+140);
				wndrP1clone1:rotationz(0);
				wndrP1clone1:sleep(2);
				wndrP1clone1:smooth(1);
				wndrP1clone1:x(P1xpos);
				wndrP1clone1:y(P1ypos+450);
				wndrP1clone1:rotationz(0);
			end
			
			if P2 then
								
				wndrP2clone1:zoom(0.7);
				wndrP2clone1:smooth(1);
				wndrP2clone1:x(P2xpos);
				wndrP2clone1:y(P2ypos+140);
				wndrP2clone1:rotationz(0);
				wndrP2clone1:sleep(2);
				wndrP2clone1:smooth(1);
				wndrP2clone1:x(P2xpos);
				wndrP2clone1:y(P2ypos+450);
				wndrP2clone1:rotationz(0);
			end
		end,
		
		
		-------------------------------------------
		-------------------------------------------
		-------------------------------------------
		
		RaiseThirdMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone3:x(P1xpos-130);
				wndrP1clone3:zoom(0.7);
				wndrP1clone3:decelerate(0.5);
				wndrP1clone3:x(P1xpos-130);
				wndrP1clone3:y(P1ypos+100);
				wndrP1clone3:rotationz(0);
			end
			
			if P2 then
				
				wndrP2clone3:x(P2xpos+130);				
				wndrP2clone3:zoom(0.7);
				wndrP2clone3:decelerate(0.5);
				wndrP2clone3:x(P2xpos+130);
				wndrP2clone3:y(P2ypos+100);
				wndrP2clone3:rotationz(0);
			end
		end,
		
		LowerFourthMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone4:smooth(1);
				wndrP1clone4:y(P1ypos+64);
			end
			
			if P2 then
								
				wndrP2clone4:smooth(1);
				wndrP2clone4:y(P2ypos+64);
			end
		end,
		
		LowerBothMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone4:smooth(1);
				wndrP1clone4:y(P1ypos+64+64);
				
				wndrP1clone3:smooth(1);
				wndrP1clone3:y(P1ypos+100+80);
			end
			
			if P2 then
								
				wndrP2clone4:smooth(1);
				wndrP2clone4:y(P2ypos+64+64);
				wndrP2clone3:smooth(1);
				wndrP2clone3:y(P2ypos+100+80);
			end
		end,
		
		LowerBothAgainMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone4:smooth(1);
				wndrP1clone4:y(P1ypos+64+64+64);
				
				wndrP1clone3:smooth(1);
				wndrP1clone3:y(P1ypos+100+70+70);
			end
			
			if P2 then
								
				wndrP2clone4:smooth(1);
				wndrP2clone4:y(P2ypos+64+64+64);
				wndrP2clone3:smooth(1);
				wndrP2clone3:y(P2ypos+100+70+70);
			end
		end,
		
		
		RaiseSecondMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone2:x(P1xpos+110);
				wndrP1clone2:zoom(0.6);
				wndrP1clone2:decelerate(0.5);
				wndrP1clone2:y(P1ypos+120);
				
			end
			
			if P2 then
				
				wndrP2clone2:x(P2xpos-110);
				wndrP2clone2:zoom(0.6);
				wndrP2clone2:decelerate(0.5);
				wndrP2clone2:y(P2ypos+120);
			end
		end,
		
		RaiseAllMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone2:smooth(0.7);
				wndrP1clone2:y(P1ypos+120-64);
				
				wndrP1clone3:smooth(0.7);
				wndrP1clone3:y(P1ypos+64);
				
				wndrP1clone4:smooth(0.7);
				wndrP1clone4:y(P1ypos);
				
				
			end
			
			if P2 then
				
				wndrP2clone2:smooth(0.7);
				wndrP2clone2:y(P2ypos+120-64);
				
				wndrP2clone3:smooth(0.7);
				wndrP2clone3:y(P2ypos+64);
				
				wndrP2clone4:smooth(0.7);
				wndrP2clone4:y(P2ypos);
			end
		end,
		
		LowerAllMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone2:smooth(0.7);
				wndrP1clone2:y(P1ypos+120);
				
				wndrP1clone3:smooth(0.7);
				wndrP1clone3:y(P1ypos+100+70);
				
				wndrP1clone4:smooth(0.7);
				wndrP1clone4:y(P1ypos+64);
				
				
			end
			
			if P2 then
				
				wndrP2clone2:smooth(0.7);
				wndrP2clone2:y(P2ypos+120);
				
				wndrP2clone3:smooth(0.7);
				wndrP2clone3:y(P2ypos+100+70);
				
				wndrP2clone4:smooth(0.7);
				wndrP2clone4:y(P2ypos+64);
			end
		end,
		
		FlyAwayMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone2:smooth(1);
				wndrP1clone2:y(P1ypos-500);
				
				wndrP1clone3:smooth(1);
				wndrP1clone3:y(P1ypos-500);
				
				wndrP1clone4:smooth(0.5);
				wndrP1clone4:y(P1ypos);
				
				
			end
			
			if P2 then
				
				wndrP2clone2:smooth(1);
				wndrP2clone2:y(P2ypos-500);
				
				wndrP2clone3:smooth(1);
				wndrP2clone3:y(P2ypos-500);
				
				wndrP2clone4:smooth(0.5);
				wndrP2clone4:y(P2ypos);
			end
		end,
		
		Hide123MessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone1:visible(false);
				wndrP1clone2:visible(false);
				wndrP1clone3:visible(false);

			end
			
			if P2 then
				
				wndrP2clone1:visible(false);
				wndrP2clone2:visible(false);
				wndrP2clone3:visible(false);
			end
		end,
		
----------------------------------------
	
	WagPlayersMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				P1:wag();
				P1:effectclock('bgm');
				P1:effectmagnitude(0,0,30);
				P1:effectperiod(2);
			end
			
			if P2 then
								
				P2:wag();
				P2:effectclock('bgm');
				P2:effectmagnitude(0,0,-30);
				P2:effectperiod(2);
			end
		end,
	},
	
	--------------------------------------------------------
	--------------------------------------------------------
	--------------------------------------------------------
	-------------HERE LIES THE ACTOR PROXIES----------------
	--------------------------------------------------------
	--------------------------------------------------------
	--------------------------------------------------------
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone1=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone2=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone3=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone4=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone5=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone6=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone7=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone8=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone9=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone10=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone11=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone12=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone13=self;
			
		end;
	};
	
	
	------
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone1=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone2=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone3=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone4=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone5=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone6=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone7=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone8=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone9=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone10=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone11=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone12=self;
			
		end;
	};

	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone13=self;
			
		end;
	};
	
}