local frame = {
  InitCommand = function(self)
    self:visible(false)
    return self:sleep(1000)
  end
}
local leafOffset = 200
local leafCmd = {
  OnCommand = function(self)
    return self:queuecommand('Fall')
  end,
  FallCommand = function(self)
    self:diffusealpha(0)
    self:effectmagnitude(100,0,0)
    self:x(360)
    self:y(math.random(SCREEN_TOP, SCREEN_BOTTOM))
    self:zoom(0)
    self:sleep(math.random() * 3)
    self:linear(0)
    self:x(math.random(SCREEN_LEFT-100, SCREEN_RIGHT+100))
    self:sleep(4)
    self:rotationz(90)
    self:decelerate(3)
    self:zoom(0.4)
    self:diffusealpha(0.1)
    self:linear(math.random() * 10)
    self:addx(-1500)
    self:sleep(0.01)
    self:x(900)
    self:linear(math.random() * 10)
    self:addx(-1500)
    self:sleep(0.01)
    self:x(900)
    self:linear(math.random() * 10)
    self:addx(-1500)
    self:sleep(0.01)
    self:x(900)
    self:linear(math.random() * 10)
    self:addx(-1500)
    self:sleep(0.01)
    self:x(900)
    self:linear(math.random() * 10)
    self:addx(-1500)
    self:sleep(0.01)
    self:x(900)
    self:linear(math.random() * 10)
    self:addx(-1500)
    self:sleep(0.01)
    self:x(900)
    self:linear(math.random() * 10)
    self:addx(-1500)
    if GAMESTATE:GetSongBeat() < 185 then
      return self:queuecommand('Fall')
    end
  end
}
local leaf = LoadActor('4') .. leafCmd
for i = 1, 90 do
  table.insert(frame, leaf)
end
local leaf = LoadActor('8') .. leafCmd
for i = 1, 90 do
  table.insert(frame, leaf)
end
local leaf = LoadActor('12') .. leafCmd
for i = 1, 90 do
  table.insert(frame, leaf)
end
local leaf = LoadActor('24') .. leafCmd
for i = 1, 90 do
  table.insert(frame, leaf)
end
local leaf = LoadActor('58') .. leafCmd
for i = 1, 90 do
  table.insert(frame, leaf)
end
local leaf = LoadActor('64') .. leafCmd
for i = 1, 90 do
  table.insert(frame, leaf)
end
local leaf = LoadActor('92') .. leafCmd
for i = 1, 90 do
  table.insert(frame, leaf)
end
local leaf = LoadActor('198') .. leafCmd
for i = 1, 90 do
  table.insert(frame, leaf)
end
return Def.ActorFrame(frame)
