
local songName= GAMESTATE:GetCurrentSong():GetSongDir()

local function iris_mod_internal(str, pn)
	local ps= GAMESTATE:GetPlayerState(pn)
	local pmods= ps:GetPlayerOptionsString('ModsLevel_Song')
	ps:SetPlayerOptions('ModsLevel_Song', pmods .. ', ' .. str)
	--GAMESTATE:ApplyGameCommand('mod,'..str, pn)
end


local function iris_mod(str)
	for i=1,2 do
		iris_mod_internal(str, 'PlayerNumber_P' .. i)
	end
end



local function iris_init()
	fgcurcommand = 0;
	wndr_skewx=0.3;
	checked = false;
	
	-- Original Mods in .ssc by Kirby5464, Remastered from scratch by Jose_Varela. 
	
	--lua course :D	/ timed mod management	
	curmod = 1;
	--{beat,mod,player}
	mods = {

		{32,'*99 60% stealth, *99 30% drunk, *99 30% dizzy'},
		{32.1,'*0.1 0% stealth, *0.1 0% drunk, *0.1 0% dizzy'},

		{69,'*99 100% brake'},
		{69.1,'*8 0% brake'},
		{69.5,'*99 100% brake'},
		{69.6,'*8 0% brake'},
		{70,'*99 100% brake'},
		{70.1,'*8 0% brake'},
		{70.5,'*99 100% brake'},
		{70.6,'*8 0% brake'},
		{71,'*99 100% brake'},
		{71.1,'*8 0% brake'},
		{71.5,'*99 100% brake'},
		{71.6,'*8 0% brake'},

		{77,'*30 drunk'},
		{78,'*30 -100% drunk'},
		{79,'*30 0% drunk'},

		{85,'*99 100% brake'},
		{85.1,'*8 0% brake'},
		{85.5,'*99 100% brake'},
		{85.6,'*8 0% brake'},
		{86,'*99 100% brake'},
		{86.1,'*8 0% brake'},
		{86.5,'*99 100% brake'},
		{86.6,'*8 0% brake'},
		{87,'*99 100% brake'},
		{87.1,'*8 0% brake'},
		{87.5,'*99 100% brake'},
		{87.6,'*8 0% brake'},

		{101,'*99 100% brake'},
		{101.1,'*8 0% brake'},
		{101.5,'*99 100% brake'},
		{101.6,'*8 0% brake'},
		{102,'*99 100% brake'},
		{102.1,'*8 0% brake'},
		{102.5,'*99 100% brake'},
		{102.6,'*8 0% brake'},
		{103,'*99 100% brake'},
		{103.1,'*8 0% brake'},
		{103.5,'*99 100% brake'},
		{103.6,'*8 0% brake'},

		{117,'*99 100% brake'},
		{117.1,'*8 0% brake'},
		{117.5,'*99 100% brake'},
		{117.6,'*8 0% brake'},
		{118,'*99 100% brake'},
		{118.1,'*8 0% brake'},
		{118.5,'*99 100% brake'},
		{118.6,'*8 0% brake'},
		{119,'*99 100% brake'},
		{119.1,'*8 0% brake'},
		{119.5,'*99 100% brake'},
		{119.6,'*8 0% brake'},

		{124,'*99 50% reverse, *99 50% flip, *99 stealth'},
		{124.5,'*99 0% stealth'},
		{125,'*2 0% reverse, *2 0% flip'},

		{130,'*15 drunk'},
		{131,'*15 -100% drunk'},
		{132,'*15 0% drunk'},

		{133,'*99 -80% tiny'},
		{133.1,'*8 0% tiny'},
		{133.5,'*99 -80% tiny'},
		{133.6,'*8 0% tiny'},
		{134,'*99 -80% tiny'},
		{134.1,'*8 0% tiny'},

		{136,'*8 flip'},
		{136.5,'*8 0% flip'},
		{137,'*99 -80% tiny'},
		{137.1,'*8 0% tiny'},
		{138,'*8 flip'},
		{138.5,'*8 0% flip'},
		{139,'*8 flip'},
		{139.5,'*8 0% flip'},

		{141,'*30 tipsy'},
		{141.5,'*30 -100% tipsy'},
		{143,'*30 0% tipsy'},

		{146,'*15 drunk'},
		{147,'*15 -100% drunk'},
		{148,'*15 0% drunk'},

		{149,'*99 -80% tiny'},
		{149.1,'*8 0% tiny'},
		{149.5,'*99 -80% tiny'},
		{149.6,'*8 0% tiny'},
		{150,'*99 -80% tiny'},
		{150.1,'*8 0% tiny'},

		{152,'*8 flip'},
		{152.5,'*8 0% flip'},
		{153,'*99 -80% tiny'},
		{153.1,'*8 0% tiny'},
		{154,'*8 flip'},
		{154.5,'*8 0% flip'},
		{155,'*8 flip'},
		{155.5,'*8 0% flip'},

		{162,'*15 drunk'},
		{163,'*15 -100% drunk'},
		{164,'*15 0% drunk'},

		{165,'*99 -80% tiny'},
		{165.1,'*8 0% tiny'},
		{165.5,'*99 -80% tiny'},
		{165.6,'*8 0% tiny'},
		{166,'*99 -80% tiny'},
		{166.1,'*8 0% tiny'},

		{168,'*8 flip'},
		{168.5,'*8 0% flip'},
		{169,'*99 -80% tiny'},
		{169.1,'*8 0% tiny'},
		{170,'*8 flip'},
		{170.5,'*8 0% flip'},
		{171,'*8 flip'},
		{171.5,'*8 0% flip'},

		{173,'*30 tipsy'},
		{173.5,'*30 -100% tipsy'},
		{175,'*30 0% tipsy'},

		{178,'*15 drunk'},
		{179,'*15 -100% drunk'},
		{180,'*15 0% drunk'},

		{181,'*99 -80% tiny'},
		{181.1,'*8 0% tiny'},
		{181.5,'*99 -80% tiny'},
		{181.6,'*8 0% tiny'},
		{182,'*99 -80% tiny'},
		{182.1,'*8 0% tiny'},

		{184,'*8 flip'},
		{184.5,'*8 0% flip'},
		{185,'*99 -80% tiny'},
		{185.1,'*8 0% tiny'},
		{186,'*8 flip'},
		{186.5,'*8 0% flip'},
		{187,'*8 flip'},
		{187.5,'*8 0% flip'},

		{189,'*30 tipsy'},
		{189.5,'*30 -100% tipsy'},
		{191,'*30 0% tipsy'},

		{192,'*99 130% drunk, *99 20% dizzy, *99 140% tipsy'},
		{193,'*30 0% tipsy'},

		{197,'*99 100% brake'},
		{197.1,'*8 0% brake'},
		{197.5,'*99 100% brake'},
		{197.6,'*8 0% brake'},
		{198,'*99 100% brake'},
		{198.1,'*8 0% brake'},
		{198.5,'*99 100% brake'},
		{198.6,'*8 0% brake'},
		{199,'*99 100% brake'},
		{199.1,'*8 0% brake'},
		{199.5,'*99 100% brake'},
		{199.6,'*8 0% brake'},

		{213,'*99 100% brake'},
		{213.1,'*8 0% brake'},
		{213.5,'*99 100% brake'},
		{213.6,'*8 0% brake'},
		{214,'*99 100% brake'},
		{214.1,'*8 0% brake'},
		{214.5,'*99 100% brake'},
		{214.6,'*8 0% brake'},
		{215,'*99 100% brake'},
		{215.1,'*8 0% brake'},
		{215.5,'*99 100% brake'},
		{215.6,'*8 0% brake'},

		{229,'*99 100% brake'},
		{229.1,'*8 0% brake'},
		{229.5,'*99 100% brake'},
		{229.6,'*8 0% brake'},
		{230,'*99 100% brake'},
		{230.1,'*8 0% brake'},
		{230.5,'*99 100% brake'},
		{230.6,'*8 0% brake'},
		{231,'*99 100% brake'},
		{231.1,'*8 0% brake'},
		{231.5,'*99 100% brake'},
		{231.6,'*8 0% brake'},

		{245,'*99 100% brake'},
		{245.1,'*8 0% brake'},
		{245.5,'*99 100% brake'},
		{245.6,'*8 0% brake'},
		{246,'*99 100% brake'},
		{246.1,'*8 0% brake'},
		{246.5,'*99 100% brake'},
		{246.6,'*8 0% brake'},
		{247,'*99 100% brake'},
		{247.1,'*8 0% brake'},
		{247.5,'*99 100% brake'},
		{247.6,'*8 0% brake'},

		{248,'*99 -100% drunk, *9 0% dizzy'},
		{248.1,'*9 0% drunk'},
		{250,'*99 drunk'},
		{250.1,'*9 0% drunk'},

		{256,'*30 drunk'},
		{257,'*30 -100% drunk'},
		{258,'*30 drunk'},
		{259,'*30 -100% drunk'},

		{260,'drunk, *13 tipsy'},
		{260.5,'*13 -100% tipsy'},
		{261,'*13 tipsy'},
		{261.5,'*13 -100% tipsy'},
		{262,'*13 tipsy'},
		{262.5,'*13 -100% tipsy'},
		{263,'*13 tipsy'},
		{263.5,'*13 0% tipsy'},
		{264,'*13 tipsy'},
		{264.25,'*13 -100% drunk, *13 0% tipsy'},
		{264.5,'*13 drunk'},
		{264.75,'*13 -100% drunk'},
		{265,'*0.8 0% drunk'},

		{276,'*15 reverse'},
		{277,'*15 0% reverse'},
		{278,'*15 reverse'},
		{279,'*15 0% reverse'},
		{280,'*15 reverse'},
		{281,'*15 0% reverse'},

		{282,'*13 tipsy'},
		{282.5,'*13 -100% tipsy'},
		{283,'*13 tipsy'},
		{283.5,'*13 -100% tipsy'},
		{284,'*13 tipsy'},
		{284.5,'*13 0% tipsy'},

		{308,'*0.5 50% reverse, drunk'},
		{312,'*0.6 0% reverse, 0% drunk'},

		{320,'*30 drunk'},
		{321,'*30 -100% drunk'},
		{322,'*30 drunk'},
		{323,'*30 -100% drunk'},

		{324,'drunk, *13 tipsy'},
		{324.5,'*13 -100% tipsy'},
		{325,'*13 tipsy'},
		{325.5,'*13 -100% tipsy'},
		{326,'*13 tipsy'},
		{326.5,'*13 -100% tipsy'},
		{327,'*13 tipsy'},
		{327.5,'*13 0% tipsy'},
		{328,'*13 tipsy'},
		{328.25,'*13 -100% drunk, *13 0% tipsy'},
		{328.5,'*13 drunk'},
		{328.75,'*13 -100% drunk'},
		{329,'*0.8 0% drunk'},

		{340,'*15 reverse'},
		{341,'*15 0% reverse'},
		{342,'*15 reverse'},
		{343,'*15 0% reverse'},
		{344,'*15 reverse'},
		{345,'*15 0% reverse'},

		{372,'*0.5 50% reverse, drunk'},
		{376,'*0.6 0% reverse, 0% drunk'},

		{383,'*30 200% tiny'},
		{384,'*99 tipsy, *99 190% drunk, *99 150% brake, *99 -300% tiny'},
		{384.1,'*0.8 0% brake, *0.6 0% tiny'},
		{385,'*9 0% tipsy, *9 40% drunk, *99 60% brake, *30 0% tiny'},

		{416,'*99 tipsy, *99 190% drunk, *99 150% brake, *99 -150% tiny'},
		{416.1,'*0.8 0% brake, *0.6 0% tiny'},
		{417,'*9 0% tipsy, *9 40% drunk, *99 60% brake, *30 0% tiny, *99 60% wave'},

		{448,'*99 10% beat'},

		{480,'*6 30% tipsy'},

		{510,'*6 0% brake, *6 0% drunk, *6 0% wave, *6 0% tipsy, *6 0% beat'},

		{512,'*15 reverse'},
		{513,'*15 0% reverse'},
		{514,'*15 flip'},
		{515,'*15 0% flip'},

		{516,'*30 tipsy'},
		{516.5,'*30 -100% tipsy'},
		{517,'*30 0% tipsy'},

		{518,'*30 tipsy, *30 drunk'},
		{518.5,'*30 -100% tipsy, *30 -100% drunk'},
		{519,'*30 0% tipsy, *30 drunk'},
		{519.5,'*30 -100% tipsy, *30 -100% drunk'},
		{520,'*30 0% tipsy, *30 0% drunk, *30 cross'},
		{521,'*30 0% cross'},
		{522,'*30 alternate'},
		{523,'*30 0% alternate'},

		{524,'*30 10% reverse, *30 10% flip'},
		{524.5,'*30 20% reverse, *30 20% flip'},
		{525,'*30 30% reverse, *30 30% flip'},
		{525.5,'*30 40% reverse, *30 40% flip'},
		{526,'*30 50% reverse, *30 50% flip'},
		{526.1,'*0.9 0% reverse, *0.9 0% flip'},

		{528,'*99 -150% tiny'},
		{528.1,'*16 0% tiny'},
		{529,'*99 -150% tiny'},
		{529.1,'*16 0% tiny'},
		{530,'*99 -150% tiny'},
		{530.1,'*16 0% tiny'},
		{531,'*99 -150% tiny'},
		{531.1,'*16 0% tiny'},

		{532,'*30 reverse'},
		{532.5,'*30 flip'},
		{533,'*30 0% reverse, *30 0% flip'},

		{534,'*30 30% reverse'},
		{534.1,'*3 0% reverse'},
		{534.5,'*30 30% reverse'},
		{534.6,'*3 0% reverse'},
		{535,'*30 30% reverse'},
		{535.1,'*3 0% reverse'},
		{535.5,'*30 30% reverse'},
		{535.6,'*3 0% reverse'},

		{536,'*99 -150% tiny'},
		{537,'*99 150% tiny'},
		{538,'*15 0% tiny'},

		{544,'*15 reverse'},
		{545,'*15 0% reverse'},
		{546,'*15 flip'},
		{547,'*15 0% flip'},

		{548,'*30 tipsy'},
		{548.5,'*30 -100% tipsy'},
		{549,'*30 0% tipsy'},

		{550,'*30 tipsy, *30 drunk'},
		{550.5,'*30 -100% tipsy, *30 -100% drunk'},
		{551,'*30 0% tipsy, *30 drunk'},
		{551.5,'*30 -100% tipsy, *30 -100% drunk'},
		{552,'*30 0% tipsy, *30 0% drunk, *30 cross'},
		{553,'*30 0% cross'},
		{554,'*30 alternate'},
		{555,'*30 0% alternate'},

		{556,'*30 10% reverse, *30 10% flip'},
		{556.5,'*30 20% reverse, *30 20% flip'},
		{557,'*30 30% reverse, *30 30% flip'},
		{557.5,'*30 40% reverse, *30 40% flip'},
		{558,'*30 50% reverse, *30 50% flip'},
		{558.1,'*0.9 0% reverse, *0.9 0% flip'},

		{560,'*99 -150% tiny'},
		{560.1,'*16 0% tiny'},
		{561,'*99 -150% tiny'},
		{561.1,'*16 0% tiny'},
		{562,'*99 -150% tiny'},
		{562.1,'*16 0% tiny'},
		{563,'*99 -150% tiny'},
		{563.1,'*16 0% tiny'},

		{564,'*30 reverse'},
		{564.5,'*30 flip'},
		{565,'*30 0% reverse, *30 0% flip'},

		{566,'*30 30% reverse'},
		{566.1,'*3 0% reverse'},
		{566.5,'*30 30% reverse'},
		{566.6,'*3 0% reverse'},
		{567,'*30 30% reverse'},
		{567.1,'*3 0% reverse'},
		{567.5,'*30 30% reverse'},
		{567.6,'*3 0% reverse'},

		{568,'*99 -150% tiny'},
		{569,'*99 150% tiny'},
		{570,'*15 0% tiny'},

		{578,'*15 drunk'},
		{579,'*15 -100% drunk'},
		{580,'*15 0% drunk'},

		{581,'*99 -80% tiny'},
		{581.1,'*8 0% tiny'},
		{581.5,'*99 -80% tiny'},
		{581.6,'*8 0% tiny'},
		{582,'*99 -80% tiny'},
		{582.1,'*8 0% tiny'},

		{584,'*8 flip'},
		{584.5,'*8 0% flip'},
		{585,'*99 -80% tiny'},
		{585.1,'*8 0% tiny'},

		{586.5,'*8 flip'},
		{587,'*8 0% flip'},

		{588,'*30 tipsy'},
		{589,'*30 -100% tipsy'},
		{589.5,'*30 0% tipsy'},

		{594,'*15 drunk'},
		{595,'*15 -100% drunk'},
		{596,'*15 0% drunk'},

		{597,'*99 -80% tiny'},
		{597.1,'*8 0% tiny'},
		{597.5,'*99 -80% tiny'},
		{597.6,'*8 0% tiny'},
		{598,'*99 -80% tiny'},
		{598.1,'*8 0% tiny'},

		{600,'*8 flip'},
		{600.5,'*8 0% flip'},
		{601,'*99 -80% tiny'},
		{601.1,'*8 0% tiny'},

		{602.5,'*8 flip'},
		{603,'*8 0% flip'},

		{610,'*15 drunk'},
		{611,'*15 -100% drunk'},
		{612,'*15 0% drunk'},

		{613,'*99 -80% tiny'},
		{613.1,'*8 0% tiny'},
		{613.5,'*99 -80% tiny'},
		{613.6,'*8 0% tiny'},
		{614,'*99 -80% tiny'},
		{614.1,'*8 0% tiny'},

		{616,'*8 flip'},
		{616.5,'*8 0% flip'},
		{617,'*99 -80% tiny'},
		{617.1,'*8 0% tiny'},

		{618.5,'*8 flip'},
		{619,'*8 0% flip'},

		{626,'*15 drunk'},
		{627,'*15 -100% drunk'},
		{628,'*15 0% drunk'},

		{629,'*99 -80% tiny'},
		{629.1,'*8 0% tiny'},
		{629.5,'*99 -80% tiny'},
		{629.6,'*8 0% tiny'},
		{630,'*99 -80% tiny'},
		{630.1,'*8 0% tiny'},

		{632,'*8 flip'},
		{632.5,'*8 0% flip'},
		{633,'*99 -80% tiny'},
		{633.1,'*8 0% tiny'},

		{634.5,'*8 flip'},
		{635,'*8 0% flip'},

		{636,'*99 drunk'},
		{636.1,'*9 0% drunk'},
		{638,'*99 drunk'},
		{638.1,'*9 0% drunk'},

		{640,'*99 -40% tiny'},
		{640.1,'*30 0% tiny'},
		{640.5,'*99 -40% tiny'},
		{640.6,'*30 0% tiny'},
		{641,'*99 -40% tiny'},
		{641.1,'*30 0% tiny'},
		{641.5,'*99 -40% tiny'},
		{641.6,'*30 0% tiny'},
		{642,'*99 -40% tiny'},
		{642.1,'*30 0% tiny'},

		{643,'*99 -40% tiny'},
		{643.1,'*30 0% tiny'},

		{644,'*99 -40% tiny'},
		{644.1,'*30 0% tiny'},
		{644.5,'*99 -40% tiny'},
		{644.6,'*30 0% tiny'},
		{645,'*99 -40% tiny'},
		{645.1,'*30 0% tiny'},

		{645.75,'*99 -90% tiny'},
		{645.8,'*30 0% tiny'},

		{646.5,'*99 -90% tiny'},
		{646.6,'*30 0% tiny'},

		{647.5,'*99 -90% tiny'},
		{647.6,'*30 0% tiny'},
		{647.75,'*99 -90% tiny'},
		{647.8,'*30 0% tiny'},
		{648,'*99 -90% tiny'},
		{648.1,'*30 0% tiny'},

		{649,'*99 -90% tiny'},
		{649.1,'*30 0% tiny'},

		{649.5,'*99 -90% tiny'},
		{649.6,'*30 0% tiny'},

		{650.5,'*99 -90% tiny'},
		{650.6,'*30 0% tiny'},
		{650.75,'*99 -90% tiny'},
		{650.8,'*30 0% tiny'},
		{651,'*99 -90% tiny'},
		{651.1,'*30 0% tiny'},

		{652.25,'*99 -90% tiny'},
		{652.3,'*30 0% tiny'},

		{658.75,'*99 -90% tiny'},
		{658.8,'*30 0% tiny'},
		{659.25,'*99 -90% tiny'},
		{659.3,'*30 0% tiny'},

		{661.75,'*99 -90% tiny'},
		{661.8,'*30 0% tiny'},

		{662.25,'*99 -90% tiny'},
		{662.3,'*30 0% tiny'},

		{662.75,'*99 -90% tiny'},
		{662.8,'*30 0% tiny'},

		{663.5,'*99 -90% tiny'},
		{663.6,'*30 0% tiny'},

		{664.25,'*99 -90% tiny'},
		{664.3,'*30 0% tiny'},
		{664.75,'*99 -90% tiny'},
		{664.8,'*30 0% tiny'},

		{665.5,'*99 -90% tiny'},
		{665.6,'*30 0% tiny'},

		{667.5,'*99 -90% tiny'},
		{667.6,'*30 0% tiny'},

		{668.75,'*99 -90% tiny'},
		{668.8,'*30 0% tiny'},
		{669,'*99 -90% tiny'},
		{669.1,'*30 0% tiny'},
		{669.25,'*99 -90% tiny'},
		{669.3,'*30 0% tiny'},

		{670,'*99 -90% tiny'},
		{670.1,'*30 0% tiny'},

		{673.5,'*99 -90% tiny'},
		{673.6,'*30 0% tiny'},
		{674.5,'*99 -90% tiny'},
		{674.6,'*30 0% tiny'},


		
	}

	iris_driven = 1;
	iris_driven_beat = 193;
	iris_driven_beat_init = 193;

	iris_driven_speed = 0.65;
	iris_driven_modspeed = 1.0;

	iris_drunk = 1;
	iris_drunk_amt = 0;
	iris_bumpy = 1;
	iris_bumpy_amt = 0;

	--SCREAMING GUMBALL / timed message broadcaster
	curmessage = 1;
	--{beat,message,ignoreIfAhead}
	messages = {
		--{182.5,'CytusSpawn'},
		--{193,'CytusBegin'},
		--{257,'CytusEnd'},

		{128,'VibratePlayer'},
		{129.5,'VibratePlayerStop'},
		{144,'VibratePlayer'},
		{145.5,'VibratePlayerStop'},
		{160,'VibratePlayer'},
		{161.5,'VibratePlayerStop'},
		{176,'VibratePlayer'},
		{177.5,'VibratePlayerStop'},
		{192,'VibratePlayer'},
		{193.5,'VibratePlayerStop'},
		{256,'VibratePlayer'},
		{259,'VibratePlayerStop'},
		{288,'PlayerRight'},
		{289,'PlayerUp'},
		{290,'PlayerDown'},
		{291,'PlayerUp'},
		{292,'PlayerLeft'},
		{294,'PlayerRight'},
		{296,'PlayerDown'},
		{298,'PlayerUp'},
		{300,'PlayerLeft'},
		{302,'PlayerDown'},
		{304,'PlayerRestore'},
		{320,'VibratePlayer'},
		{323.5,'VibratePlayerStop'},
		{352,'PlayerLeft'},
		{353,'PlayerDown'},
		{354,'PlayerUp'},
		{355,'PlayerDown'},
		{356,'PlayerRight'},
		{358,'PlayerLeft'},
		{360,'PlayerUp'},
		{362,'PlayerDown'},
		{364,'PlayerRight'},
		{366,'PlayerUp'},
		{368,'PlayerRestore'},
		{384,'VibratePlayer'},
		{385.5,'VibratePlayerStop'},
		{416,'VibratePlayer'},
		{417.5,'VibratePlayerStop'},
		{576,'VibratePlayer'},
		{577.5,'VibratePlayerStop'},
		{592,'VibratePlayer'},
		{593.5,'VibratePlayerStop'},
		{608,'VibratePlayer'},
		{609.5,'VibratePlayerStop'},
		{624,'VibratePlayer'},
		{625.5,'VibratePlayerStop'},

	}
	
end

local function iris_update()

	if GAMESTATE:GetSongBeat()>=0.1 and not checked then
	
	if SCREENMAN:GetTopScreen():GetChild('PlayerP1') then
		P1 = SCREENMAN:GetTopScreen():GetChild('PlayerP1')
	end
			if P1 then
				P1xpos=P1:GetX();
				P1ypos=P1:GetY();
			end
	if SCREENMAN:GetTopScreen():GetChild('PlayerP2') then
		P2 = SCREENMAN:GetTopScreen():GetChild('PlayerP2')
	end
			if P2 then
				P2xpos=P2:GetX();
				P2ypos=P2:GetY();
			end
		--PE = SCREENMAN:GetTopScreen():GetChild('')
		
		screen = SCREENMAN:GetTopScreen()
		
		if P1 then
			P1:visible(false);
			P1:x(0);
			P1:y(0);
			wndrP1clone1:SetTarget(P1);
			wndrP1clone1:x(P1xpos);
			wndrP1clone1:y(P1ypos);
			
			
			wndrP1clone2:SetTarget(P1);
			wndrP1clone3:SetTarget(P1);
			wndrP1clone4:SetTarget(P1);
			
			wndrP1clone2:visible(false);
			wndrP1clone3:visible(false);
			wndrP1clone4:visible(false);
		end
		
		if P2 then
			P2:visible(false);
			P2:x(0);
			P2:y(0);
			wndrP2clone1:SetTarget(P2);
			wndrP2clone1:x(P2xpos);
			wndrP2clone1:y(P2ypos);
			
			
			wndrP2clone2:SetTarget(P2);
			wndrP2clone3:SetTarget(P2);
			wndrP2clone4:SetTarget(P2);
			
			wndrP2clone2:visible(false);
			wndrP2clone3:visible(false);
			wndrP2clone4:visible(false);
		end
		checked = true;
		
	end
	
	local beat = GAMESTATE:GetSongBeat()

	-- Collect all the mods that will be applied in this frame into one string.
	-- Mod tweening doesn't work correctly if the mods are in seperate commands.
	local mods_this_frame= {}
	local function add_mod(mod_str)
		mods_this_frame[#mods_this_frame+1]= mod_str
	end
	local function execute_mods()
		if #mods_this_frame <= 0 then return end
		local total_mod_str= ""
		for i, ms in ipairs(mods_this_frame) do
			if #total_mod_str > 0 then
				total_mod_str= total_mod_str .. ", "
			end
			total_mod_str= total_mod_str .. ms
		end
		iris_mod(total_mod_str)
	end
	
	--[[
	
	if beat>257 and fgcurcommand == 3 then
		set_player_speed(PLAYER_1, iris_speedmodP1)
		set_player_speed(PLAYER_2, iris_speedmodP2)
		add_mod('*1000 no reverse')
		add_mod('*1000 no centered')
		add_mod('*1000 no dark')
		fgcurcommand = fgcurcommand+1
	end --]]
	
	while curmod<= #mods and GAMESTATE:GetSongBeat()>=mods[curmod][1] do
		add_mod(mods[curmod][2])
		curmod = curmod+1
	end

	execute_mods()
	
	--SCREAMING GUMBALL
	while curmessage<= #messages and GAMESTATE:GetSongBeat()>=messages[curmessage][1] do
		if messages[curmessage][3] and GAMESTATE:GetSongBeat()>=messages[curmessage][1]+5 then
			curmessage = curmessage+1;
		else
			MESSAGEMAN:Broadcast(messages[curmessage][2])
			curmessage = curmessage+1;
		end
	end
end

return Def.ActorFrame{
	OnCommand= function(self)
							 iris_init()
							 self:SetUpdateFunction(iris_update)
						 end,
	Def.Quad{
		Name= "I may be sleeping, but I preserve the world.",
		InitCommand= cmd(visible,false),
		OnCommand= cmd(sleep,1000),
	},
	Def.Quad{
		OnCommand= cmd(diffuse,0,0,0,1;diffusealpha,0;zoomto,6,SCREEN_HEIGHT;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y),
		CytusSpawnMessageCommand= cmd(linear,1;diffusealpha,1),
		CytusEndMessageCommand= cmd(linear,1;diffusealpha,0),
		
		PlayersRot1MessageCommand= function(self)
			if P1 then
			P1:decelerate(.3)
			P1:rotationz(90)
			end
			
			if P2 then
			P2:decelerate(.3)
			P2:rotationz(-90)
			end
		end,
		
		PlayersRot2MessageCommand= function(self)
			if P1 then
			P1:decelerate(.3)
			P1:rotationz(-90)
			end
			
			if P2 then
			P2:decelerate(.3)
			P2:rotationz(90)
			end
		end,
		
		PlayersRot0MessageCommand= function(self)
			if P1 then
			P1:decelerate(.3)
			P1:rotationz(0)
			end
			
			if P2 then
			P2:decelerate(.3)
			P2:rotationz(0)
			end
		end,
		
		PlayersSkew1MessageCommand= function(self)
			if P1 then
			P1:smooth(0.10)
			P1:skewx(wndr_skewx)
			end
			
			--PE:skewx(wndr_skewx)
			
			if P2 then
			P2:smooth(0.10)
			P2:skewx(-wndr_skewx)
			end
		end,
		
		PlayersSkew2MessageCommand= function(self)
			if P1 then
			P1:smooth(0.10)
			P1:skewx(-wndr_skewx)
			end
			
			if P2 then
			P2:smooth(0.10)
			P2:skewx(wndr_skewx)
			end
		end,
		
		PlayersSkew0MessageCommand= function(self)
			if P1 then
			P1:stoptweening()
			P1:linear(0.25)
			P1:skewx(0)
			end
			
			if P2 then
			P2:stoptweening()
			P2:linear(0.25)
			P2:skewx(0)
			end
		end,

		PlayerRotateRightMessageCommand= function(self)
			if P1 then
			P1:addz(90)
			end
			
			if P2 then
			P2:addz(90)
			end
		end,

		PlayerRotateLeftMessageCommand= function(self)
			if P1 then
			P1:addz(-90)
			end
			
			if P2 then
			P2:addz(-90)
			end
		end,

		PlayerRotateRestoreMessageCommand= function(self)
			if P1 then
			P1:rotationz(0)
			end
			
			if P2 then
			P2:rotationz(0)
			end
		end,

		PlayerLeftMessageCommand= function(self)
			if P1 then
			P1:linear(0.1)
			P1:rotationz(270)
			end
			
			if P2 then
			P2:linear(0.1)
			P2:rotationz(270)
			end
		end,

		PlayerRightMessageCommand= function(self)
			if P1 then
			P1:linear(0.1)
			P1:rotationz(90)
			end
			
			if P2 then
			P2:linear(0.1)
			P2:rotationz(90)
			end
		end,

		PlayerDownMessageCommand= function(self)
			if P1 then
			P1:linear(0.1)
			P1:rotationz(180)
			end
			
			if P2 then
			P2:linear(0.1)
			P2:rotationz(180)
			end
		end,

		PlayerUpMessageCommand= function(self)
			if P1 then
			P1:linear(0.1)
			P1:rotationz(0)
			end
			
			if P2 then
			P2:linear(0.1)
			P2:rotationz(0)
			end
		end,

		PlayerRestoreMessageCommand= function(self)
			if P1 then
			P1:smooth(0.9)
			P1:rotationz(0)
			end
			
			if P2 then
			P2:linear(0.1)
			P2:rotationz(0)
			end
		end,


		-- Vibration commands
		VibratePlayerMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):vibrate();
			SCREENMAN:GetTopScreen():effectmagnitude(20,20,20);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):vibrate();
			SCREENMAN:GetTopScreen():effectmagnitude(20,20,20);
		end,

		VibratePlayerStopMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):stopeffect();
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):stopeffect();
		end,

		VibrateMessageCommand= function(self)
			SCREENMAN:GetTopScreen():vibrate();
			SCREENMAN:GetTopScreen():effectmagnitude(20,20,20);
		end,

		VibratestopMessageCommand= function(self)
			SCREENMAN:GetTopScreen():stopeffect();
		end,

		BounceMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectperiod(1)
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectmagnitude(0,-15,0)
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectperiod(1)
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectmagnitude(0,-15,0)
        end,

        BouncefasterMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectperiod(.5)
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectmagnitude(0,-15,0)
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectperiod(.5)
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectmagnitude(0,-15,0)
        end,

        BouncefastererMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectperiod(.25)
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectmagnitude(0,-15,0)
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectperiod(.25)
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectmagnitude(0,-15,0)
        end,

        BounceSomewereElseMessageCommand= function(self)
        	self:sleep(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectperiod(1)
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectmagnitude(20,-15,15)
        end,

        BouncestopMessageCommand= function(self)
        	SCREENMAN:GetTopScreen():GetChild('PlayerP1'):stopeffect();
        	SCREENMAN:GetTopScreen():GetChild('PlayerP2'):stopeffect();
        end,

        SlidestuffoffstopMessageCommand= function(self)
        	SCREENMAN:GetTopScreen():GetChild('PlayerP1'):decelerate(1.4);
        	SCREENMAN:GetTopScreen():GetChild('PlayerP1'):x(-1000);
        	SCREENMAN:GetTopScreen():GetChild('LifeP1'):decelerate(1.4);
            SCREENMAN:GetTopScreen():GetChild('LifeP1'):x(-1000);
            SCREENMAN:GetTopScreen():GetChild('ScoreP1'):decelerate(1.4);
            SCREENMAN:GetTopScreen():GetChild('ScoreP1'):x(-1000);
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Combo'):decelerate(1.4);
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Combo'):x(-1000);
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Judgment'):decelerate(1.4);
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Judgment'):x(-1000);
        end,

        DivideClonesMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:addx(250);
				wndrP1clone2:addx(-250);
				wndrP1clone3:Vibrate();
				wndrP1clone4:Vibrate();
			end
		end,

		LetsmakeeverythinggoupexceptforthenotefieldMessageCommand= function(self)
			if P1 then
			self:sleep(0);
			SCREENMAN:GetTopScreen():y(-500);
			P1:y(500)
			end
			
			if P2 then
			P2:y(500)
			end
		end,

		MainDissapearsMessageCommand= function(self)
			if P1 then
			self:sleep(0);
			SCREENMAN:GetTopScreen():smooth(0.2);
			SCREENMAN:GetTopScreen():GetChild('Background'):diffusealpha(0);
			end
			
			if P2 then
			P2:y(500)
			end
		end,

		BackUpMessageCommand= function(self)
			if P1 then
			self:sleep(0);
			SCREENMAN:GetTopScreen():smooth(.8);
			P1:smooth(.8)
			SCREENMAN:GetTopScreen():y(0);
			P1:y(0)
			end
			
			if P2 then
			P2:smooth(.8)
			P2:y(0)
			end
		end,

		ChangethebeatofthesongpleaseMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):addx(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):addy(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):addz(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationx(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationy(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationz(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):addx(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):addy(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):addz(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationx(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationy(math.random(-50,50));
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationz(math.random(-50,50));
		end,

		ChangethebeatbackMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):x(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):y(500);
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):z(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationx(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationy(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationz(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):x(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):y(500);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):z(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationx(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationy(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationz(0);
		end,
		
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		
		
		ClonesSetMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				wndrP1clone1:visible(true);
				wndrP1clone2:visible(true);
				wndrP1clone3:visible(true);
				wndrP1clone4:visible(true);
				
				wndrP1clone2:x(wndrP1clone1:GetX()+64);
				wndrP1clone3:x(wndrP1clone1:GetX()+128);
				wndrP1clone4:x(wndrP1clone1:GetX()+192);
				
				wndrP1clone2:y(wndrP1clone1:GetY()+450);
				wndrP1clone3:y(wndrP1clone1:GetY()+450);
				wndrP1clone4:y(wndrP1clone1:GetY()+450);
			end
			
			if P2 then
				wndrP2clone1:visible(true);
				wndrP2clone2:visible(true);
				wndrP2clone3:visible(true);
				wndrP2clone4:visible(true);
				
				wndrP2clone2:x(wndrP2clone1:GetX()-64);
				wndrP2clone3:x(wndrP2clone1:GetX()-128);
				wndrP2clone4:x(wndrP2clone1:GetX()-192);
				
				wndrP2clone2:y(wndrP2clone1:GetY()+450);
				wndrP2clone3:y(wndrP2clone1:GetY()+450);
				wndrP2clone4:y(wndrP2clone1:GetY()+450);
			end
		end,
		
		DropFirstMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:smooth(0.345);
				wndrP1clone1:addy(450);
				wndrP1clone1:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone1:smooth(0.345);
				wndrP2clone1:addy(450);
				wndrP2clone1:rotationz(20);
			end
		end,
		
		
		FirstJumpMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:sleep(0);
				wndrP1clone1:rotationz(-20);
				wndrP1clone1:smooth(0.345*2);
				wndrP1clone1:addy(-450);
				wndrP1clone1:rotationz(0);
				wndrP1clone1:smooth(0.345*2);
				wndrP1clone1:addy(450);
				wndrP1clone1:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone1:sleep(0);
				wndrP2clone1:rotationz(-20);
				wndrP2clone1:smooth(0.345*2);
				wndrP2clone1:addy(-450);
				wndrP2clone1:rotationz(0);
				wndrP2clone1:smooth(0.345*2);
				wndrP2clone1:addy(450);
				wndrP2clone1:rotationz(20);
			end
		end,
		
		
		SecondJumpMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone2:sleep(0);
				wndrP1clone2:rotationz(-20);
				wndrP1clone2:smooth(0.345*2);
				wndrP1clone2:addy(-450);
				wndrP1clone2:rotationz(0);
				wndrP1clone2:smooth(0.345*2);
				wndrP1clone2:addy(450);
				wndrP1clone2:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone2:sleep(0);
				wndrP2clone2:rotationz(-20);
				wndrP2clone2:smooth(0.345*2);
				wndrP2clone2:addy(-450);
				wndrP2clone2:rotationz(0);
				wndrP2clone2:smooth(0.345*2);
				wndrP2clone2:addy(450);
				wndrP2clone2:rotationz(20);
			end
		end,
		
		ThirdJumpMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone3:sleep(0);
				wndrP1clone3:rotationz(-20);
				wndrP1clone3:smooth(0.345*2);
				wndrP1clone3:addy(-450);
				wndrP1clone3:rotationz(0);
				wndrP1clone3:smooth(0.345*2);
				wndrP1clone3:addy(450);
				wndrP1clone3:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone3:sleep(0);
				wndrP2clone3:rotationz(-20);
				wndrP2clone3:smooth(0.345*2);
				wndrP2clone3:addy(-450);
				wndrP2clone3:rotationz(0);
				wndrP2clone3:smooth(0.345*2);
				wndrP2clone3:addy(450);
				wndrP2clone3:rotationz(20);
			end
		end,
		
		FourthJumpMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone4:sleep(0);
				wndrP1clone4:rotationz(-20);
				wndrP1clone4:smooth(0.345*2);
				wndrP1clone4:addy(-450);
				wndrP1clone4:rotationz(0);
				wndrP1clone4:smooth(0.345*2);
				wndrP1clone4:addy(450);
				wndrP1clone4:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone4:sleep(0);
				wndrP2clone4:rotationz(-20);
				wndrP2clone4:smooth(0.345*2);
				wndrP2clone4:addy(-450);
				wndrP2clone4:rotationz(0);
				wndrP2clone4:smooth(0.345*2);
				wndrP2clone4:addy(450);
				wndrP2clone4:rotationz(20);
			end
		end,
		
		FourthSetMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone4:sleep(0);
				wndrP1clone4:rotationz(-20);
				wndrP1clone4:smooth(0.345*2);
				wndrP1clone4:x(P1xpos);
				wndrP1clone4:y(P1ypos);
				wndrP1clone4:rotationz(0);
			end
			
			if P1 then
				
				wndrP2clone4:sleep(0);
				wndrP2clone4:rotationz(-20);
				wndrP2clone4:smooth(0.345*2);
				wndrP2clone4:x(P2xpos);
				wndrP2clone4:y(P2ypos);
				wndrP2clone4:rotationz(0);
			end
		end,
		
		HideRestMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:visible(false);
				wndrP1clone2:visible(false);
				wndrP1clone3:visible(false);
			end
			
			if P2 then
				
				wndrP2clone1:visible(false);
				wndrP2clone2:visible(false);
				wndrP2clone3:visible(false);
			end
		end,
		
		------------------------------------------------
		------------------------------------------------
		------------------------------------------------
		----------BRIDGE THING PART MOD THINGY----------
		------------------------------------------------
		------------------------------------------------
		------------------------------------------------
		
		SetRestMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:visible(true);
				wndrP1clone1:x(P1xpos);
				wndrP1clone1:y(P1ypos+450);
				wndrP1clone1:rotationz(0);
				
				wndrP1clone2:visible(true);
				wndrP1clone2:x(P1xpos);
				wndrP1clone2:y(P1ypos+450);
				wndrP1clone2:rotationz(0);
				
				wndrP1clone3:visible(true);
				wndrP1clone3:x(P1xpos);
				wndrP1clone3:y(P1ypos+450);
				wndrP1clone3:rotationz(0);
			end
			
			if P2 then
				
				wndrP2clone1:visible(true);
				wndrP2clone1:x(P2xpos);
				wndrP2clone1:y(P2ypos+450);
				wndrP2clone1:rotationz(0);
				
				wndrP2clone2:visible(true);
				wndrP2clone2:x(P2xpos);
				wndrP2clone2:y(P2ypos+450);
				wndrP2clone2:rotationz(0);
				
				wndrP2clone3:visible(true);
				wndrP2clone3:x(P2xpos);
				wndrP2clone3:y(P2ypos+450);
				wndrP2clone3:rotationz(0);
			end
		end,
		
		PopThirdMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone3:zoom(0.9);
				wndrP1clone3:smooth(1);
				wndrP1clone3:x(P1xpos+100);
				wndrP1clone3:y(P1ypos+100);
				wndrP1clone3:rotationz(40);
				wndrP1clone3:sleep(2);
				wndrP1clone3:smooth(1);
				wndrP1clone3:x(P1xpos);
				wndrP1clone3:y(P1ypos+450);
				wndrP1clone3:rotationz(0);
			end
			
			if P2 then
								
				wndrP2clone3:zoom(0.9);
				wndrP2clone3:smooth(1);
				wndrP2clone3:x(P2xpos-100);
				wndrP2clone3:y(P2ypos+100);
				wndrP2clone3:rotationz(-40);
				wndrP2clone3:sleep(2);
				wndrP2clone3:smooth(1);
				wndrP2clone3:x(P2xpos);
				wndrP2clone3:y(P2ypos+450);
				wndrP2clone3:rotationz(0);
			end
		end,
		
		PopSecondMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone2:zoom(0.8);
				wndrP1clone2:smooth(1);
				wndrP1clone2:x(P1xpos-100);
				wndrP1clone2:y(P1ypos+120);
				wndrP1clone2:rotationz(-40);
				wndrP1clone2:sleep(2);
				wndrP1clone2:smooth(1);
				wndrP1clone2:x(P1xpos);
				wndrP1clone2:y(P1ypos+450);
				wndrP1clone2:rotationz(0);
			end
			
			if P2 then
								
				wndrP2clone2:zoom(0.8);
				wndrP2clone2:smooth(1);
				wndrP2clone2:x(P2xpos+100);
				wndrP2clone2:y(P2ypos+120);
				wndrP2clone2:rotationz(40);
				wndrP2clone2:sleep(2);
				wndrP2clone2:smooth(1);
				wndrP2clone2:x(P2xpos);
				wndrP2clone2:y(P2ypos+450);
				wndrP2clone2:rotationz(0);
			end
		end,
		
		PopFirstMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone1:zoom(0.7);
				wndrP1clone1:smooth(1);
				wndrP1clone1:x(P1xpos);
				wndrP1clone1:y(P1ypos+140);
				wndrP1clone1:rotationz(0);
				wndrP1clone1:sleep(2);
				wndrP1clone1:smooth(1);
				wndrP1clone1:x(P1xpos);
				wndrP1clone1:y(P1ypos+450);
				wndrP1clone1:rotationz(0);
			end
			
			if P2 then
								
				wndrP2clone1:zoom(0.7);
				wndrP2clone1:smooth(1);
				wndrP2clone1:x(P2xpos);
				wndrP2clone1:y(P2ypos+140);
				wndrP2clone1:rotationz(0);
				wndrP2clone1:sleep(2);
				wndrP2clone1:smooth(1);
				wndrP2clone1:x(P2xpos);
				wndrP2clone1:y(P2ypos+450);
				wndrP2clone1:rotationz(0);
			end
		end,
		
		
		-------------------------------------------
		-------------------------------------------
		-------------------------------------------
		
		RaiseThirdMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone3:x(P1xpos-130);
				wndrP1clone3:zoom(0.7);
				wndrP1clone3:decelerate(0.5);
				wndrP1clone3:x(P1xpos-130);
				wndrP1clone3:y(P1ypos+100);
				wndrP1clone3:rotationz(0);
			end
			
			if P2 then
				
				wndrP2clone3:x(P2xpos+130);				
				wndrP2clone3:zoom(0.7);
				wndrP2clone3:decelerate(0.5);
				wndrP2clone3:x(P2xpos+130);
				wndrP2clone3:y(P2ypos+100);
				wndrP2clone3:rotationz(0);
			end
		end,
		
		LowerFourthMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone4:smooth(1);
				wndrP1clone4:y(P1ypos+64);
			end
			
			if P2 then
								
				wndrP2clone4:smooth(1);
				wndrP2clone4:y(P2ypos+64);
			end
		end,
		
		LowerBothMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone4:smooth(1);
				wndrP1clone4:y(P1ypos+64+64);
				
				wndrP1clone3:smooth(1);
				wndrP1clone3:y(P1ypos+100+80);
			end
			
			if P2 then
								
				wndrP2clone4:smooth(1);
				wndrP2clone4:y(P2ypos+64+64);
				wndrP2clone3:smooth(1);
				wndrP2clone3:y(P2ypos+100+80);
			end
		end,
		
		LowerBothAgainMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone4:smooth(1);
				wndrP1clone4:y(P1ypos+64+64+64);
				
				wndrP1clone3:smooth(1);
				wndrP1clone3:y(P1ypos+100+70+70);
			end
			
			if P2 then
								
				wndrP2clone4:smooth(1);
				wndrP2clone4:y(P2ypos+64+64+64);
				wndrP2clone3:smooth(1);
				wndrP2clone3:y(P2ypos+100+70+70);
			end
		end,
		
		
		RaiseSecondMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone2:x(P1xpos+110);
				wndrP1clone2:zoom(0.6);
				wndrP1clone2:decelerate(0.5);
				wndrP1clone2:y(P1ypos+120);
				
			end
			
			if P2 then
				
				wndrP2clone2:x(P2xpos-110);
				wndrP2clone2:zoom(0.6);
				wndrP2clone2:decelerate(0.5);
				wndrP2clone2:y(P2ypos+120);
			end
		end,
		
		RaiseAllMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone2:smooth(0.7);
				wndrP1clone2:y(P1ypos+120-64);
				
				wndrP1clone3:smooth(0.7);
				wndrP1clone3:y(P1ypos+64);
				
				wndrP1clone4:smooth(0.7);
				wndrP1clone4:y(P1ypos);
				
				
			end
			
			if P2 then
				
				wndrP2clone2:smooth(0.7);
				wndrP2clone2:y(P2ypos+120-64);
				
				wndrP2clone3:smooth(0.7);
				wndrP2clone3:y(P2ypos+64);
				
				wndrP2clone4:smooth(0.7);
				wndrP2clone4:y(P2ypos);
			end
		end,
		
		LowerAllMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone2:smooth(0.7);
				wndrP1clone2:y(P1ypos+120);
				
				wndrP1clone3:smooth(0.7);
				wndrP1clone3:y(P1ypos+100+70);
				
				wndrP1clone4:smooth(0.7);
				wndrP1clone4:y(P1ypos+64);
				
				
			end
			
			if P2 then
				
				wndrP2clone2:smooth(0.7);
				wndrP2clone2:y(P2ypos+120);
				
				wndrP2clone3:smooth(0.7);
				wndrP2clone3:y(P2ypos+100+70);
				
				wndrP2clone4:smooth(0.7);
				wndrP2clone4:y(P2ypos+64);
			end
		end,
		
		FlyAwayMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone2:smooth(1);
				wndrP1clone2:y(P1ypos-500);
				
				wndrP1clone3:smooth(1);
				wndrP1clone3:y(P1ypos-500);
				
				wndrP1clone4:smooth(0.5);
				wndrP1clone4:y(P1ypos);
				
				
			end
			
			if P2 then
				
				wndrP2clone2:smooth(1);
				wndrP2clone2:y(P2ypos-500);
				
				wndrP2clone3:smooth(1);
				wndrP2clone3:y(P2ypos-500);
				
				wndrP2clone4:smooth(0.5);
				wndrP2clone4:y(P2ypos);
			end
		end,
		
		Hide123MessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone1:visible(false);
				wndrP1clone2:visible(false);
				wndrP1clone3:visible(false);

			end
			
			if P2 then
				
				wndrP2clone1:visible(false);
				wndrP2clone2:visible(false);
				wndrP2clone3:visible(false);
			end
		end,
		
----------------------------------------
	
	WagPlayersMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				P1:wag();
				P1:effectclock('bgm');
				P1:effectmagnitude(0,0,30);
				P1:effectperiod(2);
			end
			
			if P2 then
								
				P2:wag();
				P2:effectclock('bgm');
				P2:effectmagnitude(0,0,-30);
				P2:effectperiod(2);
			end
		end,
	},
	
	--------------------------------------------------------
	--------------------------------------------------------
	--------------------------------------------------------
	-------------HERE LIES THE ACTOR PROXIES----------------
	--------------------------------------------------------
	--------------------------------------------------------
	--------------------------------------------------------
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone1=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone2=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone3=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone4=self;
			
		end;
	};
	
	
	------
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone1=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone2=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone3=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone4=self;
			
		end;
	};
	
}
