
local songName= GAMESTATE:GetCurrentSong():GetSongDir()

local function iris_mod_internal(str, pn)
	local ps= GAMESTATE:GetPlayerState(pn)
	local pmods= ps:GetPlayerOptionsString('ModsLevel_Song')
	ps:SetPlayerOptions('ModsLevel_Song', pmods .. ', ' .. str)
	--GAMESTATE:ApplyGameCommand('mod,'..str, pn)
end


local function iris_mod(str)
	for i=1,2 do
		iris_mod_internal(str, 'PlayerNumber_P' .. i)
	end
end



local function iris_init()
	fgcurcommand = 0;
	wndr_skewx=0.3;
	checked = false;
	
	
	
	--lua course :D	/ timed mod management	
	curmod = 1;
	--{beat,mod,player}
	mods = {

		{0.1,'*1000 2.6x'},
		{1,'*100000 280% drunk, *100000 60% tornado'},
		{1.1,'*9 0% drunk, *9 0% tornado'},
		{3,'*100000 280% drunk, *100000 60% tornado'},
		{3.1,'*9 0% drunk, *9 0% tornado'},
		{5,'*100000 280% drunk, *100000 60% tornado'},
		{5.1,'*9 0% drunk, *9 0% tornado'},
		{7,'*100000 280% drunk, *100000 60% tornado'},
		{7.1,'*9 0% drunk, *9 0% tornado'},

		-- The vocals begin here.
		{8,'*99 30% stealth'},
		{8.1,'*9 0% stealth,'},
		{8.25,'*99 30% stealth'},
		{8.3,'*9 0% stealth,'},
		{8.5,'*99 30% stealth'},
		{8.6,'*9 0% stealth,'},
		{8.75,'*99 30% stealth'},
		{8.8,'*9 0% stealth,'},

		{9,'*99 30% stealth'},
		{9.1,'*9 0% stealth,'},
		{9.25,'*99 30% stealth'},
		{9.3,'*9 0% stealth,'},
		{9.5,'*99 30% stealth'},
		{9.6,'*9 0% stealth,'},
		{9.75,'*99 30% stealth'},
		{9.8,'*9 0% stealth,'},

		{10,'*99 30% stealth'},
		{10.1,'*9 0% stealth,'},
		{10.25,'*99 30% stealth'},
		{10.3,'*9 0% stealth,'},
		{10.5,'*99 30% stealth'},
		{10.6,'*9 0% stealth,'},
		{10.75,'*99 30% stealth'},
		{10.8,'*9 0% stealth,'},

		{11,'*99 30% stealth'},
		{11.1,'*9 0% stealth,'},
		{11.25,'*99 30% stealth'},
		{11.3,'*9 0% stealth,'},
		{11.5,'*99 30% stealth'},
		{11.6,'*9 0% stealth,'},
		{11.75,'*99 30% stealth'},
		{11.8,'*9 0% stealth,'},

		{12,'*99 30% stealth'},
		{12.1,'*9 0% stealth,'},
		{12.25,'*99 30% stealth'},
		{12.3,'*9 0% stealth,'},
		{12.5,'*99 30% stealth'},
		{12.6,'*9 0% stealth,'},
		{12.75,'*99 30% stealth'},
		{12.8,'*9 0% stealth,'},

		{13,'*99 30% stealth'},
		{13.1,'*9 0% stealth,'},
		{13.25,'*99 30% stealth'},
		{13.3,'*9 0% stealth,'},
		{13.5,'*99 30% stealth'},
		{13.6,'*9 0% stealth,'},
		{13.75,'*99 30% stealth'},
		{13.8,'*9 0% stealth,'},

		{14,'*99 30% stealth'},
		{14.1,'*9 0% stealth,'},
		{14.25,'*99 30% stealth'},
		{14.3,'*9 0% stealth,'},
		{14.5,'*99 30% stealth'},
		{14.6,'*9 0% stealth,'},
		{14.75,'*99 30% stealth'},
		{14.8,'*9 0% stealth,'},

		{15,'*99 30% stealth'},
		{15.1,'*9 0% stealth,'},
		{15.25,'*99 30% stealth'},
		{15.3,'*9 0% stealth,'},
		{15.5,'*99 30% stealth'},
		{15.6,'*9 0% stealth,'},
		{15.75,'*99 30% stealth'},
		{15.8,'*9 0% stealth,'},

		-- So, i decided to repeat the vocals, like i did in the cureffect, so yeah.
		{8+8,'*99 30% stealth'},
		{8+8.1,'*9 0% stealth,'},
		{8+8.25,'*99 30% stealth'},
		{8+8.3,'*9 0% stealth,'},
		{8+8.5,'*99 30% stealth'},
		{8+8.6,'*9 0% stealth,'},
		{8+8.75,'*99 30% stealth'},
		{8+8.8,'*9 0% stealth,'},

		{8+9,'*99 30% stealth'},
		{8+9.1,'*9 0% stealth,'},
		{8+9.25,'*99 30% stealth'},
		{8+9.3,'*9 0% stealth,'},
		{8+9.5,'*99 30% stealth'},
		{8+9.6,'*9 0% stealth,'},
		{8+9.75,'*99 30% stealth'},
		{8+9.8,'*9 0% stealth,'},

		{8+10,'*99 30% stealth'},
		{8+10.1,'*9 0% stealth,'},
		{8+10.25,'*99 30% stealth'},
		{8+10.3,'*9 0% stealth,'},
		{8+10.5,'*99 30% stealth'},
		{8+10.6,'*9 0% stealth,'},
		{8+10.75,'*99 30% stealth'},
		{8+10.8,'*9 0% stealth,'},

		{8+11,'*99 30% stealth'},
		{8+11.1,'*9 0% stealth,'},
		{8+11.25,'*99 30% stealth'},
		{8+11.3,'*9 0% stealth,'},
		{8+11.5,'*99 30% stealth'},
		{8+11.6,'*9 0% stealth,'},
		{8+11.75,'*99 30% stealth'},
		{8+11.8,'*9 0% stealth,'},

		{8+12,'*99 30% stealth'},
		{8+12.1,'*9 0% stealth,'},
		{8+12.25,'*99 30% stealth'},
		{8+12.3,'*9 0% stealth,'},
		{8+12.5,'*99 30% stealth'},
		{8+12.6,'*9 0% stealth,'},
		{8+12.75,'*99 30% stealth'},
		{8+12.8,'*9 0% stealth,'},

		{8+13,'*99 30% stealth'},
		{8+13.1,'*9 0% stealth,'},
		{8+13.25,'*99 30% stealth'},
		{8+13.3,'*9 0% stealth,'},
		{8+13.5,'*99 30% stealth'},
		{8+13.6,'*9 0% stealth,'},
		{8+13.75,'*99 30% stealth'},
		{8+13.8,'*9 0% stealth,'},

		{8+14,'*99 30% stealth'},
		{8+14.1,'*9 0% stealth,'},
		{8+14.25,'*99 30% stealth'},
		{8+14.3,'*9 0% stealth,'},
		{8+14.5,'*99 30% stealth'},
		{8+14.6,'*9 0% stealth,'},
		{8+14.75,'*99 30% stealth'},
		{8+14.8,'*9 0% stealth,'},

		{8+15,'*99 30% stealth'},
		{8+15.1,'*9 0% stealth,'},
		{8+15.25,'*99 30% stealth'},
		{8+15.3,'*9 0% stealth,'},
		{8+15.5,'*99 30% stealth'},
		{8+15.6,'*9 0% stealth,'},
		{8+15.75,'*99 30% stealth'},
		{8+15.8,'*9 0% stealth,'},

		{16+8,'*99 30% stealth'},
		{16+8.1,'*9 0% stealth,'},
		{16+8.25,'*99 30% stealth'},
		{16+8.3,'*9 0% stealth,'},
		{16+8.5,'*99 30% stealth'},
		{16+8.6,'*9 0% stealth,'},
		{16+8.75,'*99 30% stealth'},
		{16+8.8,'*9 0% stealth,'},

		{16+9,'*99 30% stealth'},
		{16+9.1,'*9 0% stealth,'},
		{16+9.25,'*99 30% stealth'},
		{16+9.3,'*9 0% stealth,'},
		{16+9.5,'*99 30% stealth'},
		{16+9.6,'*9 0% stealth,'},
		{16+9.75,'*99 30% stealth'},
		{16+9.8,'*9 0% stealth,'},

		{16+10,'*99 30% stealth'},
		{16+10.1,'*9 0% stealth,'},
		{16+10.25,'*99 30% stealth'},
		{16+10.3,'*9 0% stealth,'},
		{16+10.5,'*99 30% stealth'},
		{16+10.6,'*9 0% stealth,'},
		{16+10.75,'*99 30% stealth'},
		{16+10.8,'*9 0% stealth,'},

		{16+11,'*99 30% stealth'},
		{16+11.1,'*9 0% stealth,'},
		{16+11.25,'*99 30% stealth'},
		{16+11.3,'*9 0% stealth,'},
		{16+11.5,'*99 30% stealth'},
		{16+11.6,'*9 0% stealth,'},
		{16+11.75,'*99 30% stealth'},
		{16+11.8,'*9 0% stealth,'},

		{16+12,'*99 30% stealth'},
		{16+12.1,'*9 0% stealth,'},
		{16+12.25,'*99 30% stealth'},
		{16+12.3,'*9 0% stealth,'},
		{16+12.5,'*99 30% stealth'},
		{16+12.6,'*9 0% stealth,'},
		{16+12.75,'*99 30% stealth'},
		{16+12.8,'*9 0% stealth,'},

		{16+13,'*99 30% stealth'},
		{16+13.1,'*9 0% stealth,'},
		{16+13.25,'*99 30% stealth'},
		{16+13.3,'*9 0% stealth,'},
		{16+13.5,'*99 30% stealth'},
		{16+13.6,'*9 0% stealth,'},
		{16+13.75,'*99 30% stealth'},
		{16+13.8,'*9 0% stealth,'},

		{16+14,'*99 30% stealth'},
		{16+14.1,'*9 0% stealth,'},
		{16+14.25,'*99 30% stealth'},
		{16+14.3,'*9 0% stealth,'},
		{16+14.5,'*99 30% stealth'},
		{16+14.6,'*9 0% stealth,'},
		{16+14.75,'*99 30% stealth'},
		{16+14.8,'*9 0% stealth,'},

		{16+15,'*99 30% stealth'},
		{16+15.1,'*9 0% stealth,'},
		{16+15.25,'*99 30% stealth'},
		{16+15.3,'*9 0% stealth,'},
		{16+15.5,'*99 30% stealth'},
		{16+15.6,'*9 0% stealth,'},
		{16+15.75,'*99 30% stealth'},
		{16+15.8,'*9 0% stealth,'},

		{24+8,'*99 30% stealth'},
		{24+8.1,'*9 0% stealth,'},
		{24+8.25,'*99 30% stealth'},
		{24+8.3,'*9 0% stealth,'},
		{24+8.5,'*99 30% stealth'},
		{24+8.6,'*9 0% stealth,'},
		{24+8.75,'*99 30% stealth'},
		{24+8.8,'*9 0% stealth,'},

		{24+9,'*99 30% stealth'},
		{24+9.1,'*9 0% stealth,'},
		{24+9.25,'*99 30% stealth'},
		{24+9.3,'*9 0% stealth,'},
		{24+9.5,'*99 30% stealth'},
		{24+9.6,'*9 0% stealth,'},
		{24+9.75,'*99 30% stealth'},
		{24+9.8,'*9 0% stealth,'},

		{24+10,'*99 30% stealth'},
		{24+10.1,'*9 0% stealth,'},
		{24+10.25,'*99 30% stealth'},
		{24+10.3,'*9 0% stealth,'},
		{24+10.5,'*99 30% stealth'},
		{24+10.6,'*9 0% stealth,'},
		{24+10.75,'*99 30% stealth'},
		{24+10.8,'*9 0% stealth,'},

		{24+11,'*99 30% stealth'},
		{24+11.1,'*9 0% stealth,'},
		{24+11.25,'*99 30% stealth'},
		{24+11.3,'*9 0% stealth,'},
		{24+11.5,'*99 30% stealth'},
		{24+11.6,'*9 0% stealth,'},
		{24+11.75,'*99 30% stealth'},
		{24+11.8,'*9 0% stealth,'},

		{24+12,'*99 30% stealth'},
		{24+12.1,'*9 0% stealth,'},
		{24+12.25,'*99 30% stealth'},
		{24+12.3,'*9 0% stealth,'},
		{24+12.5,'*99 30% stealth'},
		{24+12.6,'*9 0% stealth,'},
		{24+12.75,'*99 30% stealth'},
		{24+12.8,'*9 0% stealth,'},

		{24+13,'*99 30% stealth'},
		{24+13.1,'*9 0% stealth,'},
		{24+13.25,'*99 30% stealth'},
		{24+13.3,'*9 0% stealth,'},
		{24+13.5,'*99 30% stealth'},
		{24+13.6,'*9 0% stealth,'},
		{24+13.75,'*99 30% stealth'},
		{24+13.8,'*9 0% stealth,'},

		{24+14,'*99 30% stealth'},
		{24+14.1,'*9 0% stealth,'},
		{24+14.25,'*99 30% stealth'},
		{24+14.3,'*9 0% stealth,'},
		{24+14.5,'*99 30% stealth'},
		{24+14.6,'*9 0% stealth,'},
		{24+14.75,'*99 30% stealth'},
		{24+14.8,'*9 0% stealth,'},

		{24+15,'*99 30% stealth'},
		{24+15.1,'*9 0% stealth,'},
		{24+15.25,'*99 30% stealth'},
		{24+15.3,'*9 0% stealth,'},
		{24+15.5,'*99 30% stealth'},
		{24+15.6,'*9 0% stealth,'},
		{24+15.75,'*99 30% stealth'},
		{24+15.8,'*9 0% stealth,'},

		{32+8,'*99 30% stealth'},
		{32+8.1,'*9 0% stealth,'},
		{32+8.25,'*99 30% stealth'},
		{32+8.3,'*9 0% stealth,'},
		{32+8.5,'*99 30% stealth'},
		{32+8.6,'*9 0% stealth,'},
		{32+8.75,'*99 30% stealth'},
		{32+8.8,'*9 0% stealth,'},

		{32+9,'*99 30% stealth'},
		{32+9.1,'*9 0% stealth,'},
		{32+9.25,'*99 30% stealth'},
		{32+9.3,'*9 0% stealth,'},
		{32+9.5,'*99 30% stealth'},
		{32+9.6,'*9 0% stealth,'},
		{32+9.75,'*99 30% stealth'},
		{32+9.8,'*9 0% stealth,'},

		{32+10,'*99 30% stealth'},
		{32+10.1,'*9 0% stealth,'},
		{32+10.25,'*99 30% stealth'},
		{32+10.3,'*9 0% stealth,'},
		{32+10.5,'*99 30% stealth'},
		{32+10.6,'*9 0% stealth,'},
		{32+10.75,'*99 30% stealth'},
		{32+10.8,'*9 0% stealth,'},

		{32+11,'*99 30% stealth'},
		{32+11.1,'*9 0% stealth,'},
		{32+11.25,'*99 30% stealth'},
		{32+11.3,'*9 0% stealth,'},
		{32+11.5,'*99 30% stealth'},
		{32+11.6,'*9 0% stealth,'},
		{32+11.75,'*99 30% stealth'},
		{32+11.8,'*9 0% stealth,'},

		{32+12,'*99 30% stealth'},
		{32+12.1,'*9 0% stealth,'},
		{32+12.25,'*99 30% stealth'},
		{32+12.3,'*9 0% stealth,'},
		{32+12.5,'*99 30% stealth'},
		{32+12.6,'*9 0% stealth,'},
		{32+12.75,'*99 30% stealth'},
		{32+12.8,'*9 0% stealth,'},

		{32+13,'*99 30% stealth'},
		{32+13.1,'*9 0% stealth,'},
		{32+13.25,'*99 30% stealth'},
		{32+13.3,'*9 0% stealth,'},
		{32+13.5,'*99 30% stealth'},
		{32+13.6,'*9 0% stealth,'},
		{32+13.75,'*99 30% stealth'},
		{32+13.8,'*9 0% stealth,'},

		{32+14,'*99 30% stealth'},
		{32+14.1,'*9 0% stealth,'},
		{32+14.25,'*99 30% stealth'},
		{32+14.3,'*9 0% stealth,'},
		{32+14.5,'*99 30% stealth'},
		{32+14.6,'*9 0% stealth,'},
		{32+14.75,'*99 30% stealth'},
		{32+14.8,'*9 0% stealth,'},

		{32+15,'*99 30% stealth'},
		{32+15.1,'*9 0% stealth,'},
		{32+15.25,'*99 30% stealth'},
		{32+15.3,'*9 0% stealth,'},
		{32+15.5,'*99 30% stealth'},
		{32+15.6,'*9 0% stealth,'},
		{32+15.75,'*99 30% stealth'},
		{32+15.8,'*9 0% stealth,'},

		{40+8,'*99 30% stealth'},
		{40+8.1,'*9 0% stealth,'},
		{40+8.25,'*99 30% stealth'},
		{40+8.3,'*9 0% stealth,'},
		{40+8.5,'*99 30% stealth'},
		{40+8.6,'*9 0% stealth,'},
		{40+8.75,'*99 30% stealth'},
		{40+8.8,'*9 0% stealth,'},

		{40+9,'*99 30% stealth'},
		{40+9.1,'*9 0% stealth,'},
		{40+9.25,'*99 30% stealth'},
		{40+9.3,'*9 0% stealth,'},
		{40+9.5,'*99 30% stealth'},
		{40+9.6,'*9 0% stealth,'},
		{40+9.75,'*99 30% stealth'},
		{40+9.8,'*9 0% stealth,'},

		{40+10,'*99 30% stealth'},
		{40+10.1,'*9 0% stealth,'},
		{40+10.25,'*99 30% stealth'},
		{40+10.3,'*9 0% stealth,'},
		{40+10.5,'*99 30% stealth'},
		{40+10.6,'*9 0% stealth,'},
		{40+10.75,'*99 30% stealth'},
		{40+10.8,'*9 0% stealth,'},

		{40+11,'*99 30% stealth'},
		{40+11.1,'*9 0% stealth,'},
		{40+11.25,'*99 30% stealth'},
		{40+11.3,'*9 0% stealth,'},
		{40+11.5,'*99 30% stealth'},
		{40+11.6,'*9 0% stealth,'},
		{40+11.75,'*99 30% stealth'},
		{40+11.8,'*9 0% stealth,'},

		{40+12,'*99 30% stealth'},
		{40+12.1,'*9 0% stealth,'},
		{40+12.25,'*99 30% stealth'},
		{40+12.3,'*9 0% stealth,'},
		{40+12.5,'*99 30% stealth'},
		{40+12.6,'*9 0% stealth,'},
		{40+12.75,'*99 30% stealth'},
		{40+12.8,'*9 0% stealth,'},

		{40+13,'*99 30% stealth'},
		{40+13.1,'*9 0% stealth,'},
		{40+13.25,'*99 30% stealth'},
		{40+13.3,'*9 0% stealth,'},
		{40+13.5,'*99 30% stealth'},
		{40+13.6,'*9 0% stealth,'},
		{40+13.75,'*99 30% stealth'},
		{40+13.8,'*9 0% stealth,'},

		{40+14,'*99 30% stealth'},
		{40+14.1,'*9 0% stealth,'},
		{40+14.25,'*99 30% stealth'},
		{40+14.3,'*9 0% stealth,'},
		{40+14.5,'*99 30% stealth'},
		{40+14.6,'*9 0% stealth,'},
		{40+14.75,'*99 30% stealth'},
		{40+14.8,'*9 0% stealth,'},

		{40+15,'*99 30% stealth'},
		{40+15.1,'*9 0% stealth,'},
		{40+15.25,'*99 30% stealth'},
		{40+15.3,'*9 0% stealth,'},
		{40+15.5,'*99 30% stealth'},
		{40+15.6,'*9 0% stealth,'},
		{40+15.75,'*99 30% stealth'},
		{40+15.8,'*9 0% stealth,'},

		{48+8,'*99 30% stealth'},
		{48+8.1,'*9 0% stealth,'},
		{48+8.25,'*99 30% stealth'},
		{48+8.3,'*9 0% stealth,'},
		{48+8.5,'*99 30% stealth'},
		{48+8.6,'*9 0% stealth,'},
		{48+8.75,'*99 30% stealth'},
		{48+8.8,'*9 0% stealth,'},

		{48+9,'*99 30% stealth'},
		{48+9.1,'*9 0% stealth,'},
		{48+9.25,'*99 30% stealth'},
		{48+9.3,'*9 0% stealth,'},
		{48+9.5,'*99 30% stealth'},
		{48+9.6,'*9 0% stealth,'},
		{48+9.75,'*99 30% stealth'},
		{48+9.8,'*9 0% stealth,'},

		{48+10,'*99 30% stealth'},
		{48+10.1,'*9 0% stealth,'},
		{48+10.25,'*99 30% stealth'},
		{48+10.3,'*9 0% stealth,'},
		{48+10.5,'*99 30% stealth'},
		{48+10.6,'*9 0% stealth,'},
		{48+10.75,'*99 30% stealth'},
		{48+10.8,'*9 0% stealth,'},

		{48+11,'*99 30% stealth'},
		{48+11.1,'*9 0% stealth,'},
		{48+11.25,'*99 30% stealth'},
		{48+11.3,'*9 0% stealth,'},
		{48+11.5,'*99 30% stealth'},
		{48+11.6,'*9 0% stealth,'},
		{48+11.75,'*99 30% stealth'},
		{48+11.8,'*9 0% stealth,'},

		{48+12,'*99 30% stealth'},
		{48+12.1,'*9 0% stealth,'},
		{48+12.25,'*99 30% stealth'},
		{48+12.3,'*9 0% stealth,'},
		{48+12.5,'*99 30% stealth'},
		{48+12.6,'*9 0% stealth,'},
		{48+12.75,'*99 30% stealth'},
		{48+12.8,'*9 0% stealth,'},

		{48+13,'*99 30% stealth'},
		{48+13.1,'*9 0% stealth,'},
		{48+13.25,'*99 30% stealth'},
		{48+13.3,'*9 0% stealth,'},
		{48+13.5,'*99 30% stealth'},
		{48+13.6,'*9 0% stealth,'},
		{48+13.75,'*99 30% stealth'},
		{48+13.8,'*9 0% stealth,'},

		{48+14,'*99 30% stealth'},
		{48+14.1,'*9 0% stealth,'},
		{48+14.25,'*99 30% stealth'},
		{48+14.3,'*9 0% stealth,'},
		{48+14.5,'*99 30% stealth'},
		{48+14.6,'*9 0% stealth,'},
		{48+14.75,'*99 30% stealth'},
		{48+14.8,'*9 0% stealth,'},

		{48+15,'*99 30% stealth'},
		{48+15.1,'*9 0% stealth,'},
		{48+15.25,'*99 30% stealth'},
		{48+15.3,'*9 0% stealth,'},
		{48+15.5,'*99 30% stealth'},
		{48+15.6,'*9 0% stealth,'},
		{48+15.75,'*99 30% stealth'},
		{48+15.8,'*9 0% stealth,'},

		{56+8,'*99 30% stealth'},
		{56+8.1,'*9 0% stealth,'},
		{56+8.25,'*99 30% stealth'},
		{56+8.3,'*9 0% stealth,'},
		{56+8.5,'*99 30% stealth'},
		{56+8.6,'*9 0% stealth,'},
		{56+8.75,'*99 30% stealth'},
		{56+8.8,'*9 0% stealth,'},

		{56+9,'*99 30% stealth'},
		{56+9.1,'*9 0% stealth,'},
		{56+9.25,'*99 30% stealth'},
		{56+9.3,'*9 0% stealth,'},
		{56+9.5,'*99 30% stealth'},
		{56+9.6,'*9 0% stealth,'},
		{56+9.75,'*99 30% stealth'},
		{56+9.8,'*9 0% stealth,'},

		{56+10,'*99 30% stealth'},
		{56+10.1,'*9 0% stealth,'},
		{56+10.25,'*99 30% stealth'},
		{56+10.3,'*9 0% stealth,'},
		{56+10.5,'*99 30% stealth'},
		{56+10.6,'*9 0% stealth,'},
		{56+10.75,'*99 30% stealth'},
		{56+10.8,'*9 0% stealth,'},

		{56+11,'*99 30% stealth'},
		{56+11.1,'*9 0% stealth,'},
		{56+11.25,'*99 30% stealth'},
		{56+11.3,'*9 0% stealth,'},
		{56+11.5,'*99 30% stealth'},
		{56+11.6,'*9 0% stealth,'},
		{56+11.75,'*99 30% stealth'},
		{56+11.8,'*9 0% stealth,'},

		{56+12,'*99 30% stealth'},
		{56+12.1,'*9 0% stealth,'},
		{56+12.25,'*99 30% stealth'},
		{56+12.3,'*9 0% stealth,'},
		{56+12.5,'*99 30% stealth'},
		{56+12.6,'*9 0% stealth,'},
		{56+12.75,'*99 30% stealth'},
		{56+12.8,'*9 0% stealth,'},

		{56+13,'*99 30% stealth'},
		{56+13.1,'*9 0% stealth,'},
		{56+13.25,'*99 30% stealth'},
		{56+13.3,'*9 0% stealth,'},
		{56+13.5,'*99 30% stealth'},
		{56+13.6,'*9 0% stealth,'},
		{56+13.75,'*99 30% stealth'},
		{56+13.8,'*9 0% stealth,'},

		{56+14,'*99 30% stealth'},
		{56+14.1,'*9 0% stealth,'},
		{56+14.25,'*99 30% stealth'},
		{56+14.3,'*9 0% stealth,'},
		{56+14.5,'*99 30% stealth'},
		{56+14.6,'*9 0% stealth,'},
		{56+14.75,'*99 30% stealth'},
		{56+14.8,'*9 0% stealth,'},

		{56+15,'*99 30% stealth'},
		{56+15.1,'*9 0% stealth,'},
		{56+15.25,'*99 30% stealth'},
		{56+15.3,'*9 0% stealth,'},
		{56+15.5,'*99 30% stealth'},
		{56+15.6,'*9 0% stealth,'},
		{56+15.75,'*99 30% stealth'},
		{56+15.8,'*9 0% stealth,'},

		{64+8,'*99 30% stealth'},
		{64+8.1,'*9 0% stealth,'},
		{64+8.25,'*99 30% stealth'},
		{64+8.3,'*9 0% stealth,'},
		{64+8.5,'*99 30% stealth'},
		{64+8.6,'*9 0% stealth,'},
		{64+8.75,'*99 30% stealth'},
		{64+8.8,'*9 0% stealth,'},

		{64+9,'*99 30% stealth'},
		{64+9.1,'*9 0% stealth,'},
		{64+9.25,'*99 30% stealth'},
		{64+9.3,'*9 0% stealth,'},
		{64+9.5,'*99 30% stealth'},
		{64+9.6,'*9 0% stealth,'},
		{64+9.75,'*99 30% stealth'},
		{64+9.8,'*9 0% stealth,'},

		{64+10,'*99 30% stealth'},
		{64+10.1,'*9 0% stealth,'},
		{64+10.25,'*99 30% stealth'},
		{64+10.3,'*9 0% stealth,'},
		{64+10.5,'*99 30% stealth'},
		{64+10.6,'*9 0% stealth,'},
		{64+10.75,'*99 30% stealth'},
		{64+10.8,'*9 0% stealth,'},

		{64+11,'*99 30% stealth'},
		{64+11.1,'*9 0% stealth,'},
		{64+11.25,'*99 30% stealth'},
		{64+11.3,'*9 0% stealth,'},
		{64+11.5,'*99 30% stealth'},
		{64+11.6,'*9 0% stealth,'},
		{64+11.75,'*99 30% stealth'},
		{64+11.8,'*9 0% stealth,'},

		{64+12,'*99 30% stealth'},
		{64+12.1,'*9 0% stealth,'},
		{64+12.25,'*99 30% stealth'},
		{64+12.3,'*9 0% stealth,'},
		{64+12.5,'*99 30% stealth'},
		{64+12.6,'*9 0% stealth,'},
		{64+12.75,'*99 30% stealth'},
		{64+12.8,'*9 0% stealth,'},

		{64+13,'*99 30% stealth'},
		{64+13.1,'*9 0% stealth,'},
		{64+13.25,'*99 30% stealth'},
		{64+13.3,'*9 0% stealth,'},
		{64+13.5,'*99 30% stealth'},
		{64+13.6,'*9 0% stealth,'},
		{64+13.75,'*99 30% stealth'},
		{64+13.8,'*9 0% stealth,'},

		{64+14,'*99 30% stealth'},
		{64+14.1,'*9 0% stealth,'},
		{64+14.25,'*99 30% stealth'},
		{64+14.3,'*9 0% stealth,'},
		{64+14.5,'*99 30% stealth'},
		{64+14.6,'*9 0% stealth,'},
		{64+14.75,'*99 30% stealth'},
		{64+14.8,'*9 0% stealth,'},

		{64+15,'*99 30% stealth'},
		{64+15.1,'*9 0% stealth,'},
		{64+15.25,'*99 30% stealth'},
		{64+15.3,'*9 0% stealth,'},
		{64+15.5,'*99 30% stealth'},
		{64+15.6,'*9 0% stealth,'},
		{64+15.75,'*99 30% stealth'},
		{64+15.8,'*9 0% stealth,'},

		-- As i mention, it starts again.
		{80+8,'*99 30% stealth'},
		{80+8.1,'*9 0% stealth,'},
		{80+8.25,'*99 30% stealth'},
		{80+8.3,'*9 0% stealth,'},
		{80+8.5,'*99 30% stealth'},
		{80+8.6,'*9 0% stealth,'},
		{80+8.75,'*99 30% stealth'},
		{80+8.8,'*9 0% stealth,'},

		{80+9,'*99 30% stealth'},
		{80+9.1,'*9 0% stealth,'},
		{80+9.25,'*99 30% stealth'},
		{80+9.3,'*9 0% stealth,'},
		{80+9.5,'*99 30% stealth'},
		{80+9.6,'*9 0% stealth,'},
		{80+9.75,'*99 30% stealth'},
		{80+9.8,'*9 0% stealth,'},

		{80+10,'*99 30% stealth'},
		{80+10.1,'*9 0% stealth,'},
		{80+10.25,'*99 30% stealth'},
		{80+10.3,'*9 0% stealth,'},
		{80+10.5,'*99 30% stealth'},
		{80+10.6,'*9 0% stealth,'},
		{80+10.75,'*99 30% stealth'},
		{80+10.8,'*9 0% stealth,'},

		{80+11,'*99 30% stealth'},
		{80+11.1,'*9 0% stealth,'},
		{80+11.25,'*99 30% stealth'},
		{80+11.3,'*9 0% stealth,'},
		{80+11.5,'*99 30% stealth'},
		{80+11.6,'*9 0% stealth,'},
		{80+11.75,'*99 30% stealth'},
		{80+11.8,'*9 0% stealth,'},

		{80+12,'*99 30% stealth'},
		{80+12.1,'*9 0% stealth,'},
		{80+12.25,'*99 30% stealth'},
		{80+12.3,'*9 0% stealth,'},
		{80+12.5,'*99 30% stealth'},
		{80+12.6,'*9 0% stealth,'},
		{80+12.75,'*99 30% stealth'},
		{80+12.8,'*9 0% stealth,'},

		{80+13,'*99 30% stealth'},
		{80+13.1,'*9 0% stealth,'},
		{80+13.25,'*99 30% stealth'},
		{80+13.3,'*9 0% stealth,'},
		{80+13.5,'*99 30% stealth'},
		{80+13.6,'*9 0% stealth,'},
		{80+13.75,'*99 30% stealth'},
		{80+13.8,'*9 0% stealth,'},

		{80+14,'*99 30% stealth'},
		{80+14.1,'*9 0% stealth,'},
		{80+14.25,'*99 30% stealth'},
		{80+14.3,'*9 0% stealth,'},
		{80+14.5,'*99 30% stealth'},
		{80+14.6,'*9 0% stealth,'},
		{80+14.75,'*99 30% stealth'},
		{80+14.8,'*9 0% stealth,'},

		{80+15,'*99 30% stealth'},
		{80+15.1,'*9 0% stealth,'},
		{80+15.25,'*99 30% stealth'},
		{80+15.3,'*9 0% stealth,'},
		{80+15.5,'*99 30% stealth'},
		{80+15.6,'*9 0% stealth,'},
		{80+15.75,'*99 30% stealth'},
		{80+15.8,'*9 0% stealth,'},
		-- So, i decided to repeat the vocals, like i did in the cureffect, so yeah.
		{80+8+8,'*99 30% stealth'},
		{80+8+8.1,'*9 0% stealth,'},
		{80+8+8.25,'*99 30% stealth'},
		{80+8+8.3,'*9 0% stealth,'},
		{80+8+8.5,'*99 30% stealth'},
		{80+8+8.6,'*9 0% stealth,'},
		{80+8+8.75,'*99 30% stealth'},
		{80+8+8.8,'*9 0% stealth,'},

		{80+8+9,'*99 30% stealth'},
		{80+8+9.1,'*9 0% stealth,'},
		{80+8+9.25,'*99 30% stealth'},
		{80+8+9.3,'*9 0% stealth,'},
		{80+8+9.5,'*99 30% stealth'},
		{80+8+9.6,'*9 0% stealth,'},
		{80+8+9.75,'*99 30% stealth'},
		{80+8+9.8,'*9 0% stealth,'},

		{80+8+10,'*99 30% stealth'},
		{80+8+10.1,'*9 0% stealth,'},
		{80+8+10.25,'*99 30% stealth'},
		{80+8+10.3,'*9 0% stealth,'},
		{80+8+10.5,'*99 30% stealth'},
		{80+8+10.6,'*9 0% stealth,'},
		{80+8+10.75,'*99 30% stealth'},
		{80+8+10.8,'*9 0% stealth,'},

		{80+8+11,'*99 30% stealth'},
		{80+8+11.1,'*9 0% stealth,'},
		{80+8+11.25,'*99 30% stealth'},
		{80+8+11.3,'*9 0% stealth,'},
		{80+8+11.5,'*99 30% stealth'},
		{80+8+11.6,'*9 0% stealth,'},
		{80+8+11.75,'*99 30% stealth'},
		{80+8+11.8,'*9 0% stealth,'},

		{80+8+12,'*99 30% stealth'},
		{80+8+12.1,'*9 0% stealth,'},
		{80+8+12.25,'*99 30% stealth'},
		{80+8+12.3,'*9 0% stealth,'},
		{80+8+12.5,'*99 30% stealth'},
		{80+8+12.6,'*9 0% stealth,'},
		{80+8+12.75,'*99 30% stealth'},
		{80+8+12.8,'*9 0% stealth,'},

		{80+8+13,'*99 30% stealth'},
		{80+8+13.1,'*9 0% stealth,'},
		{80+8+13.25,'*99 30% stealth'},
		{80+8+13.3,'*9 0% stealth,'},
		{80+8+13.5,'*99 30% stealth'},
		{80+8+13.6,'*9 0% stealth,'},
		{80+8+13.75,'*99 30% stealth'},
		{80+8+13.8,'*9 0% stealth,'},

		{80+8+14,'*99 30% stealth'},
		{80+8+14.1,'*9 0% stealth,'},
		{80+8+14.25,'*99 30% stealth'},
		{80+8+14.3,'*9 0% stealth,'},
		{80+8+14.5,'*99 30% stealth'},
		{80+8+14.6,'*9 0% stealth,'},
		{80+8+14.75,'*99 30% stealth'},
		{80+8+14.8,'*9 0% stealth,'},

		{80+8+15,'*99 30% stealth'},
		{80+8+15.1,'*9 0% stealth,'},
		{80+8+15.25,'*99 30% stealth'},
		{80+8+15.3,'*9 0% stealth,'},
		{80+8+15.5,'*99 30% stealth'},
		{80+8+15.6,'*9 0% stealth,'},
		{80+8+15.75,'*99 30% stealth'},
		{80+8+15.8,'*9 0% stealth,'},

		{80+16+8,'*99 30% stealth'},
		{80+16+8.1,'*9 0% stealth,'},
		{80+16+8.25,'*99 30% stealth'},
		{80+16+8.3,'*9 0% stealth,'},
		{80+16+8.5,'*99 30% stealth'},
		{80+16+8.6,'*9 0% stealth,'},
		{80+16+8.75,'*99 30% stealth'},
		{80+16+8.8,'*9 0% stealth,'},

		{80+16+9,'*99 30% stealth'},
		{80+16+9.1,'*9 0% stealth,'},
		{80+16+9.25,'*99 30% stealth'},
		{80+16+9.3,'*9 0% stealth,'},
		{80+16+9.5,'*99 30% stealth'},
		{80+16+9.6,'*9 0% stealth,'},
		{80+16+9.75,'*99 30% stealth'},
		{80+16+9.8,'*9 0% stealth,'},

		{80+16+10,'*99 30% stealth'},
		{80+16+10.1,'*9 0% stealth,'},
		{80+16+10.25,'*99 30% stealth'},
		{80+16+10.3,'*9 0% stealth,'},
		{80+16+10.5,'*99 30% stealth'},
		{80+16+10.6,'*9 0% stealth,'},
		{80+16+10.75,'*99 30% stealth'},
		{80+16+10.8,'*9 0% stealth,'},

		{80+16+11,'*99 30% stealth'},
		{80+16+11.1,'*9 0% stealth,'},
		{80+16+11.25,'*99 30% stealth'},
		{80+16+11.3,'*9 0% stealth,'},
		{80+16+11.5,'*99 30% stealth'},
		{80+16+11.6,'*9 0% stealth,'},
		{80+16+11.75,'*99 30% stealth'},
		{80+16+11.8,'*9 0% stealth,'},

		{80+16+12,'*99 30% stealth'},
		{80+16+12.1,'*9 0% stealth,'},
		{80+16+12.25,'*99 30% stealth'},
		{80+16+12.3,'*9 0% stealth,'},
		{80+16+12.5,'*99 30% stealth'},
		{80+16+12.6,'*9 0% stealth,'},
		{80+16+12.75,'*99 30% stealth'},
		{80+16+12.8,'*9 0% stealth,'},

		{80+16+13,'*99 30% stealth'},
		{80+16+13.1,'*9 0% stealth,'},
		{80+16+13.25,'*99 30% stealth'},
		{80+16+13.3,'*9 0% stealth,'},
		{80+16+13.5,'*99 30% stealth'},
		{80+16+13.6,'*9 0% stealth,'},
		{80+16+13.75,'*99 30% stealth'},
		{80+16+13.8,'*9 0% stealth,'},

		{80+16+14,'*99 30% stealth'},
		{80+16+14.1,'*9 0% stealth,'},
		{80+16+14.25,'*99 30% stealth'},
		{80+16+14.3,'*9 0% stealth,'},
		{80+16+14.5,'*99 30% stealth'},
		{80+16+14.6,'*9 0% stealth,'},
		{80+16+14.75,'*99 30% stealth'},
		{80+16+14.8,'*9 0% stealth,'},

		{80+16+15,'*99 30% stealth'},
		{80+16+15.1,'*9 0% stealth,'},
		{80+16+15.25,'*99 30% stealth'},
		{80+16+15.3,'*9 0% stealth,'},
		{80+16+15.5,'*99 30% stealth'},
		{80+16+15.6,'*9 0% stealth,'},
		{80+16+15.75,'*99 30% stealth'},
		{80+16+15.8,'*9 0% stealth,'},

		{80+24+8,'*99 30% stealth'},
		{80+24+8.1,'*9 0% stealth,'},
		{80+24+8.25,'*99 30% stealth'},
		{80+24+8.3,'*9 0% stealth,'},
		{80+24+8.5,'*99 30% stealth'},
		{80+24+8.6,'*9 0% stealth,'},
		{80+24+8.75,'*99 30% stealth'},
		{80+24+8.8,'*9 0% stealth,'},

		{80+24+9,'*99 30% stealth'},
		{80+24+9.1,'*9 0% stealth,'},
		{80+24+9.25,'*99 30% stealth'},
		{80+24+9.3,'*9 0% stealth,'},
		{80+24+9.5,'*99 30% stealth'},
		{80+24+9.6,'*9 0% stealth,'},
		{80+24+9.75,'*99 30% stealth'},
		{80+24+9.8,'*9 0% stealth,'},

		{80+24+10,'*99 30% stealth'},
		{80+24+10.1,'*9 0% stealth,'},
		{80+24+10.25,'*99 30% stealth'},
		{80+24+10.3,'*9 0% stealth,'},
		{80+24+10.5,'*99 30% stealth'},
		{80+24+10.6,'*9 0% stealth,'},
		{80+24+10.75,'*99 30% stealth'},
		{80+24+10.8,'*9 0% stealth,'},

		{80+24+11,'*99 30% stealth'},
		{80+24+11.1,'*9 0% stealth,'},
		{80+24+11.25,'*99 30% stealth'},
		{80+24+11.3,'*9 0% stealth,'},
		{80+24+11.5,'*99 30% stealth'},
		{80+24+11.6,'*9 0% stealth,'},
		{80+24+11.75,'*99 30% stealth'},
		{80+24+11.8,'*9 0% stealth,'},

		{80+24+12,'*99 30% stealth'},
		{80+24+12.1,'*9 0% stealth,'},
		{80+24+12.25,'*99 30% stealth'},
		{80+24+12.3,'*9 0% stealth,'},
		{80+24+12.5,'*99 30% stealth'},
		{80+24+12.6,'*9 0% stealth,'},
		{80+24+12.75,'*99 30% stealth'},
		{80+24+12.8,'*9 0% stealth,'},

		{80+24+13,'*99 30% stealth'},
		{80+24+13.1,'*9 0% stealth,'},
		{80+24+13.25,'*99 30% stealth'},
		{80+24+13.3,'*9 0% stealth,'},
		{80+24+13.5,'*99 30% stealth'},
		{80+24+13.6,'*9 0% stealth,'},
		{80+24+13.75,'*99 30% stealth'},
		{80+24+13.8,'*9 0% stealth,'},

		{80+24+14,'*99 30% stealth'},
		{80+24+14.1,'*9 0% stealth,'},
		{80+24+14.25,'*99 30% stealth'},
		{80+24+14.3,'*9 0% stealth,'},
		{80+24+14.5,'*99 30% stealth'},
		{80+24+14.6,'*9 0% stealth,'},
		{80+24+14.75,'*99 30% stealth'},
		{80+24+14.8,'*9 0% stealth,'},

		{80+24+15,'*99 30% stealth'},
		{80+24+15.1,'*9 0% stealth,'},
		{80+24+15.25,'*99 30% stealth'},
		{80+24+15.3,'*9 0% stealth,'},
		{80+24+15.5,'*99 30% stealth'},
		{80+24+15.6,'*9 0% stealth,'},
		{80+24+15.75,'*99 30% stealth'},
		{80+24+15.8,'*9 0% stealth,'},

		{80+32+8,'*99 30% stealth'},
		{80+32+8.1,'*9 0% stealth,'},
		{80+32+8.25,'*99 30% stealth'},
		{80+32+8.3,'*9 0% stealth,'},
		{80+32+8.5,'*99 30% stealth'},
		{80+32+8.6,'*9 0% stealth,'},
		{80+32+8.75,'*99 30% stealth'},
		{80+32+8.8,'*9 0% stealth,'},

		{80+32+9,'*99 30% stealth'},
		{80+32+9.1,'*9 0% stealth,'},
		{80+32+9.25,'*99 30% stealth'},
		{80+32+9.3,'*9 0% stealth,'},
		{80+32+9.5,'*99 30% stealth'},
		{80+32+9.6,'*9 0% stealth,'},
		{80+32+9.75,'*99 30% stealth'},
		{80+32+9.8,'*9 0% stealth,'},

		{80+32+10,'*99 30% stealth'},
		{80+32+10.1,'*9 0% stealth,'},
		{80+32+10.25,'*99 30% stealth'},
		{80+32+10.3,'*9 0% stealth,'},
		{80+32+10.5,'*99 30% stealth'},
		{80+32+10.6,'*9 0% stealth,'},
		{80+32+10.75,'*99 30% stealth'},
		{80+32+10.8,'*9 0% stealth,'},

		{80+32+11,'*99 30% stealth'},
		{80+32+11.1,'*9 0% stealth,'},
		{80+32+11.25,'*99 30% stealth'},
		{80+32+11.3,'*9 0% stealth,'},
		{80+32+11.5,'*99 30% stealth'},
		{80+32+11.6,'*9 0% stealth,'},
		{80+32+11.75,'*99 30% stealth'},
		{80+32+11.8,'*9 0% stealth,'},

		{80+32+12,'*99 30% stealth'},
		{80+32+12.1,'*9 0% stealth,'},
		{80+32+12.25,'*99 30% stealth'},
		{80+32+12.3,'*9 0% stealth,'},
		{80+32+12.5,'*99 30% stealth'},
		{80+32+12.6,'*9 0% stealth,'},
		{80+32+12.75,'*99 30% stealth'},
		{80+32+12.8,'*9 0% stealth,'},

		{80+32+13,'*99 30% stealth'},
		{80+32+13.1,'*9 0% stealth,'},
		{80+32+13.25,'*99 30% stealth'},
		{80+32+13.3,'*9 0% stealth,'},
		{80+32+13.5,'*99 30% stealth'},
		{80+32+13.6,'*9 0% stealth,'},
		{80+32+13.75,'*99 30% stealth'},
		{80+32+13.8,'*9 0% stealth,'},

		{80+32+14,'*99 30% stealth'},
		{80+32+14.1,'*9 0% stealth,'},
		{80+32+14.25,'*99 30% stealth'},
		{80+32+14.3,'*9 0% stealth,'},
		{80+32+14.5,'*99 30% stealth'},
		{80+32+14.6,'*9 0% stealth,'},
		{80+32+14.75,'*99 30% stealth'},
		{80+32+14.8,'*9 0% stealth,'},

		{80+32+15,'*99 30% stealth'},
		{80+32+15.1,'*9 0% stealth,'},
		{80+32+15.25,'*99 30% stealth'},
		{80+32+15.3,'*9 0% stealth,'},
		{80+32+15.5,'*99 30% stealth'},
		{80+32+15.6,'*9 0% stealth,'},
		{80+32+15.75,'*99 30% stealth'},
		{80+32+15.8,'*9 0% stealth,'},

		{80+40+8,'*99 30% stealth'},
		{80+40+8.1,'*9 0% stealth,'},
		{80+40+8.25,'*99 30% stealth'},
		{80+40+8.3,'*9 0% stealth,'},
		{80+40+8.5,'*99 30% stealth'},
		{80+40+8.6,'*9 0% stealth,'},
		{80+40+8.75,'*99 30% stealth'},
		{80+40+8.8,'*9 0% stealth,'},

		{80+40+9,'*99 30% stealth'},
		{80+40+9.1,'*9 0% stealth,'},
		{80+40+9.25,'*99 30% stealth'},
		{80+40+9.3,'*9 0% stealth,'},
		{80+40+9.5,'*99 30% stealth'},
		{80+40+9.6,'*9 0% stealth,'},
		{80+40+9.75,'*99 30% stealth'},
		{80+40+9.8,'*9 0% stealth,'},

		{80+40+10,'*99 30% stealth'},
		{80+40+10.1,'*9 0% stealth,'},
		{80+40+10.25,'*99 30% stealth'},
		{80+40+10.3,'*9 0% stealth,'},
		{80+40+10.5,'*99 30% stealth'},
		{80+40+10.6,'*9 0% stealth,'},
		{80+40+10.75,'*99 30% stealth'},
		{80+40+10.8,'*9 0% stealth,'},

		{80+40+11,'*99 30% stealth'},
		{80+40+11.1,'*9 0% stealth,'},
		{80+40+11.25,'*99 30% stealth'},
		{80+40+11.3,'*9 0% stealth,'},
		{80+40+11.5,'*99 30% stealth'},
		{80+40+11.6,'*9 0% stealth,'},
		{80+40+11.75,'*99 30% stealth'},
		{80+40+11.8,'*9 0% stealth,'},

		{80+40+12,'*99 30% stealth'},
		{80+40+12.1,'*9 0% stealth,'},
		{80+40+12.25,'*99 30% stealth'},
		{80+40+12.3,'*9 0% stealth,'},
		{80+40+12.5,'*99 30% stealth'},
		{80+40+12.6,'*9 0% stealth,'},
		{80+40+12.75,'*99 30% stealth'},
		{80+40+12.8,'*9 0% stealth,'},

		{80+40+13,'*99 30% stealth'},
		{80+40+13.1,'*9 0% stealth,'},
		{80+40+13.25,'*99 30% stealth'},
		{80+40+13.3,'*9 0% stealth,'},
		{80+40+13.5,'*99 30% stealth'},
		{80+40+13.6,'*9 0% stealth,'},
		{80+40+13.75,'*99 30% stealth'},
		{80+40+13.8,'*9 0% stealth,'},

		{80+40+14,'*99 30% stealth'},
		{80+40+14.1,'*9 0% stealth,'},
		{80+40+14.25,'*99 30% stealth'},
		{80+40+14.3,'*9 0% stealth,'},
		{80+40+14.5,'*99 30% stealth'},
		{80+40+14.6,'*9 0% stealth,'},
		{80+40+14.75,'*99 30% stealth'},
		{80+40+14.8,'*9 0% stealth,'},

		{80+40+15,'*99 30% stealth'},
		{80+40+15.1,'*9 0% stealth,'},
		{80+40+15.25,'*99 30% stealth'},
		{80+40+15.3,'*9 0% stealth,'},
		{80+40+15.5,'*99 30% stealth'},
		{80+40+15.6,'*9 0% stealth,'},
		{80+40+15.75,'*99 30% stealth'},
		{80+40+15.8,'*9 0% stealth,'},

		{80+48+8,'*99 30% stealth'},
		{80+48+8.1,'*9 0% stealth,'},
		{80+48+8.25,'*99 30% stealth'},
		{80+48+8.3,'*9 0% stealth,'},
		{80+48+8.5,'*99 30% stealth'},
		{80+48+8.6,'*9 0% stealth,'},
		{80+48+8.75,'*99 30% stealth'},
		{80+48+8.8,'*9 0% stealth,'},

		{80+48+9,'*99 30% stealth'},
		{80+48+9.1,'*9 0% stealth,'},
		{80+48+9.25,'*99 30% stealth'},
		{80+48+9.3,'*9 0% stealth,'},
		{80+48+9.5,'*99 30% stealth'},
		{80+48+9.6,'*9 0% stealth,'},
		{80+48+9.75,'*99 30% stealth'},
		{80+48+9.8,'*9 0% stealth,'},

		{80+48+10,'*99 30% stealth'},
		{80+48+10.1,'*9 0% stealth,'},
		{80+48+10.25,'*99 30% stealth'},
		{80+48+10.3,'*9 0% stealth,'},
		{80+48+10.5,'*99 30% stealth'},
		{80+48+10.6,'*9 0% stealth,'},
		{80+48+10.75,'*99 30% stealth'},
		{80+48+10.8,'*9 0% stealth,'},

		{80+48+11,'*99 30% stealth'},
		{80+48+11.1,'*9 0% stealth,'},
		{80+48+11.25,'*99 30% stealth'},
		{80+48+11.3,'*9 0% stealth,'},
		{80+48+11.5,'*99 30% stealth'},
		{80+48+11.6,'*9 0% stealth,'},
		{80+48+11.75,'*99 30% stealth'},
		{80+48+11.8,'*9 0% stealth,'},

		{80+48+12,'*99 30% stealth'},
		{80+48+12.1,'*9 0% stealth,'},
		{80+48+12.25,'*99 30% stealth'},
		{80+48+12.3,'*9 0% stealth,'},
		{80+48+12.5,'*99 30% stealth'},
		{80+48+12.6,'*9 0% stealth,'},
		{80+48+12.75,'*99 30% stealth'},
		{80+48+12.8,'*9 0% stealth,'},

		{80+48+13,'*99 30% stealth'},
		{80+48+13.1,'*9 0% stealth,'},
		{80+48+13.25,'*99 30% stealth'},
		{80+48+13.3,'*9 0% stealth,'},
		{80+48+13.5,'*99 30% stealth'},
		{80+48+13.6,'*9 0% stealth,'},
		{80+48+13.75,'*99 30% stealth'},
		{80+48+13.8,'*9 0% stealth,'},

		{80+48+14,'*99 30% stealth'},
		{80+48+14.1,'*9 0% stealth,'},
		{80+48+14.25,'*99 30% stealth'},
		{80+48+14.3,'*9 0% stealth,'},
		{80+48+14.5,'*99 30% stealth'},
		{80+48+14.6,'*9 0% stealth,'},
		{80+48+14.75,'*99 30% stealth'},
		{80+48+14.8,'*9 0% stealth,'},

		{80+48+15,'*99 30% stealth'},
		{80+48+15.1,'*9 0% stealth,'},
		{80+48+15.25,'*99 30% stealth'},
		{80+48+15.3,'*9 0% stealth,'},
		{80+48+15.5,'*99 30% stealth'},
		{80+48+15.6,'*9 0% stealth,'},
		{80+48+15.75,'*99 30% stealth'},
		{80+48+15.8,'*9 0% stealth,'},

		{80+56+8,'*99 30% stealth'},
		{80+56+8.1,'*9 0% stealth,'},
		{80+56+8.25,'*99 30% stealth'},
		{80+56+8.3,'*9 0% stealth,'},
		{80+56+8.5,'*99 30% stealth'},
		{80+56+8.6,'*9 0% stealth,'},
		{80+56+8.75,'*99 30% stealth'},
		{80+56+8.8,'*9 0% stealth,'},

		{80+56+9,'*99 30% stealth'},
		{80+56+9.1,'*9 0% stealth,'},
		{80+56+9.25,'*99 30% stealth'},
		{80+56+9.3,'*9 0% stealth,'},
		{80+56+9.5,'*99 30% stealth'},
		{80+56+9.6,'*9 0% stealth,'},
		{80+56+9.75,'*99 30% stealth'},
		{80+56+9.8,'*9 0% stealth,'},

		{80+56+10,'*99 30% stealth'},
		{80+56+10.1,'*9 0% stealth,'},
		{80+56+10.25,'*99 30% stealth'},
		{80+56+10.3,'*9 0% stealth,'},
		{80+56+10.5,'*99 30% stealth'},
		{80+56+10.6,'*9 0% stealth,'},
		{80+56+10.75,'*99 30% stealth'},
		{80+56+10.8,'*9 0% stealth,'},

		{80+56+11,'*99 30% stealth'},
		{80+56+11.1,'*9 0% stealth,'},
		{80+56+11.25,'*99 30% stealth'},
		{80+56+11.3,'*9 0% stealth,'},
		{80+56+11.5,'*99 30% stealth'},
		{80+56+11.6,'*9 0% stealth,'},
		{80+56+11.75,'*99 30% stealth'},
		{80+56+11.8,'*9 0% stealth,'},

		{80+56+12,'*99 30% stealth'},
		{80+56+12.1,'*9 0% stealth,'},
		{80+56+12.25,'*99 30% stealth'},
		{80+56+12.3,'*9 0% stealth,'},
		{80+56+12.5,'*99 30% stealth'},
		{80+56+12.6,'*9 0% stealth,'},
		{80+56+12.75,'*99 30% stealth'},
		{80+56+12.8,'*9 0% stealth,'},

		{80+56+13,'*99 30% stealth'},
		{80+56+13.1,'*9 0% stealth,'},
		{80+56+13.25,'*99 30% stealth'},
		{80+56+13.3,'*9 0% stealth,'},
		{80+56+13.5,'*99 30% stealth'},
		{80+56+13.6,'*9 0% stealth,'},
		{80+56+13.75,'*99 30% stealth'},
		{80+56+13.8,'*9 0% stealth,'},

		{80+56+14,'*99 30% stealth'},
		{80+56+14.1,'*9 0% stealth,'},
		{80+56+14.25,'*99 30% stealth'},
		{80+56+14.3,'*9 0% stealth,'},
		{80+56+14.5,'*99 30% stealth'},
		{80+56+14.6,'*9 0% stealth,'},
		{80+56+14.75,'*99 30% stealth'},
		{80+56+14.8,'*9 0% stealth,'},

		{80+56+15,'*99 30% stealth'},
		{80+56+15.1,'*9 0% stealth,'},
		{80+56+15.25,'*99 30% stealth'},
		{80+56+15.3,'*9 0% stealth,'},
		{80+56+15.5,'*99 30% stealth'},
		{80+56+15.6,'*9 0% stealth,'},
		{80+56+15.75,'*99 30% stealth'},
		{80+56+15.8,'*9 0% stealth,'},

		{80+64+8,'*99 30% stealth'},
		{80+64+8.1,'*9 0% stealth,'},
		{80+64+8.25,'*99 30% stealth'},
		{80+64+8.3,'*9 0% stealth,'},
		{80+64+8.5,'*99 30% stealth'},
		{80+64+8.6,'*9 0% stealth,'},
		{80+64+8.75,'*99 30% stealth'},
		{80+64+8.8,'*9 0% stealth,'},

		{80+64+9,'*99 30% stealth'},
		{80+64+9.1,'*9 0% stealth,'},
		{80+64+9.25,'*99 30% stealth'},
		{80+64+9.3,'*9 0% stealth,'},
		{80+64+9.5,'*99 30% stealth'},
		{80+64+9.6,'*9 0% stealth,'},
		{80+64+9.75,'*99 30% stealth'},
		{80+64+9.8,'*9 0% stealth,'},

		{80+64+10,'*99 30% stealth'},
		{80+64+10.1,'*9 0% stealth,'},
		{80+64+10.25,'*99 30% stealth'},
		{80+64+10.3,'*9 0% stealth,'},
		{80+64+10.5,'*99 30% stealth'},
		{80+64+10.6,'*9 0% stealth,'},
		{80+64+10.75,'*99 30% stealth'},
		{80+64+10.8,'*9 0% stealth,'},

		{80+64+11,'*99 30% stealth'},
		{80+64+11.1,'*9 0% stealth,'},
		{80+64+11.25,'*99 30% stealth'},
		{80+64+11.3,'*9 0% stealth,'},
		{80+64+11.5,'*99 30% stealth'},
		{80+64+11.6,'*9 0% stealth,'},
		{80+64+11.75,'*99 30% stealth'},
		{80+64+11.8,'*9 0% stealth,'},

		{80+64+12,'*99 30% stealth'},
		{80+64+12.1,'*9 0% stealth,'},
		{80+64+12.25,'*99 30% stealth'},
		{80+64+12.3,'*9 0% stealth,'},
		{80+64+12.5,'*99 30% stealth'},
		{80+64+12.6,'*9 0% stealth,'},
		{80+64+12.75,'*99 30% stealth'},
		{80+64+12.8,'*9 0% stealth,'},

		{80+64+13,'*99 30% stealth'},
		{80+64+13.1,'*9 0% stealth,'},
		{80+64+13.25,'*99 30% stealth'},
		{80+64+13.3,'*9 0% stealth,'},
		{80+64+13.5,'*99 30% stealth'},
		{80+64+13.6,'*9 0% stealth,'},
		{80+64+13.75,'*99 30% stealth'},
		{80+64+13.8,'*9 0% stealth,'},

		{80+64+14,'*99 30% stealth'},
		{80+64+14.1,'*9 0% stealth,'},
		{80+64+14.25,'*99 30% stealth'},
		{80+64+14.3,'*9 0% stealth,'},
		{80+64+14.5,'*99 30% stealth'},
		{80+64+14.6,'*9 0% stealth,'},
		{80+64+14.75,'*99 30% stealth'},
		{80+64+14.8,'*9 0% stealth,'},

		{80+64+15,'*99 30% stealth'},
		{80+64+15.1,'*9 0% stealth,'},
		{80+64+15.25,'*99 30% stealth'},
		{80+64+15.3,'*9 0% stealth,'},
		{80+64+15.5,'*99 30% stealth'},
		{80+64+15.6,'*9 0% stealth,'},
		{80+64+15.75,'*99 30% stealth'},
		{80+64+15.8,'*9 0% stealth,'},

		
	}

	iris_driven = 1;
	iris_driven_beat = 193;
	iris_driven_beat_init = 193;

	iris_driven_speed = 0.65;
	iris_driven_modspeed = 1.0;

	iris_drunk = 1;
	iris_drunk_amt = 0;
	iris_bumpy = 1;
	iris_bumpy_amt = 0;

	--SCREAMING GUMBALL / timed message broadcaster
	curmessage = 1;
	--{beat,message,ignoreIfAhead}
	messages = {
		--{182.5,'CytusSpawn'},
		--{193,'CytusBegin'},
		--{257,'CytusEnd'},

		{16,'Rotatetheplayer'},
		{23,'Restorerotation'},
		{24,'Rotatetheplayeralt'},
		{31,'Restorerotationalt'},
		{32,'Rotatetheplayer'},
		{39,'Restorerotation'},
		{40,'Rotatetheplayeralt'},
		{47,'Restorerotationalt'},
		{48,'Rotatetheplayer'},
		{55,'Restorerotation'},
		{56,'Rotatetheplayeralt'},
		{63,'Restorerotationalt'},
		{64,'Rotatetheplayer'},
		{71,'Restorerotation'},
		{72,'Rotatetheplayeralt'},
		{79,'Restorerotationalt'},
		----------------------------------------------------------------------------------------------------
		-- The song repeats again, so i just repeat the sequence. Good thing it is the exact same length. --
		----------------------------------------------------------------------------------------------------
		{80+16,'Rotatetheplayer'},
		{80+23,'Restorerotation'},
		{80+24,'Rotatetheplayeralt'},
		{80+31,'Restorerotationalt'},
		{80+32,'Rotatetheplayer'},
		{80+39,'Restorerotation'},
		{80+40,'Rotatetheplayeralt'},
		{80+47,'Restorerotationalt'},
		{80+48,'Rotatetheplayer'},
		{80+55,'Restorerotation'},
		{80+56,'Rotatetheplayeralt'},
		{80+63,'Restorerotationalt'},
		{80+64,'Rotatetheplayer'},
		{80+71,'Restorerotation'},
		{80+72,'Rotatetheplayeralt'},
		{80+79,'Restorerotationalt'},

	}
	
end

local function iris_update()

	if GAMESTATE:GetSongBeat()>=0.1 and not checked then
	
	if SCREENMAN:GetTopScreen():GetChild('PlayerP1') then
		P1 = SCREENMAN:GetTopScreen():GetChild('PlayerP1')
	end
			if P1 then
				P1xpos=P1:GetX();
				P1ypos=P1:GetY();
			end
	if SCREENMAN:GetTopScreen():GetChild('PlayerP2') then
		P2 = SCREENMAN:GetTopScreen():GetChild('PlayerP2')
	end
			if P2 then
				P2xpos=P2:GetX();
				P2ypos=P2:GetY();
			end
		--PE = SCREENMAN:GetTopScreen():GetChild('')
		
		screen = SCREENMAN:GetTopScreen()
		
		if P1 then
			P1:visible(false);
			P1:x(0);
			P1:y(0);
			wndrP1clone1:SetTarget(P1);
			wndrP1clone1:x(P1xpos);
			wndrP1clone1:y(P1ypos);
			
			
			wndrP1clone2:SetTarget(P1);
			wndrP1clone3:SetTarget(P1);
			wndrP1clone4:SetTarget(P1);
			
			wndrP1clone2:visible(false);
			wndrP1clone3:visible(false);
			wndrP1clone4:visible(false);
		end
		
		if P2 then
			P2:visible(false);
			P2:x(0);
			P2:y(0);
			wndrP2clone1:SetTarget(P2);
			wndrP2clone1:x(P2xpos);
			wndrP2clone1:y(P2ypos);
			
			
			wndrP2clone2:SetTarget(P2);
			wndrP2clone3:SetTarget(P2);
			wndrP2clone4:SetTarget(P2);
			
			wndrP2clone2:visible(false);
			wndrP2clone3:visible(false);
			wndrP2clone4:visible(false);
		end
		checked = true;
		
	end
	
	local beat = GAMESTATE:GetSongBeat()

	-- Collect all the mods that will be applied in this frame into one string.
	-- Mod tweening doesn't work correctly if the mods are in seperate commands.
	local mods_this_frame= {}
	local function add_mod(mod_str)
		mods_this_frame[#mods_this_frame+1]= mod_str
	end
	local function execute_mods()
		if #mods_this_frame <= 0 then return end
		local total_mod_str= ""
		for i, ms in ipairs(mods_this_frame) do
			if #total_mod_str > 0 then
				total_mod_str= total_mod_str .. ", "
			end
			total_mod_str= total_mod_str .. ms
		end
		iris_mod(total_mod_str)
	end
	
	--[[
	
	if beat>257 and fgcurcommand == 3 then
		set_player_speed(PLAYER_1, iris_speedmodP1)
		set_player_speed(PLAYER_2, iris_speedmodP2)
		add_mod('*1000 no reverse')
		add_mod('*1000 no centered')
		add_mod('*1000 no dark')
		fgcurcommand = fgcurcommand+1
	end --]]
	
	while curmod<= #mods and GAMESTATE:GetSongBeat()>=mods[curmod][1] do
		add_mod(mods[curmod][2])
		curmod = curmod+1
	end

	execute_mods()
	
	--SCREAMING GUMBALL
	while curmessage<= #messages and GAMESTATE:GetSongBeat()>=messages[curmessage][1] do
		if messages[curmessage][3] and GAMESTATE:GetSongBeat()>=messages[curmessage][1]+5 then
			curmessage = curmessage+1;
		else
			MESSAGEMAN:Broadcast(messages[curmessage][2])
			curmessage = curmessage+1;
		end
	end
end

return Def.ActorFrame{
	OnCommand= function(self)
							 iris_init()
							 self:SetUpdateFunction(iris_update)
						 end,
	Def.Quad{
		Name= "I may be sleeping, but I preserve the world.",
		InitCommand= cmd(visible,false),
		OnCommand= cmd(sleep,1000),
	},
	Def.Quad{
		OnCommand= cmd(diffuse,0,0,0,1;diffusealpha,0;zoomto,6,SCREEN_HEIGHT;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y),
		CytusSpawnMessageCommand= cmd(linear,1;diffusealpha,1),
		CytusEndMessageCommand= cmd(linear,1;diffusealpha,0),

		RotatetheplayerMessageCommand= function(self)
			P1:smooth(3.2)
			P1:rotationz(math.random(-20,20));
			P1:rotationx(math.random(-40,40));
			P1:zoom(0.4)
			-- P2
			P2:smooth(3.2)
			P2:zoom(0.4)
			P2:rotationz(math.random(-20,20));
			P2:rotationx(math.random(-40,40));
		end,

		RotatetheplayeraltMessageCommand= function(self)
			P1:smooth(3.2)
			P1:zoom(0.4)
			P1:rotationz(math.random(-40,40));
			P1:rotationx(math.random(-80,80));
			-- P2
			P2:smooth(3.2)
			P2:zoom(0.4)
			P2:rotationz(math.random(-40,40));
			P2:rotationx(math.random(-80,80));
		end,

		RestorerotationMessageCommand= function(self)
			P1:linear(0.12)
			P1:rotationz(-25)
			P1:rotationx(-25)
			P1:zoom(0.6)
			P1:linear(0.12)
			P1:rotationz(10)
			P1:rotationx(10)
			P1:zoom(0.8)
			P1:linear(0.12)
			P1:rotationz(0)
			P1:rotationx(0)
			P1:zoom(1)
			-- P2
			P2:linear(0.12)
			P2:rotationz(-25)
			P2:rotationx(-25)
			P2:zoom(0.6)
			P2:linear(0.12)
			P2:rotationz(10)
			P2:rotationx(10)
			P2:zoom(0.8)
			P2:linear(0.12)
			P2:rotationz(0)
			P2:rotationx(0)
			P2:zoom(1)
		end,

		RestorerotationaltMessageCommand= function(self)
			P1:linear(0.12)
			P1:rotationz(25)
			P1:rotationx(25)
			P1:zoom(0.6)
			P1:linear(0.12)
			P1:rotationz(-10)
			P1:rotationx(-10)
			P1:zoom(0.8)
			P1:linear(0.12)
			P1:rotationz(0)
			P1:rotationx(0)
			P1:zoom(1)
			-- P2
			P2:linear(0.12)
			P2:rotationz(25)
			P2:rotationx(25)
			P2:zoom(0.6)
			P2:linear(0.12)
			P2:rotationz(-10)
			P2:rotationx(-10)
			P2:zoom(0.8)
			P2:linear(0.12)
			P2:rotationz(0)
			P2:rotationx(0)
			P2:zoom(1)
		end,
	},
	
	--------------------------------------------------------
	--------------------------------------------------------
	--------------------------------------------------------
	-------------HERE LIES THE ACTOR PROXIES----------------
	--------------------------------------------------------
	--------------------------------------------------------
	--------------------------------------------------------
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone1=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone2=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone3=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone4=self;
			
		end;
	};
	
	
	------
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone1=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone2=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone3=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone4=self;
			
		end;
	};
	
}