
local songName= GAMESTATE:GetCurrentSong():GetSongDir()

local function iris_mod_internal(str, pn)
	local ps= GAMESTATE:GetPlayerState(pn)
	local pmods= ps:GetPlayerOptionsString('ModsLevel_Song')
	ps:SetPlayerOptions('ModsLevel_Song', pmods .. ', ' .. str)
	--GAMESTATE:ApplyGameCommand('mod,'..str, pn)
end


local function iris_mod(str)
	for i=1,2 do
		iris_mod_internal(str, 'PlayerNumber_P' .. i)
	end
end



local function iris_init()
	fgcurcommand = 0;
	wndr_skewx=0.3;
	checked = false;
	
	
	
	--lua course :D	/ timed mod management	
	curmod = 1;
	--{beat,mod,player}
	mods = {

		{0.1,'*10000 2.6x'},

		{21,'*99 -70% tiny'},
		{21.1,'*0.8 0% tiny'},
		{37,'*99 -70% tiny'},
		{37.1,'*0.8 0% tiny'},
		{38,'*99 -70% tiny'},
		{38.1,'*0.8 0% tiny'},
		{45,'*99 -70% tiny'},
		{45.1,'*0.8 0% tiny'},
		{47,'*99 -70% tiny'},
		{47.1,'*0.8 0% tiny'},
		{49,'*99 -70% tiny'},
		{49.1,'*0.8 0% tiny'},
		{50,'*99 -70% tiny'},
		{50.1,'*0.8 0% tiny'},
		{51,'*99 -70% tiny'},
		{51.1,'*0.8 0% tiny'},
		{51.5,'*99 -70% tiny'},
		{51.6,'*0.8 0% tiny'},

		{52,'*99 -70% tiny'},
		{52.1,'*15 0% tiny'},
		{52.25,'*99 -70% tiny'},
		{52.3,'*15 0% tiny'},
		{52.5,'*99 -70% tiny'},
		{52.6,'*15 0% tiny'},
		{52.75,'*99 -70% tiny'},
		{52.8,'*15 0% tiny'},
		{53,'*99 -70% tiny'},
		{53.1,'*15 0% tiny'},

		{54,'*99 invert'},
		{54.5,'*99 0% invert'},

		{57,'*99 -70% tiny, *99 30% drunk, *99 30% tornado'},
		{57.1,'*0.8 0% tiny, *2 0% drunk, *2 0% tornado'},
		{58.5,'*99 -70% tiny, *99 30% drunk, *99 30% tornado'},
		{58.6,'*0.8 0% tiny, *2 0% drunk, *2 0% tornado'},
		{65,'*99 -70% tiny, *99 30% drunk, *99 30% tornado'},
		{65.1,'*0.8 0% tiny, *2 0% drunk, *2 0% tornado'},
		{66.5,'*99 -70% tiny, *99 30% drunk, *99 30% tornado'},
		{66.6,'*0.8 0% tiny, *2 0% drunk, *2 0% tornado'},
		{73,'*99 -70% tiny, *99 30% drunk, *99 30% tornado'},
		{73.1,'*0.8 0% tiny, *2 0% drunk, *2 0% tornado'},
		{74.75,'*99 -70% tiny, *99 30% drunk, *99 30% tornado'},
		{74.8,'*0.8 0% tiny, *2 0% drunk, *2 0% tornado'},
		{81,'*99 -70% tiny, *99 30% drunk, *99 30% tornado'},
		{81.1,'*0.8 0% tiny, *2 0% drunk, *2 0% tornado'},
		{82.5,'*99 -70% tiny, *99 30% drunk, *99 30% tornado'},
		{82.6,'*0.8 0% tiny, *2 0% drunk, *2 0% tornado'},

		{89,'*99 brake'},
		{89.1,'*4 0% brake'},
		{90,'*99 brake'},
		{90.1,'*4 0% brake'},
		{91,'*99 brake'},
		{91.1,'*4 0% brake'},
		{92,'*99 brake'},
		{92.1,'*4 0% brake'},
		{93,'*99 brake'},
		{93.1,'*4 0% brake'},
		{94,'*99 brake'},
		{94.1,'*4 0% brake'},
		{95,'*99 brake'},
		{95.1,'*4 0% brake'},
		{96,'*99 brake'},
		{96.1,'*4 0% brake'},
		{97,'*99 brake'},
		{97.1,'*4 0% brake'},
		{98,'*99 brake'},
		{98.1,'*4 0% brake'},
		{99,'*99 brake'},
		{99.1,'*4 0% brake'},
		{100,'*99 brake'},
		{100.1,'*4 0% brake'},
		{101,'*99 brake'},
		{101.1,'*4 0% brake'},
		{102,'*99 brake'},
		{102.1,'*4 0% brake'},
		{103,'*99 brake'},
		{103.1,'*4 0% brake'},
		{104,'*99 brake'},
		{104.1,'*11 0% brake'},
		{104.5,'*99 brake'},
		{104.6,'*11 0% brake'},
		{105,'*99 brake'},
		{105.1,'*11 0% brake'},
		{105.5,'*99 brake'},
		{105.6,'*11 0% brake'},
		{106,'*99 brake'},
		{106.1,'*11 0% brake'},
		{106.5,'*99 brake'},
		{106.6,'*11 0% brake'},
		{107,'*99 brake'},
		{107.1,'*11 0% brake'},
		{107.5,'*99 brake'},
		{107.6,'*11 0% brake'},
		{108,'*99 brake'},
		{108.1,'*11 0% brake'},
		{108.5,'*99 brake'},
		{108.6,'*11 0% brake'},
		{109,'*99 brake'},
		{109.1,'*11 0% brake'},
		{109.5,'*99 brake'},
		{109.6,'*11 0% brake'},
		{110,'*99 brake'},
		{110.1,'*11 0% brake'},
		{110.5,'*99 brake'},
		{110.6,'*11 0% brake'},
		{111,'*99 brake'},
		{111.1,'*11 0% brake'},
		{111.5,'*99 brake'},
		{111.6,'*11 0% brake'},
		{112,'*99 brake'},
		{112.1,'*11 0% brake'},
		{112.5,'*99 brake'},
		{112.6,'*11 0% brake'},

		{113,'*99 brake'},
		{113.1,'*11 0% brake'},
		{113.25,'*99 brake'},
		{113.3,'*11 0% brake'},
		{113.5,'*99 brake'},
		{113.6,'*11 0% brake'},
		{113.75,'*99 brake'},
		{113.8,'*11 0% brake'},
		{114,'*99 brake'},
		{114.1,'*11 0% brake'},
		{114.25,'*99 brake'},
		{114.3,'*11 0% brake'},
		{114.5,'*99 brake'},
		{114.6,'*11 0% brake'},
		{115,'*99 brake'},
		{115.1,'*11 0% brake'},
		{115.25,'*99 brake'},
		{115.3,'*11 0% brake'},
		{115.5,'*99 brake'},
		{115.6,'*11 0% brake'},
		{115.75,'*99 brake'},
		{115.8,'*11 0% brake'},
		{115.75,'*99 brake'},
		{115.8,'*11 0% brake'},
		{116,'*99 brake'},
		{116.1,'*11 0% brake'},
		{116.25,'*99 brake'},
		{116.3,'*11 0% brake'},
		{116.5,'*99 brake'},
		{116.6,'*11 0% brake'},
		{116.75,'*99 brake'},
		{116.8,'*11 0% brake'},

		{120,'*16 300% centered'},
		{121,'*99 0% centered, *99 distant, *99 200% boost, *99 wave, *99 45% brake, *999 2x'},
		{129,'*7 50% reverse'},
		{130,'*7 75% reverse'},
		{130.5,'*7 reverse'},

		{137,'*7 50% reverse'},
		{138,'*7 25% reverse'},
		{138.5,'*7 0% reverse'},

		{145,'*7 50% reverse'},
		{146,'*7 75% reverse'},
		{146.5,'*7 reverse'},

		{153,'*7 50% reverse, *99 distant'},
		{154,'*7 25% reverse, *6 drunk'},
		{154.5,'*7 0% reverse'},

		{161,'*7 50% reverse'},
		{162,'*7 75% reverse'},
		{162.5,'*7 reverse'},

		{169,'*7 50% reverse'},
		{170,'*7 25% reverse'},
		{170.5,'*7 0% reverse'},

		{177,'*7 50% reverse'},
		{178,'*7 75% reverse'},
		{178.5,'*7 reverse'},

		{185,'*8 0% reverse, *8 overhead, *8 100% bumpy, *8 30% wave, *99 45% brake'},

		{249,'*4098 240% Mini, *4098 -500% Reverse, *4098 125% Centered, *4098 0.2x, *4098 500% Tornado, *4098 10000% bumpy, 100000% Dizzy, *10000 1600% Sudden, *10000 -140% SuddenOffset, *99 stealth, *999 0% drunk, *999 0% brake'},
		{249.1,'*0.2 0% stealth'},
		{270,'*0.4 stealth'},
		{276,'**10000 No Mini,*10000 No Reverse,*10000 No Centered,*10000 2x,*10000 No Tornado,*10000 No Bumpy,*10000 No Dizzy,*4 No Stealth,*4 No Dark,*10000 No Sudden, *999 45% brake'},

		{285,'*999 97.553% Flip, *999 -21.631% Split, *999 36% Reverse'},
		{285.25,'*99999 4000% centered'},
		{285.5,'*999 0% flip, *999 0% split, *999 0% reverse, *99999 0% centered'},

		{317,'*16 300% centered'},
		{318,'*99 0% centered, *99 distant, *99 200% boost, *99 wave, *99 45% brake'},
		{326,'*7 50% reverse'},
		{327,'*7 75% reverse'},
		{327.5,'*7 reverse'},

		{334,'*7 50% reverse'},
		{335,'*7 25% reverse'},
		{335.5,'*7 0% reverse'},

		{342,'*7 50% reverse'},
		{343,'*7 75% reverse'},
		{343.5,'*7 reverse'},

		{350,'*7 50% reverse, *99 distant'},
		{351,'*7 25% reverse, *6 drunk'},
		{351.5,'*7 0% reverse'},

		{358,'*7 50% reverse'},
		{359,'*7 75% reverse'},
		{359.5,'*7 reverse'},

		{366,'*7 50% reverse'},
		{367,'*7 25% reverse'},
		{367.5,'*7 0% reverse'},

		{374,'*7 50% reverse'},
		{375,'*7 75% reverse'},
		{375.5,'*7 reverse'},

		{382,'*8 0% reverse, *999 overhead, *8 100% bumpy, *8 30% wave, *99 45% brake'},

		{478,'150% brake, 1300% bumpy'},

		{510,'*99 flip, *0.8 200% mini, *99 50% stealth, *99 dark, 0x'},
		{510.02,'*99 0% flip, *0.1 stealth'},
		{510.04,'*99 flip'},
		{510.06,'*99 0% flip'},
		{510.08,'*99 flip'},
		{510.10,'*99 0% flip'},
		{510.12,'*99 flip'},
		{510.14,'*99 0% flip'},
		{510.16,'*99 flip'},
		{510.18,'*99 0% flip'},
		{510.20,'*99 flip'},
		{510.22,'*99 flip'},
		{510.24,'*99 0% flip'},
		{510.26,'*99 flip'},
		{510.28,'*99 0% flip'},
		{510.30,'*99 flip'},
		{510.32,'*99 flip'},
		{510.34,'*99 0% flip'},
		{510.36,'*99 flip'},
		{510.38,'*99 0% flip'},
		{510.40,'*99 flip'},
		{510.42,'*99 flip'},
		{510.44,'*99 0% flip'},
		{510.46,'*99 flip'},
		{510.48,'*99 0% flip'},
		{510.50,'*99 flip'},
		{510.52,'*99 flip'},
		{510.54,'*99 0% flip'},
		{510.56,'*99 flip'},
		{510.58,'*99 0% flip'},
		{510.60,'*99 flip'},
		{510.62,'*99 flip'},
		{510.64,'*99 0% flip'},
		{510.66,'*99 flip'},
		{510.68,'*99 0% flip'},
		{510.70,'*99 flip'},
		{510.72,'*99 flip'},
		{510.74,'*99 0% flip'},
		{510.76,'*99 flip'},
		{510.78,'*99 0% flip'},
		{510.80,'*99 flip'},
		{510.82,'*99 flip'},
		{510.84,'*99 0% flip'},
		{510.86,'*99 flip'},
		{510.88,'*99 0% flip'},
		{510.90,'*99 flip'},
		{510.92,'*99 flip'},
		{510.94,'*99 0% flip'},
		{510.96,'*99 flip'},
		{510.98,'*99 0% flip'},

		{511,'*99 flip'},
		{511.02,'*99 0% flip'},
		{511.04,'*99 flip'},
		{511.06,'*99 0% flip'},
		{511.08,'*99 flip'},
		{511.10,'*99 0% flip'},
		{511.12,'*99 flip'},
		{511.14,'*99 0% flip'},
		{511.16,'*99 flip'},
		{511.18,'*99 0% flip'},
		{511.20,'*99 flip'},
		{511.22,'*99 flip'},
		{511.24,'*99 0% flip'},
		{511.26,'*99 flip'},
		{511.28,'*99 0% flip'},
		{511.30,'*99 flip'},
		{511.32,'*99 flip'},
		{511.34,'*99 0% flip'},
		{511.36,'*99 flip'},
		{511.38,'*99 0% flip'},
		{511.40,'*99 flip'},
		{511.42,'*99 flip'},
		{511.44,'*99 0% flip'},
		{511.46,'*99 flip'},
		{511.48,'*99 0% flip'},
		{511.50,'*99 flip'},
		{511.52,'*99 flip'},
		{511.54,'*99 0% flip'},
		{511.56,'*99 flip'},
		{511.58,'*99 0% flip'},
		{511.60,'*99 flip'},
		{511.62,'*99 flip'},
		{511.64,'*99 0% flip'},
		{511.66,'*99 flip'},
		{511.68,'*99 0% flip'},
		{511.70,'*99 flip'},
		{511.72,'*99 flip'},
		{511.74,'*99 0% flip'},
		{511.76,'*99 flip'},
		{511.78,'*99 0% flip'},
		{511.80,'*99 flip'},
		{511.82,'*99 flip'},
		{511.84,'*99 0% flip'},
		{511.86,'*99 flip'},
		{511.88,'*99 0% flip'},
		{511.90,'*99 flip'},
		{511.92,'*99 flip'},
		{511.94,'*99 0% flip'},
		{511.96,'*99 flip'},
		{511.98,'*99 0% flip'},

		{512,'*99 flip'},
		{512.02,'*99 0% flip'},
		{512.04,'*99 flip'},
		{512.06,'*99 0% flip'},
		{512.08,'*99 flip'},
		{512.10,'*99 0% flip'},
		{512.12,'*99 flip'},
		{512.14,'*99 0% flip'},
		{512.16,'*99 flip'},
		{512.18,'*99 0% flip'},
		{512.20,'*99 flip'},
		{512.22,'*99 flip'},
		{512.24,'*99 0% flip'},
		{512.26,'*99 flip'},
		{512.28,'*99 0% flip'},
		{512.30,'*99 flip'},
		{512.32,'*99 flip'},
		{512.34,'*99 0% flip'},
		{512.36,'*99 flip'},
		{512.38,'*99 0% flip'},
		{512.40,'*99 flip'},
		{512.42,'*99 flip'},
		{512.44,'*99 0% flip'},
		{512.46,'*99 flip'},
		{512.48,'*99 0% flip'},
		{512.50,'*99 flip'},
		{512.52,'*99 flip'},
		{512.54,'*99 0% flip'},
		{512.56,'*99 flip'},
		{512.58,'*99 0% flip'},
		{512.60,'*99 flip'},
		{512.62,'*99 flip'},
		{512.64,'*99 0% flip'},
		{512.66,'*99 flip'},
		{512.68,'*99 0% flip'},
		{512.70,'*99 flip'},
		{512.72,'*99 flip'},
		{512.74,'*99 0% flip'},
		{512.76,'*99 flip'},
		{512.78,'*99 0% flip'},
		{512.80,'*99 flip'},
		{512.82,'*99 flip'},
		{512.84,'*99 0% flip'},
		{512.86,'*99 flip'},
		{512.88,'*99 0% flip'},
		{512.90,'*99 flip'},
		{512.92,'*99 flip'},
		{512.94,'*99 0% flip'},
		{512.96,'*99 flip'},
		{512.98,'*99 0% flip'},

		{513,'*99 flip'},
		{513.02,'*99 0% flip'},
		{513.04,'*99 flip'},
		{513.06,'*99 0% flip'},
		{513.08,'*99 flip'},
		{513.10,'*99 0% flip'},
		{513.12,'*99 flip'},
		{513.14,'*99 0% flip'},
		{513.16,'*99 flip'},
		{513.18,'*99 0% flip'},
		{513.20,'*99 flip'},
		{513.22,'*99 flip'},
		{513.24,'*99 0% flip'},
		{513.26,'*99 flip'},
		{513.28,'*99 0% flip'},
		{513.30,'*99 flip'},
		{513.32,'*99 flip'},
		{513.34,'*99 0% flip'},
		{513.36,'*99 flip'},
		{513.38,'*99 0% flip'},
		{513.40,'*99 flip'},
		{513.42,'*99 flip'},
		{513.44,'*99 0% flip'},
		{513.46,'*99 flip'},
		{513.48,'*99 0% flip'},
		{513.50,'*99 flip'},
		{513.52,'*99 flip'},
		{513.54,'*99 0% flip'},
		{513.56,'*99 flip'},
		{513.58,'*99 0% flip'},
		{513.60,'*99 flip'},
		{513.62,'*99 flip'},
		{513.64,'*99 0% flip'},
		{513.66,'*99 flip'},
		{513.68,'*99 0% flip'},
		{513.70,'*99 flip'},
		{513.72,'*99 flip'},
		{513.74,'*99 0% flip'},
		{513.76,'*99 flip'},
		{513.78,'*99 0% flip'},
		{513.80,'*99 flip'},
		{513.82,'*99 flip'},
		{513.84,'*99 0% flip'},
		{513.86,'*99 flip'},
		{513.88,'*99 0% flip'},
		{513.90,'*99 flip'},
		{513.92,'*99 flip'},
		{513.94,'*99 0% flip'},
		{513.96,'*99 flip'},
		{513.98,'*99 0% flip'},

		{514,'*99 flip'},
		{514.02,'*99 0% flip'},
		{514.04,'*99 flip'},
		{514.06,'*99 0% flip'},
		{514.08,'*99 flip'},
		{514.10,'*99 0% flip'},
		{514.12,'*99 flip'},
		{514.14,'*99 0% flip'},
		{514.16,'*99 flip'},
		{514.18,'*99 0% flip'},
		{514.20,'*99 flip'},
		{514.22,'*99 flip'},
		{514.24,'*99 0% flip'},
		{514.26,'*99 flip'},
		{514.28,'*99 0% flip'},
		{514.30,'*99 flip'},
		{514.32,'*99 flip'},
		{514.34,'*99 0% flip'},
		{514.36,'*99 flip'},
		{514.38,'*99 0% flip'},
		{514.40,'*99 flip'},
		{514.42,'*99 flip'},
		{514.44,'*99 0% flip'},
		{514.46,'*99 flip'},
		{514.48,'*99 0% flip'},
		{514.50,'*99 flip'},
		{514.52,'*99 flip'},
		{514.54,'*99 0% flip'},
		{514.56,'*99 flip'},
		{514.58,'*99 0% flip'},
		{514.60,'*99 flip'},
		{514.62,'*99 flip'},
		{514.64,'*99 0% flip'},
		{514.66,'*99 flip'},
		{514.68,'*99 0% flip'},
		{514.70,'*99 flip'},
		{514.72,'*99 flip'},
		{514.74,'*99 0% flip'},
		{514.76,'*99 flip'},
		{514.78,'*99 0% flip'},
		{514.80,'*99 flip'},
		{514.82,'*99 flip'},
		{514.84,'*99 0% flip'},
		{514.86,'*99 flip'},
		{514.88,'*99 0% flip'},
		{514.90,'*99 flip'},
		{514.92,'*99 flip'},
		{514.94,'*99 0% flip'},
		{514.96,'*99 flip'},
		{514.98,'*99 0% flip'},

		{515,'*99 flip'},
		{515.02,'*99 0% flip'},
		{515.04,'*99 flip'},
		{515.06,'*99 0% flip'},
		{515.08,'*99 flip'},
		{515.10,'*99 0% flip'},
		{515.12,'*99 flip'},
		{515.14,'*99 0% flip'},
		{515.16,'*99 flip'},
		{515.18,'*99 0% flip'},
		{515.20,'*99 flip'},
		{515.22,'*99 flip'},
		{515.24,'*99 0% flip'},
		{515.26,'*99 flip'},
		{515.28,'*99 0% flip'},
		{515.30,'*99 flip'},
		{515.32,'*99 flip'},
		{515.34,'*99 0% flip'},
		{515.36,'*99 flip'},
		{515.38,'*99 0% flip'},
		{515.40,'*99 flip'},
		{515.42,'*99 flip'},
		{515.44,'*99 0% flip'},
		{515.46,'*99 flip'},
		{515.48,'*99 0% flip'},
		{515.50,'*99 flip'},
		{515.52,'*99 flip'},
		{515.54,'*99 0% flip'},
		{515.56,'*99 flip'},
		{515.58,'*99 0% flip'},
		{515.60,'*99 flip'},
		{515.62,'*99 flip'},
		{515.64,'*99 0% flip'},
		{515.66,'*99 flip'},
		{515.68,'*99 0% flip'},
		{515.70,'*99 flip'},
		{515.72,'*99 flip'},
		{515.74,'*99 0% flip'},
		{515.76,'*99 flip'},
		{515.78,'*99 0% flip'},
		{515.80,'*99 flip'},
		{515.82,'*99 flip'},
		{515.84,'*99 0% flip'},
		{515.86,'*99 flip'},
		{515.88,'*99 0% flip'},
		{515.90,'*99 flip'},
		{515.92,'*99 flip'},
		{515.94,'*99 0% flip'},
		{515.96,'*99 flip'},
		{515.98,'*99 0% flip'},

		{516,'*99 flip'},
		{516.02,'*99 0% flip'},
		{516.04,'*99 flip'},
		{516.06,'*99 0% flip'},
		{516.08,'*99 flip'},
		{516.10,'*99 0% flip'},
		{516.12,'*99 flip'},
		{516.14,'*99 0% flip'},
		{516.16,'*99 flip'},
		{516.18,'*99 0% flip'},
		{516.20,'*99 flip'},
		{516.22,'*99 flip'},
		{516.24,'*99 0% flip'},
		{516.26,'*99 flip'},
		{516.28,'*99 0% flip'},
		{516.30,'*99 flip'},
		{516.32,'*99 flip'},
		{516.34,'*99 0% flip'},
		{516.36,'*99 flip'},
		{516.38,'*99 0% flip'},
		{516.40,'*99 flip'},
		{516.42,'*99 flip'},
		{516.44,'*99 0% flip'},
		{516.46,'*99 flip'},
		{516.48,'*99 0% flip'},
		{516.50,'*99 flip'},
		{516.52,'*99 flip'},
		{516.54,'*99 0% flip'},
		{516.56,'*99 flip'},
		{516.58,'*99 0% flip'},
		{516.60,'*99 flip'},
		{516.62,'*99 flip'},
		{516.64,'*99 0% flip'},
		{516.66,'*99 flip'},
		{516.68,'*99 0% flip'},
		{516.70,'*99 flip'},
		{516.72,'*99 flip'},
		{516.74,'*99 0% flip'},
		{516.76,'*99 flip'},
		{516.78,'*99 0% flip'},
		{516.80,'*99 flip'},
		{516.82,'*99 flip'},
		{516.84,'*99 0% flip'},
		{516.86,'*99 flip'},
		{516.88,'*99 0% flip'},
		{516.90,'*99 flip'},
		{516.92,'*99 flip'},
		{516.94,'*99 0% flip'},
		{516.96,'*99 flip'},
		{516.98,'*99 0% flip'},

		{517,'*99 flip'},
		{517.02,'*99 0% flip'},
		{517.04,'*99 flip'},
		{517.06,'*99 0% flip'},
		{517.08,'*99 flip'},
		{517.10,'*99 0% flip'},
		{517.12,'*99 flip'},
		{517.14,'*99 0% flip'},
		{517.16,'*99 flip'},
		{517.18,'*99 0% flip'},
		{517.20,'*99 flip'},
		{517.22,'*99 flip'},
		{517.24,'*99 0% flip'},
		{517.26,'*99 flip'},
		{517.28,'*99 0% flip'},
		{517.30,'*99 flip'},
		{517.32,'*99 flip'},
		{517.34,'*99 0% flip'},
		{517.36,'*99 flip'},
		{517.38,'*99 0% flip'},
		{517.40,'*99 flip'},
		{517.42,'*99 flip'},
		{517.44,'*99 0% flip'},
		{517.46,'*99 flip'},
		{517.48,'*99 0% flip'},
		{517.50,'*99 flip'},
		{517.52,'*99 flip'},
		{517.54,'*99 0% flip'},
		{517.56,'*99 flip'},
		{517.58,'*99 0% flip'},
		{517.60,'*99 flip'},
		{517.62,'*99 flip'},
		{517.64,'*99 0% flip'},
		{517.66,'*99 flip'},
		{517.68,'*99 0% flip'},
		{517.70,'*99 flip'},
		{517.72,'*99 flip'},
		{517.74,'*99 0% flip'},
		{517.76,'*99 flip'},
		{517.78,'*99 0% flip'},
		{517.80,'*99 flip'},
		{517.82,'*99 flip'},
		{517.84,'*99 0% flip'},
		{517.86,'*99 flip'},
		{517.88,'*99 0% flip'},
		{517.90,'*99 flip'},
		{517.92,'*99 flip'},
		{517.94,'*99 0% flip'},
		{517.96,'*99 flip'},
		{517.98,'*99 0% flip'},

		{526,'*999 340000% centered'},



		
		
		
		
		
	}

	iris_driven = 1;
	iris_driven_beat = 193;
	iris_driven_beat_init = 193;

	iris_driven_speed = 0.65;
	iris_driven_modspeed = 1.0;

	iris_drunk = 1;
	iris_drunk_amt = 0;
	iris_bumpy = 1;
	iris_bumpy_amt = 0;

	--SCREAMING GUMBALL / timed message broadcaster
	curmessage = 1;
	--{beat,message,ignoreIfAhead}
	messages = {
		--{182.5,'CytusSpawn'},
		--{193,'CytusBegin'},
		--{257,'CytusEnd'},
		
		


	}
	
end

local function iris_update()

	if GAMESTATE:GetSongBeat()>=0.1 and not checked then
	
	if SCREENMAN:GetTopScreen():GetChild('PlayerP1') then
		P1 = SCREENMAN:GetTopScreen():GetChild('PlayerP1')
	end
			if P1 then
				P1xpos=P1:GetX();
				P1ypos=P1:GetY();
			end
	if SCREENMAN:GetTopScreen():GetChild('PlayerP2') then
		P2 = SCREENMAN:GetTopScreen():GetChild('PlayerP2')
	end
			if P2 then
				P2xpos=P2:GetX();
				P2ypos=P2:GetY();
			end
		--PE = SCREENMAN:GetTopScreen():GetChild('')
		
		screen = SCREENMAN:GetTopScreen()
		
		if P1 then
			P1:visible(false);
			P1:x(0);
			P1:y(0);
			wndrP1clone1:SetTarget(P1);
			wndrP1clone1:x(P1xpos);
			wndrP1clone1:y(P1ypos);
			
			
			wndrP1clone2:SetTarget(P1);
			wndrP1clone3:SetTarget(P1);
			wndrP1clone4:SetTarget(P1);
			
			wndrP1clone2:visible(false);
			wndrP1clone3:visible(false);
			wndrP1clone4:visible(false);
		end
		
		if P2 then
			P2:visible(false);
			P2:x(0);
			P2:y(0);
			wndrP2clone1:SetTarget(P2);
			wndrP2clone1:x(P2xpos);
			wndrP2clone1:y(P2ypos);
			
			
			wndrP2clone2:SetTarget(P2);
			wndrP2clone3:SetTarget(P2);
			wndrP2clone4:SetTarget(P2);
			
			wndrP2clone2:visible(false);
			wndrP2clone3:visible(false);
			wndrP2clone4:visible(false);
		end
		checked = true;
		
	end
	
	local beat = GAMESTATE:GetSongBeat()

	-- Collect all the mods that will be applied in this frame into one string.
	-- Mod tweening doesn't work correctly if the mods are in seperate commands.
	local mods_this_frame= {}
	local function add_mod(mod_str)
		mods_this_frame[#mods_this_frame+1]= mod_str
	end
	local function execute_mods()
		if #mods_this_frame <= 0 then return end
		local total_mod_str= ""
		for i, ms in ipairs(mods_this_frame) do
			if #total_mod_str > 0 then
				total_mod_str= total_mod_str .. ", "
			end
			total_mod_str= total_mod_str .. ms
		end
		iris_mod(total_mod_str)
	end
	
	--[[
	
	if beat>257 and fgcurcommand == 3 then
		set_player_speed(PLAYER_1, iris_speedmodP1)
		set_player_speed(PLAYER_2, iris_speedmodP2)
		add_mod('*1000 no reverse')
		add_mod('*1000 no centered')
		add_mod('*1000 no dark')
		fgcurcommand = fgcurcommand+1
	end --]]
	
	while curmod<= #mods and GAMESTATE:GetSongBeat()>=mods[curmod][1] do
		add_mod(mods[curmod][2])
		curmod = curmod+1
	end

	execute_mods()
	
	--SCREAMING GUMBALL
	while curmessage<= #messages and GAMESTATE:GetSongBeat()>=messages[curmessage][1] do
		if messages[curmessage][3] and GAMESTATE:GetSongBeat()>=messages[curmessage][1]+5 then
			curmessage = curmessage+1;
		else
			MESSAGEMAN:Broadcast(messages[curmessage][2])
			curmessage = curmessage+1;
		end
	end
end

return Def.ActorFrame{
	OnCommand= function(self)
							 iris_init()
							 self:SetUpdateFunction(iris_update)
						 end,
	Def.Quad{
		Name= "I may be sleeping, but I preserve the world.",
		InitCommand= cmd(visible,false),
		OnCommand= cmd(sleep,10000000000000000),
	},
	Def.Quad{
		OnCommand= cmd(diffuse,0,0,0,1;diffusealpha,0;zoomto,6,SCREEN_HEIGHT;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y),
		CytusSpawnMessageCommand= cmd(linear,1;diffusealpha,1),
		CytusEndMessageCommand= cmd(linear,1;diffusealpha,0),
		
		PlayersRot1MessageCommand= function(self)
			if P1 then
			P1:smooth(0.02)
			P1:rotationz(20)
			end
			
			if P2 then
			P2:smooth(0.02)
			P2:rotationz(-20)
			end
		end,

		spawnsomecloneMessageCommand= function(self)
			if P1 then
			wndrP1clone2:visible(true);
			wndrP1clone3:visible(true);

			wndrP1clone2:x(wndrP1clone1:GetX()+0);
			wndrP1clone3:x(wndrP1clone1:GetX()+0);

			wndrP1clone2:y(wndrP1clone1:GetY()+0);
			wndrP1clone3:y(wndrP1clone1:GetY()+0);
			end
			
			if P2 then
			wndrP2clone2:visible(true);
			wndrP2clone3:visible(true);

			wndrP2clone2:x(wndrP2clone1:GetX()+0);
			wndrP2clone3:x(wndrP2clone1:GetX()+0);

			wndrP2clone2:y(wndrP2clone1:GetY()+0);
			wndrP2clone3:y(wndrP2clone1:GetY()+0);
			end
		end,

		rotatetheclonesMessageCommand= function(self)
			if P1 then
			wndrP1clone2:smooth(1.3)
			wndrP1clone3:smooth(1.3)
			wndrP1clone2:rotationz(math.random(-12,12))
			wndrP1clone3:rotationz(math.random(-12,12))
			wndrP1clone2:smooth(0.9)
			wndrP1clone3:smooth(0.9)
			wndrP1clone2:rotationz(0)
			wndrP1clone3:rotationz(0)
			end
			
			if P2 then
			wndrP2clone2:smooth(1.3)
			wndrP2clone3:smooth(1.3)
			wndrP2clone2:rotationz(math.random(-12,12))
			wndrP2clone3:rotationz(math.random(-12,12))
			wndrP2clone2:smooth(0.9)
			wndrP2clone3:smooth(0.9)
			wndrP2clone2:rotationz(0)
			wndrP2clone3:rotationz(0)
			end
		end,

		rotatetheclonesvibrationMessageCommand= function(self)
			if P1 then
			wndrP1clone2:linear(0.02)
			wndrP1clone3:linear(0.02)
			wndrP1clone2:rotationz(math.random(-30,30))
			wndrP1clone3:rotationz(math.random(-30,30))
			wndrP1clone2:linear(0.02)
			wndrP1clone3:linear(0.02)
			wndrP1clone2:rotationz(0)
			wndrP1clone3:rotationz(0)
			wndrP1clone2:linear(0.02)
			wndrP1clone3:linear(0.02)
			wndrP1clone2:rotationz(math.random(-30,30))
			wndrP1clone3:rotationz(math.random(-30,30))
			wndrP1clone2:linear(0.02)
			wndrP1clone3:linear(0.02)
			wndrP1clone2:rotationz(0)
			wndrP1clone3:rotationz(0)
			wndrP1clone2:linear(0.02)
			wndrP1clone3:linear(0.02)
			wndrP1clone2:rotationz(math.random(-30,30))
			wndrP1clone3:rotationz(math.random(-30,30))
			wndrP1clone2:linear(0.02)
			wndrP1clone3:linear(0.02)
			wndrP1clone2:rotationz(0)
			wndrP1clone3:rotationz(0)
			wndrP1clone2:linear(0.02)
			wndrP1clone3:linear(0.02)
			wndrP1clone2:rotationz(math.random(-30,30))
			wndrP1clone3:rotationz(math.random(-30,30))
			wndrP1clone2:linear(0.02)
			wndrP1clone3:linear(0.02)
			wndrP1clone2:rotationz(0)
			wndrP1clone3:rotationz(0)
			end
			
			if P2 then
			wndrP2clone2:linear(0.02)
			wndrP2clone3:linear(0.02)
			wndrP2clone2:rotationz(math.random(-30,30))
			wndrP2clone3:rotationz(math.random(-30,30))
			wndrP2clone2:linear(0.02)
			wndrP2clone3:linear(0.02)
			wndrP2clone2:rotationz(0)
			wndrP2clone3:rotationz(0)
			wndrP2clone2:linear(0.02)
			wndrP2clone3:linear(0.02)
			wndrP2clone2:rotationz(math.random(-30,30))
			wndrP2clone3:rotationz(math.random(-30,30))
			wndrP2clone2:linear(0.02)
			wndrP2clone3:linear(0.02)
			wndrP2clone2:rotationz(0)
			wndrP2clone3:rotationz(0)
			wndrP2clone2:linear(0.02)
			wndrP2clone3:linear(0.02)
			wndrP2clone2:rotationz(math.random(-30,30))
			wndrP2clone3:rotationz(math.random(-30,30))
			wndrP2clone2:linear(0.02)
			wndrP2clone3:linear(0.02)
			wndrP2clone2:rotationz(0)
			wndrP2clone3:rotationz(0)
			wndrP2clone2:linear(0.02)
			wndrP2clone3:linear(0.02)
			wndrP2clone2:rotationz(math.random(-30,30))
			wndrP2clone3:rotationz(math.random(-30,30))
			wndrP2clone2:linear(0.02)
			wndrP2clone3:linear(0.02)
			wndrP2clone2:rotationz(0)
			wndrP2clone3:rotationz(0)
			end
		end,

		playfieldgoneMessageCommand= function(self)
			if P1 then
			SCREENMAN:GetTopScreen():smooth(0.07)
			SCREENMAN:GetTopScreen():y(500)
			P1:y(-500)
			wndrP1clone2:y(-500)
			wndrP1clone3:y(-500)
			end
			
			if P2 then
			P2:y(-500)
			wndrP2clone2:y(-500)
			wndrP2clone3:y(-500)
			end
		end,
		
		PlayersRot2MessageCommand= function(self)
			if P1 then
			P1:smooth(0.02)
			P1:rotationz(-20)
			end
			
			if P2 then
			P2:smooth(0.02)	
			P2:rotationz(20)
			end
		end,
		
		PlayersRot0MessageCommand= function(self)
			if P1 then
			P1:smooth(0.5)
			P1:rotationz(0)
			end
			
			if P2 then
			P2:smooth(0.5)
			P2:rotationz(0)
			end
		end,
		
		PlayersSkew1MessageCommand= function(self)
			if P1 then
			P1:smooth(0.10)
			P1:skewx(wndr_skewx)
			end
			
			--PE:skewx(wndr_skewx)
			
			if P2 then
			P2:smooth(0.10)
			P2:skewx(-wndr_skewx)
			end
		end,
		
		PlayersSkew2MessageCommand= function(self)
			if P1 then
			P1:smooth(0.10)
			P1:skewx(-wndr_skewx)
			end
			
			if P2 then
			P2:smooth(0.10)
			P2:skewx(wndr_skewx)
			end
		end,
		
		PlayersSkew0MessageCommand= function(self)
			if P1 then
			P1:stoptweening()
			P1:linear(0.25)
			P1:skewx(0)
			end
			
			if P2 then
			P2:stoptweening()
			P2:linear(0.25)
			P2:skewx(0)
			end
		end,

		-- Vibration commands
		VibrateMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):vibrate();
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectmagnitude(20,20,20);
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):vibrate();
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectmagnitude(20,20,20);
		end,

		VibratestopMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):stopeffect();
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):stopeffect();
		end,

		BounceMessageCommand= function(self)
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectperiod(1)
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectmagnitude(0,-15,0)
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):wag();
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectperiod(1)
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectmagnitude(0,-15,0)
            SCREENMAN:GetTopScreen():GetChild('PlayerP2'):wag();
        end,

        BounceSomewereElseMessageCommand= function(self)
        	self:sleep(0);
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):bounce();
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectperiod(1)
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectclock('bgm');
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectmagnitude(20,-15,15)
        end,

        BouncestopMessageCommand= function(self)
        	SCREENMAN:GetTopScreen():GetChild('PlayerP1'):stopeffect();
        end,

        SlidestuffoffstopMessageCommand= function(self)
        	SCREENMAN:GetTopScreen():GetChild('PlayerP1'):decelerate(1.4);
        	SCREENMAN:GetTopScreen():GetChild('PlayerP1'):x(-1000);
        	SCREENMAN:GetTopScreen():GetChild('LifeP1'):decelerate(1.4);
            SCREENMAN:GetTopScreen():GetChild('LifeP1'):x(-1000);
            SCREENMAN:GetTopScreen():GetChild('ScoreP1'):decelerate(1.4);
            SCREENMAN:GetTopScreen():GetChild('ScoreP1'):x(-1000);
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Combo'):decelerate(1.4);
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Combo'):x(-1000);
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Judgment'):decelerate(1.4);
            SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Judgment'):x(-1000);
        end,

        DivideClonesMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:addx(250);
				wndrP1clone2:addx(-250);
				wndrP1clone3:Vibrate();
				wndrP1clone4:Vibrate();
			end
		end,

		AndwegoawayMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				P1:smooth(1.25);
				P1:rotationz(1505640);
				P1:zoom(0);
				wndrP1clone2:smooth(1.25);
				wndrP1clone2:rotationz(40);
				wndrP1clone2:zoom(0);
			end
			
			if P2 then
				
				wndrP2clone1:smooth(0.345);
				wndrP2clone1:addy(450);
			end
		end,
		
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		-------------------------------------------------------
		
		
		ClonesSetMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				wndrP1clone1:visible(true);
				wndrP1clone2:visible(true);
				wndrP1clone3:visible(true);
				wndrP1clone4:visible(true);
				
				wndrP1clone2:x(wndrP1clone1:GetX()+64);
				wndrP1clone3:x(wndrP1clone1:GetX()+128);
				wndrP1clone4:x(wndrP1clone1:GetX()+192);
				
				wndrP1clone2:y(wndrP1clone1:GetY()+450);
				wndrP1clone3:y(wndrP1clone1:GetY()+450);
				wndrP1clone4:y(wndrP1clone1:GetY()+450);
			end
			
			if P2 then
				wndrP2clone1:visible(true);
				wndrP2clone2:visible(true);
				wndrP2clone3:visible(true);
				wndrP2clone4:visible(true);
				
				wndrP2clone2:x(wndrP2clone1:GetX()-64);
				wndrP2clone3:x(wndrP2clone1:GetX()-128);
				wndrP2clone4:x(wndrP2clone1:GetX()-192);
				
				wndrP2clone2:y(wndrP2clone1:GetY()+450);
				wndrP2clone3:y(wndrP2clone1:GetY()+450);
				wndrP2clone4:y(wndrP2clone1:GetY()+450);
			end
		end,
		
		DropFirstMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:smooth(0.345);
				wndrP1clone1:addy(450);
				wndrP1clone1:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone1:smooth(0.345);
				wndrP2clone1:addy(450);
				wndrP2clone1:rotationz(20);
			end
		end,
		
		
		FirstJumpMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:sleep(0);
				wndrP1clone1:rotationz(-20);
				wndrP1clone1:smooth(0.345*2);
				wndrP1clone1:addy(-450);
				wndrP1clone1:rotationz(0);
				wndrP1clone1:smooth(0.345*2);
				wndrP1clone1:addy(450);
				wndrP1clone1:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone1:sleep(0);
				wndrP2clone1:rotationz(-20);
				wndrP2clone1:smooth(0.345*2);
				wndrP2clone1:addy(-450);
				wndrP2clone1:rotationz(0);
				wndrP2clone1:smooth(0.345*2);
				wndrP2clone1:addy(450);
				wndrP2clone1:rotationz(20);
			end
		end,
		
		
		SecondJumpMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone2:sleep(0);
				wndrP1clone2:rotationz(-20);
				wndrP1clone2:smooth(0.345*2);
				wndrP1clone2:addy(-450);
				wndrP1clone2:rotationz(0);
				wndrP1clone2:smooth(0.345*2);
				wndrP1clone2:addy(450);
				wndrP1clone2:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone2:sleep(0);
				wndrP2clone2:rotationz(-20);
				wndrP2clone2:smooth(0.345*2);
				wndrP2clone2:addy(-450);
				wndrP2clone2:rotationz(0);
				wndrP2clone2:smooth(0.345*2);
				wndrP2clone2:addy(450);
				wndrP2clone2:rotationz(20);
			end
		end,
		
		ThirdJumpMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone3:sleep(0);
				wndrP1clone3:rotationz(-20);
				wndrP1clone3:smooth(0.345*2);
				wndrP1clone3:addy(-450);
				wndrP1clone3:rotationz(0);
				wndrP1clone3:smooth(0.345*2);
				wndrP1clone3:addy(450);
				wndrP1clone3:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone3:sleep(0);
				wndrP2clone3:rotationz(-20);
				wndrP2clone3:smooth(0.345*2);
				wndrP2clone3:addy(-450);
				wndrP2clone3:rotationz(0);
				wndrP2clone3:smooth(0.345*2);
				wndrP2clone3:addy(450);
				wndrP2clone3:rotationz(20);
			end
		end,
		
		FourthJumpMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone4:sleep(0);
				wndrP1clone4:rotationz(-20);
				wndrP1clone4:smooth(0.345*2);
				wndrP1clone4:addy(-450);
				wndrP1clone4:rotationz(0);
				wndrP1clone4:smooth(0.345*2);
				wndrP1clone4:addy(450);
				wndrP1clone4:rotationz(20);
			end
			
			if P2 then
				
				wndrP2clone4:sleep(0);
				wndrP2clone4:rotationz(-20);
				wndrP2clone4:smooth(0.345*2);
				wndrP2clone4:addy(-450);
				wndrP2clone4:rotationz(0);
				wndrP2clone4:smooth(0.345*2);
				wndrP2clone4:addy(450);
				wndrP2clone4:rotationz(20);
			end
		end,
		
		FourthSetMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone4:sleep(0);
				wndrP1clone4:rotationz(-20);
				wndrP1clone4:smooth(0.345*2);
				wndrP1clone4:x(P1xpos);
				wndrP1clone4:y(P1ypos);
				wndrP1clone4:rotationz(0);
			end
			
			if P1 then
				
				wndrP2clone4:sleep(0);
				wndrP2clone4:rotationz(-20);
				wndrP2clone4:smooth(0.345*2);
				wndrP2clone4:x(P2xpos);
				wndrP2clone4:y(P2ypos);
				wndrP2clone4:rotationz(0);
			end
		end,
		
		HideRestMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:visible(false);
				wndrP1clone2:visible(false);
				wndrP1clone3:visible(false);
			end
			
			if P2 then
				
				wndrP2clone1:visible(false);
				wndrP2clone2:visible(false);
				wndrP2clone3:visible(false);
			end
		end,
		
		------------------------------------------------
		------------------------------------------------
		------------------------------------------------
		----------BRIDGE THING PART MOD THINGY----------
		------------------------------------------------
		------------------------------------------------
		------------------------------------------------
		
		SetRestMessageCommand= function(self)
			self:sleep(0);
			if P1 then
				
				wndrP1clone1:visible(true);
				wndrP1clone1:x(P1xpos);
				wndrP1clone1:y(P1ypos+450);
				wndrP1clone1:rotationz(0);
				
				wndrP1clone2:visible(true);
				wndrP1clone2:x(P1xpos);
				wndrP1clone2:y(P1ypos+450);
				wndrP1clone2:rotationz(0);
				
				wndrP1clone3:visible(true);
				wndrP1clone3:x(P1xpos);
				wndrP1clone3:y(P1ypos+450);
				wndrP1clone3:rotationz(0);
			end
			
			if P2 then
				
				wndrP2clone1:visible(true);
				wndrP2clone1:x(P2xpos);
				wndrP2clone1:y(P2ypos+450);
				wndrP2clone1:rotationz(0);
				
				wndrP2clone2:visible(true);
				wndrP2clone2:x(P2xpos);
				wndrP2clone2:y(P2ypos+450);
				wndrP2clone2:rotationz(0);
				
				wndrP2clone3:visible(true);
				wndrP2clone3:x(P2xpos);
				wndrP2clone3:y(P2ypos+450);
				wndrP2clone3:rotationz(0);
			end
		end,
		
		PopThirdMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone3:zoom(0.9);
				wndrP1clone3:smooth(1);
				wndrP1clone3:x(P1xpos+100);
				wndrP1clone3:y(P1ypos+100);
				wndrP1clone3:rotationz(40);
				wndrP1clone3:sleep(2);
				wndrP1clone3:smooth(1);
				wndrP1clone3:x(P1xpos);
				wndrP1clone3:y(P1ypos+450);
				wndrP1clone3:rotationz(0);
			end
			
			if P2 then
								
				wndrP2clone3:zoom(0.9);
				wndrP2clone3:smooth(1);
				wndrP2clone3:x(P2xpos-100);
				wndrP2clone3:y(P2ypos+100);
				wndrP2clone3:rotationz(-40);
				wndrP2clone3:sleep(2);
				wndrP2clone3:smooth(1);
				wndrP2clone3:x(P2xpos);
				wndrP2clone3:y(P2ypos+450);
				wndrP2clone3:rotationz(0);
			end
		end,
		
		PopSecondMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone2:zoom(0.8);
				wndrP1clone2:smooth(1);
				wndrP1clone2:x(P1xpos-100);
				wndrP1clone2:y(P1ypos+120);
				wndrP1clone2:rotationz(-40);
				wndrP1clone2:sleep(2);
				wndrP1clone2:smooth(1);
				wndrP1clone2:x(P1xpos);
				wndrP1clone2:y(P1ypos+450);
				wndrP1clone2:rotationz(0);
			end
			
			if P2 then
								
				wndrP2clone2:zoom(0.8);
				wndrP2clone2:smooth(1);
				wndrP2clone2:x(P2xpos+100);
				wndrP2clone2:y(P2ypos+120);
				wndrP2clone2:rotationz(40);
				wndrP2clone2:sleep(2);
				wndrP2clone2:smooth(1);
				wndrP2clone2:x(P2xpos);
				wndrP2clone2:y(P2ypos+450);
				wndrP2clone2:rotationz(0);
			end
		end,
		
		PopFirstMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone1:zoom(0.7);
				wndrP1clone1:smooth(1);
				wndrP1clone1:x(P1xpos);
				wndrP1clone1:y(P1ypos+140);
				wndrP1clone1:rotationz(0);
				wndrP1clone1:sleep(2);
				wndrP1clone1:smooth(1);
				wndrP1clone1:x(P1xpos);
				wndrP1clone1:y(P1ypos+450);
				wndrP1clone1:rotationz(0);
			end
			
			if P2 then
								
				wndrP2clone1:zoom(0.7);
				wndrP2clone1:smooth(1);
				wndrP2clone1:x(P2xpos);
				wndrP2clone1:y(P2ypos+140);
				wndrP2clone1:rotationz(0);
				wndrP2clone1:sleep(2);
				wndrP2clone1:smooth(1);
				wndrP2clone1:x(P2xpos);
				wndrP2clone1:y(P2ypos+450);
				wndrP2clone1:rotationz(0);
			end
		end,
		
		
		-------------------------------------------
		-------------------------------------------
		-------------------------------------------
		
		RaiseThirdMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone3:x(P1xpos-130);
				wndrP1clone3:zoom(0.7);
				wndrP1clone3:decelerate(0.5);
				wndrP1clone3:x(P1xpos-130);
				wndrP1clone3:y(P1ypos+100);
				wndrP1clone3:rotationz(0);
			end
			
			if P2 then
				
				wndrP2clone3:x(P2xpos+130);				
				wndrP2clone3:zoom(0.7);
				wndrP2clone3:decelerate(0.5);
				wndrP2clone3:x(P2xpos+130);
				wndrP2clone3:y(P2ypos+100);
				wndrP2clone3:rotationz(0);
			end
		end,
		
		LowerFourthMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone4:smooth(1);
				wndrP1clone4:y(P1ypos+64);
			end
			
			if P2 then
								
				wndrP2clone4:smooth(1);
				wndrP2clone4:y(P2ypos+64);
			end
		end,
		
		LowerBothMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone4:smooth(1);
				wndrP1clone4:y(P1ypos+64+64);
				
				wndrP1clone3:smooth(1);
				wndrP1clone3:y(P1ypos+100+80);
			end
			
			if P2 then
								
				wndrP2clone4:smooth(1);
				wndrP2clone4:y(P2ypos+64+64);
				wndrP2clone3:smooth(1);
				wndrP2clone3:y(P2ypos+100+80);
			end
		end,
		
		LowerBothAgainMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				wndrP1clone4:smooth(1);
				wndrP1clone4:y(P1ypos+64+64+64);
				
				wndrP1clone3:smooth(1);
				wndrP1clone3:y(P1ypos+100+70+70);
			end
			
			if P2 then
								
				wndrP2clone4:smooth(1);
				wndrP2clone4:y(P2ypos+64+64+64);
				wndrP2clone3:smooth(1);
				wndrP2clone3:y(P2ypos+100+70+70);
			end
		end,
		
		
		RaiseSecondMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone2:x(P1xpos+110);
				wndrP1clone2:zoom(0.6);
				wndrP1clone2:decelerate(0.5);
				wndrP1clone2:y(P1ypos+120);
				
			end
			
			if P2 then
				
				wndrP2clone2:x(P2xpos-110);
				wndrP2clone2:zoom(0.6);
				wndrP2clone2:decelerate(0.5);
				wndrP2clone2:y(P2ypos+120);
			end
		end,
		
		RaiseAllMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone2:smooth(0.7);
				wndrP1clone2:y(P1ypos+120-64);
				
				wndrP1clone3:smooth(0.7);
				wndrP1clone3:y(P1ypos+64);
				
				wndrP1clone4:smooth(0.7);
				wndrP1clone4:y(P1ypos);
				
				
			end
			
			if P2 then
				
				wndrP2clone2:smooth(0.7);
				wndrP2clone2:y(P2ypos+120-64);
				
				wndrP2clone3:smooth(0.7);
				wndrP2clone3:y(P2ypos+64);
				
				wndrP2clone4:smooth(0.7);
				wndrP2clone4:y(P2ypos);
			end
		end,
		
		LowerAllMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone2:smooth(0.7);
				wndrP1clone2:y(P1ypos+120);
				
				wndrP1clone3:smooth(0.7);
				wndrP1clone3:y(P1ypos+100+70);
				
				wndrP1clone4:smooth(0.7);
				wndrP1clone4:y(P1ypos+64);
				
				
			end
			
			if P2 then
				
				wndrP2clone2:smooth(0.7);
				wndrP2clone2:y(P2ypos+120);
				
				wndrP2clone3:smooth(0.7);
				wndrP2clone3:y(P2ypos+100+70);
				
				wndrP2clone4:smooth(0.7);
				wndrP2clone4:y(P2ypos+64);
			end
		end,
		
		FlyAwayMessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone2:smooth(1);
				wndrP1clone2:y(P1ypos-500);
				
				wndrP1clone3:smooth(1);
				wndrP1clone3:y(P1ypos-500);
				
				wndrP1clone4:smooth(0.5);
				wndrP1clone4:y(P1ypos);
				
				
			end
			
			if P2 then
				
				wndrP2clone2:smooth(1);
				wndrP2clone2:y(P2ypos-500);
				
				wndrP2clone3:smooth(1);
				wndrP2clone3:y(P2ypos-500);
				
				wndrP2clone4:smooth(0.5);
				wndrP2clone4:y(P2ypos);
			end
		end,
		
		Hide123MessageCommand= function(self)
			self:sleep(0);
			if P1 then
					
				wndrP1clone1:visible(false);
				wndrP1clone2:visible(false);
				wndrP1clone3:visible(false);

			end
			
			if P2 then
				
				wndrP2clone1:visible(false);
				wndrP2clone2:visible(false);
				wndrP2clone3:visible(false);
			end
		end,
		
----------------------------------------
	
	WagPlayersMessageCommand= function(self)
			self:sleep(0);
			if P1 then
								
				P1:wag();
				P1:effectclock('bgm');
				P1:effectmagnitude(0,0,30);
				P1:effectperiod(2);
			end
			
			if P2 then
								
				P2:wag();
				P2:effectclock('bgm');
				P2:effectmagnitude(0,0,-30);
				P2:effectperiod(2);
			end
		end,
	},
	
	--------------------------------------------------------
	--------------------------------------------------------
	--------------------------------------------------------
	-------------HERE LIES THE ACTOR PROXIES----------------
	--------------------------------------------------------
	--------------------------------------------------------
	--------------------------------------------------------
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone1=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone2=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone3=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP1clone4=self;
			
		end;
	};
	
	
	------
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone1=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone2=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone3=self;
			
		end;
	};
	
	Def.ActorProxy{
		BeginCommand=function(self)
			
			wndrP2clone4=self;
			
		end;
	};
	
}